PRINT N'Modificando Procedimiento [dbo].[BulkAsyncInteraction]...';


GO
 ALTER PROCEDURE [dbo].[BulkAsyncInteraction]
AS
BEGIN
	-- ESTE SP INSERTA REGISTROS UNICOS DE ASYNCINTERACTION PROVENIENTES DE LA BD EXTERNA EN LA TABLA ASYNCINTERACTION Y PROCESSASYNCINTERACTION

	--
	INSERT INTO [dbo].[AsyncInteraction] (
		[VCC], [ID], [Folder], [ExportedContent], [Channel]
		, [Campaign], [StartDate], [EndDate], [Account], [Initiative]
		, [ContactName], [FirstTakedAgent], [LastTakedAgent], [FirstTakedAgentName], [LastTakedAgentName]
		, [IsTaken], [TotalMessages], [DurationTime], [AttentionTime], [DispositionCode]
		, [DispositionTreePath], [RawChar], [CreatedDate], [CreatedByUserId], [TimeStamp] 
		, [ContactId], [ContactAddress], [NeedI6Update]
	)
		-- SELECCIONAMOS TODOS LOS REGISTROS DE LA TABLA TEMPORAL [#AsyncInteractionTemp] QUE NO EXISTEN EN [AsyncInteraction] POR LOS PK
		SELECT AIT.[VCC], AIT.[ID], AIT.[Folder], AIT.[ExportedContent], AIT.[Channel]
				, AIT.[Campaign], AIT.[StartDate], AIT.[EndDate], AIT.[Account], AIT.[Initiative]
				, AIT.[ContactName], AIT.[FirstTakedAgent], AIT.[LastTakedAgent], A1.[Name], A2.[Name]
				, AIT.[IsTaken], AIT.[TotalMessages], AIT.[DurationTime], AIT.[AttentionTime], AIT.[DispositionCode]
				, AIT.[DispositionTreePath], AIT.[RawChar], AIT.[CreatedDate], AIT.[CreatedByUserId], GETUTCDATE()
				, AIT.[ContactId], AIT.[contactAddress], 1
			FROM [#AsyncInteractionTemp] AIT
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = AIT.[VCC]
					AND AI.[ID] = AIT.[ID]
					AND CONVERT(VARCHAR, AI.[EndDate], 23) = AIT.[Folder]
			LEFT JOIN [dbo].[Agent] A1 (NOLOCK)
				ON A1.[VCC] = AIT.[VCC]
					AND A1.[AgentId] = AIT.[FirstTakedAgent]
			LEFT JOIN [dbo].[Agent] A2 (NOLOCK)
				ON A2.[VCC] = AIT.[VCC]
					AND A2.[AgentId] = AIT.[LastTakedAgent]
			WHERE AI.[ID] IS NULL

	--
	INSERT INTO [dbo].[ProcessAsyncInteraction] (
		[VCC], [ProcessId], [InteractionType], [Campaign], [InteractionId]
		, [EndDate], [FormattedEndDate], [CreatedDate], [CreatedByUserId], [LastModifiedDate]
		, [LastModifiedByUserId], [TimeStamp]
	)
		-- SELECCIONAMOS TODOS LOS REGISTROS DE LA TABLA TEMPORAL [#ProcessAsyncInteractionTemp] QUE NO EXISTEN EN [ProcessAsyncInteraction] POR LOS PK
		SELECT PAIT.[VCC], PAIT.[ProcessId], PAIT.[InteractionType], PAIT.[Campaign], PAIT.[InteractionId] 
				, PAIT.[EndDate], PAIT.[FormattedEndDate], PAIT.[CreatedDate], PAIT.[CreatedByUserId], PAIT.[LastModifiedDate]
				, PAIT.[LastModifiedByUserId], GETUTCDATE()
			FROM [#ProcessAsyncInteractionTemp] PAIT
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = PAIT.[VCC]
					AND PAI.[ProcessId] = PAIT.[ProcessId]
					AND PAI.[InteractionType] = PAIT.[InteractionType]
					AND PAI.[InteractionId] = PAIT.[InteractionId]
					--AND PAI.[EndDate] = PAIT.[EndDate]
					AND PAI.[FormattedEndDate] = PAIT.[FormattedEndDate]
			WHERE PAI.[InteractionId] IS NULL
	
	-- ELIMINAMOS LAS TABLAS TEMPORALES
	DROP TABLE [#AsyncInteractionTemp]
	DROP TABLE [#ProcessAsyncInteractionTemp]
END
GO
PRINT N'Modificando Procedimiento [dbo].[BulkAudio]...';


GO
ALTER PROCEDURE [dbo].[BulkAudio]
AS
BEGIN
	-- DECLARAMOS UNA VARIABLE PARA DEFINIR EL VCC
	DECLARE @VCC VARCHAR(50) = NULL
	DECLARE @VCC_TYPE VARCHAR(50) = NULL

	-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL VCC
	SELECT TOP 1 @VCC = [VCC] FROM #AudioTemp (NOLOCK)

	-- BUSCAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC

	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	;WITH CTE AS (
		SELECT A.[VCC], A.[ID], A.[Section], A.[Part], A.[Number],
				A.[Gender], A.[SilenceTime], A.[DurationTime], A.[Category1], A.[Category2],
				A.[Category3], A.[Description], A.[Campaign], A.[Agent], ISNULL(A.[AgentName], AG.[Name]) 'AgentName',
				A.[Type], A.[Init], A.[StartDate], A.[EndDate], A.[DispositionCode], 
				A.[RelativePath], A.[FileName], A.[CreatedDate], A.[CreatedByUserId], A.[LastModifiedDate], 
				A.[LastModifiedByUserId], A.[ContactId], A.[ContactName], A.[ContactAddress], A.[NeedI6Update], 
				RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC], A.[ID], A.[Section], A.[Part] ORDER BY A.[ID])
			FROM #AudioTemp A (NOLOCK)
			LEFT JOIN [dbo].[Agent] AG (NOLOCK)
				ON AG.[VCC] = A.[VCC]
					AND AG.[AgentId] = A.[Agent]
	)
	-- LA TABLA TEMPORAL #AudioTemp LLEGA CON ALGUNOS REGISTROS DUPLICADOS DEBIDO A LOS CRUCES AL APLICAR LOR FILTROS, POR ELLO DEBEMOS 
	-- IDENTIFICAR LOS REPETIDOS, RN = ROW_NUMBER() OVER(PARTITION BY ...) <- NUMERA CADA REGISTRO SEGUN EL(LOS) VALOR(ES) DE ...

	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE WHERE RN > 1
	

	INSERT INTO dbo.Audio(
			[VCC]
			,[ID]
			,[Section]
			,[Part]
			,[Number]
			,[Gender]
			,[SilenceTime]
			,[DurationTime]
			,[Category1]
			,[Category2]
			,[Category3]
			,[Description]
			,[Campaign]
			,[Agent]
			,[AgentName]
			,[Type]
			,[Init]
			,[NeedI6Update]
			,[StartDate]
			,[EndDate]
			,[DispositionCode]
			,[RelativePath]
			,[FileName]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			,[ContactId]			
			,[ContactName]
			,[ContactAddress]
			) 
		SELECT
			 A.[VCC]
			,A.[ID]
			,A.[Section]
			,A.[Part]
			,A.[Number]
			,A.[Gender]
			,A.[SilenceTime]
			,A.[DurationTime]
			,A.[Category1]
			,A.[Category2]
			,A.[Category3]
			,A.[Description]
			,A.[Campaign]
			,A.[Agent]
			,A.[AgentName]
			,A.[Type]
			,A.[Init]
			,A.[NeedI6Update]
			,A.[StartDate]
			,A.[EndDate]
			,A.[DispositionCode]
			,A.[RelativePath]
			,A.[FileName]
			,A.[CreatedDate]
			,A.[CreatedByUserId]
			,A.[LastModifiedDate]
			,A.[LastModifiedByUserId]
			,GETUTCDATE()
			,A.[ContactId]		
			,A.[ContactName]
			,A.[ContactAddress]
		FROM CTE A (NOLOCK)
		WHERE A.RN = 1
			AND NOT EXISTS (
				SELECT * 
					FROM Audio B (NOLOCK)
					WHERE B.[VCC] = A.[VCC]
						AND B.[ID] = A.[ID]
						AND B.[Section] = A.[Section]
						AND B.[Part] = A.[Part]
			)

	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	;WITH CTE_PAT AS (
	   SELECT PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part]
			,PAT.[CreatedDate], PAT.[CreatedByUserId], PAT.[LastModifiedDate], PAT.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part] ORDER BY PAT.[AudioId])
	   FROM #ProcessAudioTemp PAT (NOLOCK)
	)
	-- EL CTE_PAT SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE_PAT WHERE RN > 1
		
	-- Insertamos registros en la tabla ProcessAudio
	INSERT INTO dbo.ProcessAudio
			([VCC]
			,[ProcessId]
			,[AudioId]
			,[Section]
			,[Part]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,GETUTCDATE()
		FROM CTE_PAT PAT (NOLOCK)
		WHERE PAT.RN = 1
			AND NOT EXISTS (
			SELECT * FROM ProcessAudio PA (NOLOCK)
			WHERE PA.[VCC] = PAT.[VCC]
			AND PA.[ProcessId] = PAT.[ProcessId]
			AND PA.[AudioId] = PAT.[AudioId]
			AND PA.[Section] = PAT.[Section]
			AND PA.[Part] = PAT.[Part]
		)
		GROUP BY 
			PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]

		DROP TABLE #AudioTemp
		DROP TABLE #ProcessAudioTemp

END
GO
PRINT N'Modificando Procedimiento [dbo].[BulkInteractionEvaluationPlan]...';


GO
 ALTER PROCEDURE [dbo].[BulkInteractionEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[AgentName], [IdCampaign], [IdInteraction], 
			[FormattedEndDate], [InteractionSection], [InteractionPart], 
			[InteractionDateStart], [InteractionDateEnd], [InteractionType], 
			[InteractionMessages], [InteractionDuration], [InteractionOrigin], 
			[ManagementResult], [RelativePath], [FileName],
			[ContactId], [ContactAddress], [ContactName], 
			[InteractionFormat], [NeedI6Update],
			[CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT IEP.[VCC], IEP.[IdEvaluationPlan], IEP.[IdAgent],
				IEP.[AgentName], IEP.[IdCampaign], IEP.[IdInteraction], 
				IEP.[InteractionFolder], IEP.[InteractionSection], IEP.[InteractionPart], 
				IEP.[InteractionDateStart], IEP.[InteractionDateEnd], IEP.[InteractionType], 
				IEP.[TotalMessages], IEP.[InteractionDuration], IEP.[InteractionOrigin], 
				IEP.[InteractionManagementResult], IEP.[RelativePath], IEP.[FileName],
				IEP.[InteractionContactId], IEP.[InteractionContactAddress], IEP.[InteractionContactName],
				IEP.[InteractionFormat], IEP.[NeedI6Update],
				IEP.[CreatedByUserId], GETUTCDATE(), GETUTCDATE()
			FROM [#InteractionEvaluationPlanTemp] IEP (NOLOCK)
			/*
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = IEP.[VCC]
					AND A.[AgentId] = IEP.[IdAgent]
			*/

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#InteractionEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[DeleteI6InteractionAudio]...';


GO
ALTER PROCEDURE [dbo].[DeleteI6InteractionAudio] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Section				INT = NULL,
	@Part					INT = NULL
) AS 
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION
		
		-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA AUDIO
		DELETE FROM [dbo].[Audio] 
			WHERE [VCC] = @VCC
				AND [ID] = @InteractionId
				AND [Section] = @Section
				AND [Part] = @Part

		-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA PROCESSAUDIO
		DELETE FROM [dbo].[ProcessAudio]
			WHERE [VCC] = @VCC
				AND [AudioId] = @InteractionId
				AND [Section] = @Section
				AND [Part] = @Part 

		-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA INTERACTIONEVALUATIONPLAN
		DELETE FROM [dbo].[InteractionEvaluationPlan] 
			WHERE [Instance] = @VCC
				AND [IdInteraction] = @InteractionId
				AND [InteractionSection] = @Section
				AND [InteractionPart] = @Part 

		/*
		-- ELIMINAMOS LA INTERACCION DE LA TABLA AUSITOREVALUATIONPLAN
		DELETE FROM [dbo].[AuditorEvaluationPlan]
			WHERE [Instance] = @VCC
				AND [IdInteraction] = @InteractionId
		*/

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetBillingInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetBillingInteractions] (
	@VCC					VARCHAR(50) = NULL,
	@SecondsPerRequest		DECIMAL(18, 5) = 0,
	@CharsPerPhrase			DECIMAL(18, 5) = 0,
	@Channel				VARCHAR(25) = NULL,
	@Retranscription		BIT = 0
	
)
AS
BEGIN
	
	-- SEGUN EL TIPO DE CANAL DEFINIMOS LA FUNCION
	IF @Channel = 'CALL'
	BEGIN
		-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
		DECLARE @VCC_TYPE VARCHAR(50) = ''
		
		-- RECUPERAMOS EL TIPO DE VCC
		SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC

		-- CREAMOS UNA TEMPORAL PARA AUDIO CON SU DEFINICION
		CREATE TABLE #INNER_AUDIO (
			[VCC] VARCHAR(50),
			[ID] VARCHAR(100),
			[Section] NUMERIC(5,0),
			[Part] NUMERIC(5,0), 
			[DurationTime] NUMERIC(12,0), 
			[TotalPhrases] INT,
			[IsProcess] BIT,
			[IsTranscribed] BIT,
			[IsCancel] BIT
		)
		
		-- SEGUN EL TIPO DE VCC COMPLETAMOS EL FROM
		IF @VCC_TYPE <> 'I6' -- I6
		BEGIN
			--OBTENEMOS TODOS AUDIOS RELACIONADOS A LA BUSQUEDA
			INSERT INTO #INNER_AUDIO
				SELECT DISTINCT A.[VCC],
								A.[ID],
								A.[Section],
								A.[Part],
								A.[DurationTime],
								A.[TotalPhrases],
								A.[IsProcess],
								A.[IsTranscribed],
								A.[IsCancel]
					FROM [dbo].[Audio] A (NOLOCK)
					WHERE A.[VCC] = @VCC
		END
		ELSE
	    BEGIN
			-- GENERAMOS EL 1ER RESUMEN DE AUDIOS
			;WITH CTE_AUDIO AS (
				SELECT DISTINCT A.[VCC],
								A.[ID],
								A.[Section],
								A.[Part],
								A.[DurationTime],
								A.[TotalPhrases],
								A.[IsProcess],
								A.[IsTranscribed],
								A.[IsCancel],
								RN = ROW_NUMBER() OVER(PARTITION BY A.[ID] ORDER BY A.[EndDate] DESC)
					FROM [dbo].[Audio] A (NOLOCK)
					WHERE A.[VCC] = @VCC
			)

			--OBTENEMOS TODOS AUDIOS RELACIONADOS A LA BUSQUEDA
			INSERT INTO #INNER_AUDIO
				SELECT CTE.[VCC],
						CTE.[ID],
						CTE.[Section],
						CTE.[Part],
						CTE.[DurationTime],
						CTE.[TotalPhrases],
						CTE.[IsProcess],
						CTE.[IsTranscribed],
						CTE.[IsCancel] 
					FROM CTE_AUDIO CTE
					WHERE CTE.[RN] = 1
				
		END
		
		-- HACEMOS LA BUSQUEDA
		SELECT SUM(CASE WHEN A.[IsTranscribed] = 1 
								AND @Retranscription = 0 
							THEN 1 ELSE 0 END)															'alreadyTranscribedAudio',
				SUM(CASE WHEN A.[IsTranscribed] = 1 
								AND @Retranscription = 0 
							THEN A.[DurationTime] ELSE 0 END)											'alreadyTranscribedDurationTime',
				SUM(CASE WHEN (A.[IsProcess] = 1 
								AND A.[IsTranscribed] IS NULL 
								AND A.[IsCancel] IS NULL) 
							THEN 1 ELSE 0 END)															'inProcessAudio',
				SUM(CASE WHEN (A.[IsProcess] = 1 
								AND A.[IsTranscribed] IS NULL 
								AND A.[IsCancel] IS NULL) 
							THEN A.[DurationTime] ELSE 0 END)											'inProcessDurationTime',
				'CALL'																				'interactionType',
				SUM(CASE WHEN (
					A.[IsProcess] IS NULL 
					OR
					@Retranscription = 1
					OR 
					(
						A.[IsProcess] = 1 
						AND 
						A.[IsCancel] = 1
					)
				) THEN 1 ELSE 0 END)																	'notTranscribedAudio',
				SUM(CASE WHEN (
					A.[IsProcess] IS NULL 
					OR
					@Retranscription = 1
					OR (
						A.[IsProcess] = 1 
						AND 
						A.[IsCancel] = 1
					)
				) THEN A.[DurationTime] ELSE 0 END)														'notTranscribedDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1  
								AND A.[TotalPhrases] IS NOT NULL
							THEN A.[TotalPhrases] ELSE 0 END)											'totalPhrases',
				SUM(CASE WHEN (A.[IsProcess] IS NULL 
								OR (A.[IsProcess] = 1 
									AND A.[IsCancel] = 1)
								OR (A.[TotalPhrases] IS NULL)) 
							THEN (IT.[AttentionTime] / @SecondsPerRequest) ELSE 0 END)					'totalRawPhrases',
				SUM(IT.[AttentionTime] / @SecondsPerRequest)											'averageModelRequest' 
			FROM [#InteractionsTemp] IT
			INNER JOIN [dbo].[VCC] V (NOLOCK)
				ON V.[VCC] = IT.[VCC]
			LEFT JOIN [#INNER_AUDIO] A 
				ON A.[VCC] = IT.[VCC]
					AND  A.[ID] = IT.[InteractionId]
					AND (
						(
							V.[Type] <> 'I6'
							AND 
							A.[Section] = IT.[Section]
							AND 
							A.[Part] = IT.[Part]
						)
						OR 
						(
							V.[Type] = 'I6'
						)
					)
			WHERE IT.[VCC] = @VCC

		-- ELIMINAMOS LA TABLA TEMPORAL
		DROP TABLE IF EXISTS #INNER_AUDIO
	END
	ELSE
	BEGIN
		-- DECLARAMOS UNA VARIABLE PARA PARA EL TOTALDE RESULTADOS
		DECLARE @TOTAL_INTERACTIONS INT = 0

		-- SETTEAMOS EL NUMERO DE REGISTROS A LA VARIABLE DE TOTAL
		SELECT @TOTAL_INTERACTIONS = COUNT(*) FROM [#InteractionsTemp]

		IF @TOTAL_INTERACTIONS = 0 
		BEGIN
			-- SI NO EXISTEN RESULTADOS EN HD LLENAMOSUN RESULTADOS CON 0
			SELECT @Channel																					'interactionType',
					0																						'totalInteractionDetails',
					0																						'alreadyTranscribedInteraction',
					0																						'inProcessInteraction',
					0																						'notTranscribedInteraction',
					0																						'totalPhrases',
					0																						'totalRawChars',
					0																						'totalRawPhrases'
		END 
		ELSE
		BEGIN
			-- CRUZAMOS LA TABLA TEMPORAL DE INTERACCIONES ASINCRONAS CON LA TABLA LOCAL INTERACTION PARA LAS INTERACCIONES ASINCRONAS YA REGISTRADAS
			SELECT ISNULL(IT.[Channel], @Channel)															'interactionType',
					COUNT(*)																				'totalInteractionDetails',
					SUM(CASE WHEN (AI.[VCC] IS NOT NULL 
						AND AI.[IsTranscribed] = 1) THEN 1 ELSE 0 END)										'alreadyTranscribedInteraction',
					0																						'inProcessInteraction',
					SUM(CASE WHEN (AI.[VCC] IS NULL 
						OR AI.[IsTranscribed] <> 1) THEN 1 ELSE 0 END)										'notTranscribedInteraction',
					SUM(ISNULL(AI.[TotalPhrases], 0))														'totalPhrases',
					-- CUANDO TENEMOS VALIDPHRASES, YA NO CONTAMOS LAS RAWCHAR 
					SUM(
						CASE WHEN (AI.[TotalPhrases] IS NULL 
								OR AI.[TotalPhrases] = 0)
						THEN (
							ISNULL(AI.[RawChar], ISNULL(IT.[rawChar], 0))
						)
						ELSE 0 END
					)																						'totalRawChars',
					SUM(
						CASE WHEN (AI.[TotalPhrases] IS NULL 
								OR AI.[TotalPhrases] = 0)
						THEN (
							-- SI RAWCHAR ES NULL, SE DEBE VALUAR COMO MINIMO 1 FRASE(@CharsPerPhrase)
							-- CEILING(ISNULL(AI.[RawChar], ISNULL(HDI.[rawChar], @CharsPerPhrase)) * 1.00 / @CharsPerPhrase)
							CEILING(ISNULL(AI.[RawChar], ISNULL(IT.[RawChar], 0)) * 1.00 / @CharsPerPhrase)
						)
						ELSE 0 END
					)																						'totalRawPhrases' 
				FROM [#InteractionsTemp] IT
				LEFT JOIN [dbo].[AsyncInteraction] AI 
					ON IT.[VCC] = AI.[VCC]
						AND IT.[Channel] = AI.[Channel]
						--AND IT.[Campaign] = AI.[Campaign]
						AND IT.[InteractionId] = AI.[ID]
						AND IT.[EndDate] = AI.[EndDate]
					--WHERE AI.[VCC] = @VCC
				GROUP BY IT.[VCC],
							IT.[Channel]

		END
	END

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [#InteractionsTemp] 
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetI6InteractionAudios]...';


GO
ALTER PROCEDURE [dbo].[GetI6InteractionAudios] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL
) AS 
BEGIN
	-- RETORNAMOS LOS REGISTROS DE AMBAS TABLAS
	;WITH CTE_ALL_RECORDS AS (
		-- BUSCAMOS LOS AUDIOS DE LA INTERACCION
		SELECT DISTINCT [ID]									'id',
						[Section]								'section',
						[Part]									'part',
						[Agent]									'agentId',
						[Format]								'format'
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
		UNION
		SELECT DISTINCT [IdInteraction]							'id',
						[InteractionSection]					'section',
						[InteractionPart]						'part',
						[IdAgent]								'agentId',
						[InteractionFormat]						'format'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
	),
	CTE_SUMMARY AS (
		SELECT *,
				RN = ROW_NUMBER() OVER(PARTITION BY CTE_AR.[id],
													CTE_AR.[section],
													CTE_AR.[part]
											ORDER BY CTE_AR.[id] ASC, 
													CTE_AR.[section] ASC,
													CTE_AR.[part] ASC,
													CTE_AR.[agentId] DESC,
													CTE_AR.[format] DESC
										) 
			 FROM CTE_ALL_RECORDS CTE_AR
	)
		SELECT CTE_S.[id], 
				CTE_S.[section],
				CTE_S.[part],
				CTE_S.[agentId],
				CTE_S.[format] 
			FROM CTE_SUMMARY CTE_S
			WHERE RN = 1

	/*
	-- DECLARAMOS VARIABLES PARA ALMACENAR LAS CANTIDADES DE REGISTROS
	DECLARE @AUDIO_RECORDS INT = 0
	DECLARE @INTERACION_EVALUATION_PLAN_RECORDS INT = 0

	SELECT @AUDIO_RECORDS = COUNT(*)
		FROM [dbo].[Audio] A (NOLOCK)
		WHERE A.[VCC] = @VCC
			AND A.[ID] = @InteractionId
			AND A.[NeedI6Update] = 0

	SELECT @INTERACION_EVALUATION_PLAN_RECORDS = COUNT(DISTINCT CONCAT(IEP.[IdInteraction], '_', IEP.[InteractionSection], '_', IEP.[InteractionPart]))
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE IEP.[Instance] = @VCC	
			AND IEP.[IdInteraction] = @InteractionId
			AND IEP.[NeedI6Update] = 0

	IF @AUDIO_RECORDS >= @INTERACION_EVALUATION_PLAN_RECORDS
	BEGIN

		-- BUSCAMOS LOS AUDIOS DE LA INTERACCION
		SELECT DISTINCT [ID]									'id',
						[Section]								'section',
						[Part]									'part',
						[Agent]									'agentId',
						[Format]								'format'
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
				AND A.[NeedI6Update] = 0
			ORDER BY A.[Section] ASC,  A.[Part] ASC
	END
	ELSE
	BEGIN
		SELECT DISTINCT [IdInteraction]							'id',
						[InteractionSection]					'section',
						[InteractionPart]						'part',
						[IdAgent]								'agentId',
						[InteractionFormat]						'format'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
				AND IEP.[NeedI6Update] = 0
			ORDER by IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC
	END
	*/
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetInteractionTranscription]...';


GO
-- ESTE SP RETORN LAS TRANSCRIPCIONES DE UNA INTERACCION SEGUN SU VCC, INTERACTIONTYPE(CHANNEL), INTERACTIONID
ALTER PROCEDURE [dbo].[GetInteractionTranscription] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = null,
	@ProcessId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- SI PROCESSID IS NULL RETORNA TODAS LAS TRANSCRIPCIONES DEL ID
	-- SI PROCESSID IS NOT NULL RETORNA TOADAS LAS TRANSCRIPCIONES DE ID RELACIONADAS CON EL PROCESSASYNCINTERACTION

	-- AGREGAMOS LA BUSQUEDA PARA CANALES DE TEXTO
	IF @InteractionType <> 'CALL'
	BEGIN
		-- PARA EL CASO QUE PLAN DE EVALUACION ID ES NULL
		IF @EvaluationPlanId IS NULL
		BEGIN 
			SELECT DISTINCT AI.[VCC]									'vcc',
							AI.[Campaign]								'campaign',
							AI.[Channel]								'interactionType',
							AI.[ID]										'id',
							AI.[ID]										'interactionId',
							AI.[Folder]									'folder',
							AI.[FileName]								'jsonFileName',
							AI.[ViewFileName]							'viewFileName',
							P.[Name]									'processId',
							AI.[TotalMessages]							'totalMessages',
							AI.[NeedI6Update]							'needI6Update'
				FROM [dbo].[AsyncInteraction] AI (NOLOCK)
				LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
					ON PAI.[VCC] = AI.[VCC]
						AND PAI.[Campaign] = AI.[Campaign]
						AND PAI.[InteractionType] = AI.[Channel]
						AND PAI.[FormattedEndDate] = AI.[Folder]
						AND PAI.[InteractionId] = AI.[ID]
						AND PAI.[ProcessId] = @ProcessId
				LEFT JOIN [dbo].[Process] P (NOLOCK)
					ON P.[VCC] = AI.[VCC]
						AND P.[Name] = PAI.[ProcessId]
				WHERE AI.[VCC] = @VCC
					AND AI.[Channel] = @InteractionType
					AND AI.[ID] = @InteractionId
					AND AI.[IsTranscribed] = 1
					AND (
						(@ProcessId IS NOT NULL AND PAI.[ProcessId] IS NOT NULL)
						OR
						(@ProcessId IS NULL AND PAI.[ProcessId] IS NULL)	
					)
				ORDER BY AI.[Folder] ASC

		END
		ELSE
		BEGIN
			SELECT IEP.[Instance]										'vcc',
					IEP.[IdCampaign]									'campaign',
					IEP.[InteractionType]								'interactionType',
					IEP.[IdInteraction]									'id',
					IEP.[IdInteraction]									'interactionId',
					IEP.[FormattedEndDate]								'folder',
					AI.[FileName]										'jsonFileName',
					AI.[ViewFileName]									'viewFileName',
					EP.[ProcessId]										'processId',
					IEP.[InteractionMessages]							'totalMessages',
					IEP.[NeedI6Update]									'needI6Update'
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
					ON EP.[Instance] = IEP.[Instance]
						AND EP.[ID] = IEP.[IdEvaluationPlan]
				LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
					ON PAI.[VCC] = IEP.[Instance]
						AND PAI.[Campaign] = IEP.[IdCampaign]
						AND PAI.[InteractionType] = IEP.[InteractionType]
						AND PAI.[FormattedEndDate] = IEP.[FormattedEndDate]
						AND PAI.[InteractionId] = IEP.[IdInteraction]
						AND PAI.[ProcessId] = EP.[ProcessId]
				LEFT JOIN [dbo].[Process] P (NOLOCK)
					ON P.[VCC] = IEP.[Instance]
						AND P.[Name] = EP.[ProcessId]
				LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
					ON AI.[VCC] = IEP.[Instance]
						AND AI.[Campaign] = PAI.[Campaign]
						AND AI.[Channel] = PAI.[InteractionType] 
						AND AI.[Folder] = PAI.[FormattedEndDate]
						AND AI.[ID] = PAI.[InteractionId]
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
					AND IEP.[InteractionType] = @InteractionType
					AND IEP.[IdInteraction] = @InteractionId 
		END
	END
	ELSE 
	BEGIN
		-- PARTE OPCIONAL PARA INTERACCIONES CALL, AUN NO IMPLEMENTADO
		DECLARE @ID VARCHAR(50) = ''
		IF EXISTS (
			SELECT 1 
				FROM [dbo].[Audio] A (NOLOCK)
				WHERE A.[VCC] = 'occ_test'--@VCC 
					AND (
						(CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = '{23c5b766-4d29-11ea-b486-a4420ef40d06}_0_1')
						OR
						(A.[ID] = '{23c5b766-4d29-11ea-b486-a4420ef40d06}_0_1')
					)
		) 
		BEGIN
			SET @ID = (
						SELECT TOP 1 A.[ID]
							FROM [dbo].[Audio] A (NOLOCK)
								WHERE A.[VCC] = 'occ_test'--@VCC 
									AND (
										(CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = '{23c5b766-4d29-11ea-b486-a4420ef40d06}_0_1')
										OR
										(A.[ID] = '{23c5b766-4d29-11ea-b486-a4420ef40d06}_0_1')
									)
						)

			SELECT *
				FROM [dbo].[Audio] A (NOLOCK)
				WHERE A.[VCC] = 'occ_test'--@VCC 
					AND A.[ID] = @ID
		END

		SELECT 'SOON...'

	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetProcessI6InteractionsToUpdate]...';


GO
 ALTER PROCEDURE [dbo].[GetProcessI6InteractionsToUpdate] (
	@VCC VARCHAR(50) = NULL, 
	@ProcessId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	/*
	IF OBJECT_ID(N'tempdb..#I6_INTERACTIONS_TO_UPDATE') IS NOT NULL
	BEGIN
		DROP TABLE #I6_INTERACTIONS_TO_UPDATE
	END
	ELSE 
	BEGIN
		CREATE TABLE #I6_INTERACTIONS_TO_UPDATE(
			InteractionId VARCHAR(250)
		)
	END
	*/

	-- SELECCIONAMOS LOS ID DE INTERACIONES QUE TIENEN AUDIOS QUE REQUIEREN ACTUALIZACION DE I6
	-- INSERT INTO #I6_INTERACTIONS_TO_UPDATE
		SELECT PA.[VCC]								'vcc',
				PA.[ProcessId]						'processId',
				'CALL'								'interactionType',
				A.[ID]								'id',
				P.[Language]						'language',
				A.[NeedI6Update]					'needI6Update'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			INNER JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			INNER JOIN [dbo].[Process] P (NOLOCK)
				ON P.[Name] = PA.[ProcessId]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				AND A.[NeedI6Update] = 1
				AND (
					(
						ISNULL(A.[IsProcess], 0) = 0				
						AND 
						ISNULL(A.[IsTranscribed], 0) = 0
					)											-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
					OR 
					(
						A.[IsProcess] = 1						
						AND 
						A.[IsCancel] = 1
					)
				)												-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
			GROUP BY PA.[VCC], PA.[ProcessId], A.[ID], P.[Language], A.[NeedI6Update]
		UNION
		SELECT PAI.[VCC]							'vcc',
				PAI.[ProcessId]						'processId',
				AI.[Channel]						'interactionType',
				AI.[ID]								'id',
				P.[Language]						'language',
				AI.[NeedI6Update]					'needI6Update'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					AND AI.[ID] = PAI.[InteractionId]
			INNER JOIN [dbo].[Process] P (NOLOCK)
				ON P.[Name] = PAI.[ProcessId]
			WHERE PAI.[VCC] = @VCC 
				AND PAI.[ProcessId] = @ProcessId
				AND AI.[NeedI6Update] = 1
				AND (
					(
						ISNULL(AI.[IsProcess], 0) = 0				
						AND 
						ISNULL(AI.[IsTranscribed], 0) = 0
					)											-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
					OR 
					(
						AI.[IsProcess] = 1						
						AND 
						AI.[IsCancel] = 1
					)
				)												-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
			GROUP BY PAI.[VCC], PAI.[ProcessId], AI.[Channel], AI.[ID], P.[Language], AI.[NeedI6Update]
	
	-- ACTUALIZAMOS LOS AUDIOS QUE SE VAN A TRABAJAR EN ESE PROCESS
	UPDATE A
		SET [IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[IsCancel] = NULL
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = PA.[VCC]
				AND A.[ID] = PA.[AudioId]
				AND A.[Section] = PA.[Section]
				AND A.[Part] = PA.[Part]
		WHERE PA.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND A.[NeedI6Update] = 1
			AND (
				(
					ISNULL(A.[IsProcess], 0) = 0				
					AND 
					ISNULL(A.[IsTranscribed], 0) = 0
				)											-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR 
				(
					A.[IsProcess] = 1						
					AND 
					A.[IsCancel] = 1
				)
			)												-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

	-- ACTUALIZAMOS LOS TEXTOS QUE SE VAN A TRABAJAR EN ESE PROCESS
	UPDATE AI
		SET [IsProcess] = 1,
			[IsCancel] = NULL
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[VCC] = PAI.[VCC] 
				AND AI.[ID] = PAI.[InteractionId]
		WHERE PAI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND AI.[NeedI6Update] = 1
			AND (
				(
					ISNULL(AI.[IsProcess], 0) = 0				
					AND 
					ISNULL(AI.[IsTranscribed], 0) = 0
				)											-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR 
				(
					AI.[IsProcess] = 1						
					AND 
					AI.[IsCancel] = 1
				)
			)	
	
	-- SELECT * FROM [dbo].[ProcessAudio] PA (NOLOCK) WHERE [VCC] = 'incollege'
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetProcessInteractionsByProcessId]...';


GO
 ALTER PROCEDURE [dbo].[GetProcessInteractionsByProcessId]
(
	@VCC		VARCHAR(50) = NULL,
	@ProcessId	VARCHAR(50) = NULL,
	@ResultType VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ESTA FUNCION RETORNA LAS INTERACCIONES DE TEXTO Y AUDIO RELACIONADA A UN PROCESS

	IF @ResultType = 'RAW' 
	BEGIN
		-- RESULTADO TIPO RAW GENERA UN RESULTADO CON LOS DATOS Y NOMBRES DE COLUMNAS COMO VIENEN DE HD

		SELECT CONCAT(A.[ID], '_', A.[Section], '_', A.[PArt])				'ID',
				A.[ID]														'InteractionId',
				A.[Section]													'Section',
				A.[Part]													'Part',
				'CALL'														'Channel',
				A.[Number]													'Number',
				A.[Gender]													'Gender',
				A.[SilenceTime]												'Silence',
				A.[DurationTime]											'DurationTime',
				A.[DurationTime]											'AtentionTime',
				A.[Category1]												'Category1',
				A.[Category2]												'Category2',
				A.[Category3]												'Category3',
				A.[Description]												'Description',
				A.[DispositionCode]											'DispositionCode',
				A.[Campaign]												'Campaign',
				A.[Agent]													'Agent',
				A.[Number]													'contactName',
				A.[Type]													'Type',
				A.[StartDate]												'StartDate',
				A.[EndDate]													'EndDate',
				NULL														'Format',
				A.[ValidChar]												'validChar',
				A.[TotalPhrases]											'totalPhrases',
				A.[ContactAddress]											'contactAddress',
				A.[NeedI6Update]											'needI6Update'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			INNER JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				

		SELECT PAI.[VCC]													'vcc', 
				PAI.[InteractionId]											'id', 
				PAI.[FormattedEndDate]										'folder',
				AI.[ExportedContent]										'exportedContent',
				PAI.[InteractionType]										'channel',
				PAI.[Campaign]												'campaign',
				AI.[StartDate]												'startDate',
				AI.[EndDate]												'endDate',
				AI.[Account]												'account',
				AI.[Initiative]												'initiative',
				AI.[ContactName]											'contactName',
				AI.[ContactAddress]											'contactAddress',
				AI.[FirstTakedAgent]										'firstTakedAgent',
				AI.[LastTakedAgent]											'lastTakedAgent', 
				AI.[IsTaken]												'isTaken',
				AI.[TotalMessages]											'totalMessages',
				AI.[DurationTime]											'durationTime',
				AI.[AttentionTime]											'attentionTime',
				AI.[DispositionCode]										'dispositionCode',
				AI.[DispositionTreePath]									'dispositionTreePath',
				CASE WHEN AI.[TotalPhrases] IS NULL 
					THEN AI.[RawChar] ELSE 0 END							'rawChar',
				ISNULL(AI.[TotalPhrases], 0)								'totalPhrases',
				AI.[NeedI6Update]											'needI6Update'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetTeamPerformanceFromEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[GetTeamPerformanceFromEvaluationPlan] (
	@VCC					VARCHAR(50) = NULL,
	@EvaluationFormatId		VARCHAR(50) = NULL,
	@EvaluationPlanIds		VARCHAR(MAX) = NULL,
	@AgentIds				VARCHAR(MAX) = NULL,
	@AbilityIds				VARCHAR(MAX) = NULL,
	@StartDate				DATETIME,
	@EndDate				DATETIME,
	@drilldownTarget		VARCHAR(50) = NULL,
	@drilldownId			VARCHAR(50) = NULL
)
AS
BEGIN

	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS
	CREATE TABLE #SEARCHED_INTERACTIONS
	(
		AgentId				VARCHAR(100),
		EvaluationPlanId	VARCHAR(50),
		InteractionId		VARCHAR(250)
	)
	
	IF(@drilldownTarget ='ABILITY')
	BEGIN
		SET @AbilityIds = @drilldownId
	
		INSERT INTO #SEARCHED_INTERACTIONS
			SELECT DISTINCT ER.[IdAgent]															'AgentId',
							ER.[IdEvaluationPlan]													'EvaluationPlanId',
							ER.[IdInteraction]														'InteractionId' 
		
				FROM [dbo].[EvaluationResult] ER (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON ER.[Instance] = EP.[Instance]
						AND ER.[IdEvaluationPlan] = EP.[ID]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON EP.[Instance] = AEP.[Instance]
						AND EP.[ID] = AEP.[IdEvaluationPlan]
						AND (
							EP.[Status] = 7 AND EP.Evaluation_Mode = 'A'
							OR
							AEP.[Completed] = 1 AND EP.Evaluation_Mode IN ('X','M')
						)
				WHERE ER.[Instance] = @VCC
					AND ER.[InteractionDatefin] BETWEEN @StartDate AND @EndDate
					AND ER.[IdEvaluationFormat] = @EvaluationFormatId
					AND (
						ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						OR					
						ER.[IdEvaluationPlan]  IN (SELECT Value FROM [dbo].[split](@EvaluationPlanIds, ','))
					)	
					AND (
						ISNULL(LEN(@AgentIds), 0) = 0
						OR
						ER.[IdAgent]  IN (SELECT Value FROM [dbo].[split](@AgentIds, ','))
					)
					AND (
						ISNULL(LEN(@AbilityIds), 0) = 0
						OR 					
						(
							ER.[IdAbility] IN (SELECT Value FROM [dbo].[split](@AbilityIds, ','))
							AND
							(
								/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
								/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
								(
									ER.[MaxAbilityScore] <> 0
									AND
									ER.[Qualification] = ER.[MaxAbilityScore]
								)
								OR
								(
									ER.[MaxAbilityScore] = 0
									AND
									ER.[AbilityInnerScore] = 100
								)
							)
						)
					)

	END
	ELSE
	BEGIN
		INSERT INTO #SEARCHED_INTERACTIONS
			SELECT DISTINCT ER.[IdAgent]															'AgentId',
							ER.[IdEvaluationPlan]													'EvaluationPlanId',
							ER.[IdInteraction]														'InteractionId' 
				FROM [dbo].[EvaluationResult] ER (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON ER.[Instance] = EP.[Instance]
						AND ER.[IdEvaluationPlan] = EP.[ID]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON EP.[Instance] = AEP.[Instance]
						AND EP.[ID] = AEP.[IdEvaluationPlan]
						AND (
							EP.[Status] = 7 AND EP.Evaluation_Mode = 'A'
							OR
							AEP.[Completed] = 1 AND EP.Evaluation_Mode IN ('X','M')
						)
				WHERE ER.[Instance] = @VCC
					AND ER.[InteractionDatefin] BETWEEN @StartDate AND @EndDate
					AND ER.[IdEvaluationFormat] = @EvaluationFormatId
					AND (
						ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						OR					
						ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
						)
					
					AND (
						ISNULL(LEN(@AgentIds), 0) = 0
						OR
						ER.[IdAgent]  IN(SELECT Value FROM [dbo].[split](@AgentIds,','))
						)
			
					AND (
						ISNULL(LEN(@AbilityIds), 0) = 0
						OR 
						(
						ER.[IdAbility] IN (SELECT Value FROM [dbo].[split](@AbilityIds, ','))
					
						)
					)

	END


   
	-- GENERAMOS EL LISTADO DE INTERACCIONES A BUSCAR
	
	
	--SELECT * FROM #SEARCHED_INTERACTIONS
	-- OBTENEMOS TOTAL DE INTERACCIONES POR AGENTE	
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_TOTALBYAGENT
	SELECT [AgentId],COUNT([InteractionId]) 'Total' 
		INTO #SEARCHED_INTERACTIONS_TOTALBYAGENT
		FROM #SEARCHED_INTERACTIONS 
		GROUP BY [AgentId]
	
	--SELECT * FROM #SEARCHED_INTERACTIONS_TOTALBYAGENT
	
	--OBTENENEMOS SUMATORIA DE NOTAS POR AGENTE
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_NOTAS
	SELECT ER.[IdAgent]					'AgentId',
			ER.[IdEvaluationPlan]		'EvaluationPlanId',	
			ER.[IdInteraction]			'InteractionId', 
			SUM(Qualification)			'NotaTotal'
		INTO  #SEARCHED_INTERACTIONS_NOTAS
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		INNER JOIN #SEARCHED_INTERACTIONS SI
			ON ER.[IdAgent] =SI.[AgentId]
				AND ER.[IdEvaluationPlan] = SI.[EvaluationPlanId]
				AND  ER.[IdInteraction] = SI.[InteractionId]
		WHERE ER.[Instance] = @VCC
			AND ER.[IdEvaluationFormat] = @EvaluationFormatId
			AND (
				ISNULL(LEN(@EvaluationPlanIds), 0) = 0
				OR					
			    ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
			)
		GROUP BY ER.[IdAgent],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction]
					
				
	--SELECT * FROM #SEARCHED_INTERACTIONS_NOTAS
	-- OBTENEMOS EL PROMEDIO DE NOTAS POR AGENTE PARA OBTENER CUARILTES
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_NOTAS_PROM
    SELECT [AgentId], CAST(AVG([NotaTotal]) AS DECIMAL(7,1)) 'PromNotaTotal'
	INTO #SEARCHED_INTERACTIONS_NOTAS_PROM
	FROM #SEARCHED_INTERACTIONS_NOTAS
	GROUP BY [AgentId]			

	--SELECT * FROM #SEARCHED_INTERACTIONS_NOTAS_PROM

	--OBTENEMOS CUARTILES
	--OBTENEMOS CUARTILES DE ACUERDO A LOS PROMEDIOS DE NOTAS POR AGENTE
	DROP TABLE IF EXISTS #CUARTILES
	SELECT DISTINCT CAST([PromNotaTotal] AS DECIMAL(7,1)) 'PromNotaTotal'
	INTO #CUARTILES
	FROM #SEARCHED_INTERACTIONS_NOTAS_PROM

	DROP TABLE IF EXISTS #CUARTILES_ENUM
	SELECT ROW_NUMBER() OVER(ORDER BY [PromNotaTotal] DESC) 'lux',[PromNotaTotal] 
	INTO #CUARTILES_ENUM
	FROM #CUARTILES
    
	DECLARE @CUARTIL_EL INT
	SELECT @CUARTIL_EL = COUNT(*) FROM #CUARTILES_ENUM
	
	DROP TABLE IF EXISTS #CUARTILES_FINAL
	SELECT
    CAST(CE.[PromNotaTotal] AS DECIMAL(7,1)) 'PromNotaTotal',
    IIF (A.PromNotaTotal IS NOT NULL AND @CUARTIL_EL>=4 , 1,
        IIF (B.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 2, 
        IIF (C.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 3, 
        IIF (D.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 4, 1)))
    ) as quartile
	INTO #CUARTILES_FINAL
	FROM
    #CUARTILES_ENUM CE
    LEFT OUTER JOIN #CUARTILES_ENUM A on CE.PromNotaTotal = A.PromNotaTotal and A.lux > (SELECT COUNT(*)*0.00 FROM #CUARTILES_ENUM) and a.lux <= (SELECT COUNT(*)*0.25 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM B on CE.PromNotaTotal = B.PromNotaTotal and B.lux > (SELECT COUNT(*)*0.25 FROM #CUARTILES_ENUM) and b.lux <= (SELECT COUNT(*)*0.50 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM C on CE.PromNotaTotal = C.PromNotaTotal and C.lux > (SELECT COUNT(*)*0.50 FROM #CUARTILES_ENUM) and c.lux <= (SELECT COUNT(*)*0.75 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM D on CE.PromNotaTotal = D.PromNotaTotal and D.lux > (SELECT COUNT(*)*0.75 FROM #CUARTILES_ENUM)


	-- OBTENEMOS LOS TIEMPOS DE CADA AGENTE
	DROP TABLE IF EXISTS #AGENT_AUDIOS_TIME
	SELECT A.[Agent]								'AgentId',
			A.[AgentName]							'AgentName',
			AVG(A.[DurationLinguisticTime])			'AverageLinguisticTime',
			SUM(A.[DurationLinguisticTime])			'TotalLinguisticTime'
		INTO #AGENT_AUDIOS_TIME
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		INNER JOIN #SEARCHED_INTERACTIONS SI
			ON SI.[InteractionId] = IEP.[IdInteraction]
			AND SI.[EvaluationPlanId] = IEP.[IdEvaluationPlan]
		INNER JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IEP.[Instance]
				AND A.[ID] = IEP.[IdInteraction]
				AND A.[Section] = IEP.[InteractionSection]
				AND A.[Part] = IEP.[InteractionPart]
		WHERE IEP.[Instance] = @VCC
			AND (
			 ISNULL(LEN(@EvaluationPlanIds), 0) = 0
			 OR
			 IEP.[IdEvaluationPlan]  IN (SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

			)
			
		GROUP BY A.[Agent], 
					A.[AgentName]
	
	--SELECT * FROM  #AGENT_AUDIOS_TIME	
	
	-- OBTENEMOS LAS INTEARACCIONES QUE TUVIERON SENTIMIENTO POSITVO O NEGATIVO
	-- OBTENEMOS LAS INTEARACCIONES QUE TUVIERON SENTIMIENTO POSITVO O NEGATIVO
	SELECT DISTINCT SI.[AgentId],IEP.[IdEvaluationPlan],SR.[InteractionId] ,SR.[SentimentId]
		INTO #SEARCHED_INTERACTIONS_SENTIMENTS
		FROM [dbo].[SentimentAnalysisResult] SR (NOLOCK)
				INNER JOIN [dbo].[InteractionEvaluationPlan] IEP
					ON SR.[InteractionId] = IEP.[IdInteraction]
					AND SR.[InteractionSection] = IEP.[InteractionSection] 
					AND SR.[InteractionPart] = IEP.[InteractionPart]
					AND ISNULL(SR.[EndDate],'') = ISNULL(IEP.[InteractionDateEnd],'')
					AND IEP.[Instance] = @VCC					
					AND (
						 ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						 OR					
						 IEP.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
						 )
					 AND SR.[AnalysisType] = 'Client'
					 AND SR.[Score] > 0
					 AND SR.[MaxScore] = 1
					 AND SR.[SentimentId] IN ('Positive','Negative') 
				
					INNER JOIN 
					#SEARCHED_INTERACTIONS SI 
					ON 	SR.[InteractionId] = SI.[InteractionId]
						AND IEP.[IdEvaluationPlan] = SI.[EvaluationPlanId]
						AND IEP.[IdAgent] = SI.[AgentId]
			 WHERE SR.VCC = @VCC
				AND SR.[AnalysisType] = 'Client'
				AND SR.[Score] > 0
				AND SR.[SentimentId] IN ('Positive','Negative')

		--SELECT * FROM #SEARCHED_INTERACTIONS_SENTIMENTS
			





	-- OBTENEMOS TOTAL DE INTERACCIONES POR AGENTE 
	DROP TABLE IF EXISTS #TOTALINTERACTION_SR_BY_AGENT
	SELECT [AgentId], COUNT([InteractionId]) 'TotalSentiments'
	INTO #TOTALINTERACTION_SR_BY_AGENT
	FROM  #SEARCHED_INTERACTIONS_SENTIMENTS
	GROUP BY [AgentId]


	

	DROP TABLE IF EXISTS #SENTIMENT_RESULT
	SELECT SIR.[AgentId]												'AgentId', 
		SIR.[SentimentId]												'SentimentId',
		COUNT(SIR.[InteractionId])										'Matches' ,
		CAST ((COUNT(SIR.[InteractionId])*100
		/
		CONVERT(DECIMAL(4,2),SRA.TotalSentiments)) AS DECIMAL(7,1))		'MatchesPercentage',
		SRA.[TotalSentiments]											'TotalSentiments',
	    SRAT.[Total]													'Total'
		
		INTO #SENTIMENT_RESULT
		FROM #SEARCHED_INTERACTIONS_SENTIMENTS SIR 
		INNER JOIN  #TOTALINTERACTION_SR_BY_AGENT SRA
		ON SIR.[AgentId] = SRA.[AgentId]
		INNER JOIN #SEARCHED_INTERACTIONS_TOTALBYAGENT SRAT
		ON SRAT.[AgentId] = SIR.[AgentId]
			
		GROUP BY SIR.[AgentId], SIR.[SentimentId], SRA.[TotalSentiments],[Total]	
		
    

	-- OBTENEMOS LAS HABILIDADES PARA NOMBRAR LAS COLUMNAS
		DECLARE @HABILITY_COLUMNS VARCHAR(MAX)
		SET @HABILITY_COLUMNS = STUFF(
				(
					/*
					SELECT DISTINCT ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
						FROM #TempEvaluationResult
					*/
					SELECT DISTINCT ',' + QUOTENAME(HA.[Id])
						FROM [dbo].[HistoricAbility] HA (NOLOCK) 
						WHERE HA.[VCC] = @VCC
							AND
                            (
                                ISNULL(LEN(@EvaluationPlanIds), 0) = 0
                                OR
                                HA.[EvaluationPlanId]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

                            ) 
                            
						FOR xml PATH (''), TYPE
				).value('.', 'VARCHAR(MAX)'), 
				1, 
				1, 
				''
		)

		DECLARE @HABILITY_COLUMNS_ISNULL VARCHAR(MAX)
		SET @HABILITY_COLUMNS_ISNULL = STUFF(
				(
					/*
					SELECT DISTINCT ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
						FROM #TempEvaluationResult
					*/
					SELECT DISTINCT ',' +'ISNULL('+ QUOTENAME(HA.[Id]) +',0) AS' + QUOTENAME(HA.[Id]) + ' '
						FROM [dbo].[HistoricAbility] HA (NOLOCK) 
						WHERE HA.[VCC] = @VCC
							AND
                            (
                                ISNULL(LEN(@EvaluationPlanIds), 0) = 0
                                OR
                                HA.[EvaluationPlanId]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

                            ) 
                            
						FOR xml PATH (''), TYPE
				).value('.', 'VARCHAR(MAX)'), 
				1, 
				1, 
				''
		)
		DECLARE @SENTIMENT_COLUMNS VARCHAR(100)
		DECLARE @ALL_COLUMNS VARCHAR(MAX)
		DECLARE @ALL_COLUMNS_ISNULL VARCHAR(MAX)
		SET @SENTIMENT_COLUMNS =',[Positive],[Negative]'
		SET @ALL_COLUMNS =  @HABILITY_COLUMNS + @SENTIMENT_COLUMNS
		SET @HABILITY_COLUMNS_ISNULL = @HABILITY_COLUMNS_ISNULL  +',ISNULL([Positive],0) AS [Positive],ISNULL([Negative],0) AS [Negative]'

		

		



	-- GENERAMOS EL RESUMEN DE RESULTADOS POR HABILIDAD Y MATCH POSITIVO
	DROP TABLE IF EXISTS #RESULTS_SUMMARY
	SELECT ER.[IdAgent]																	'AgentId',
			ER.[IdAbility]																'AbilityId',
			HA.[Title]																	'AbilityTitle',
			/*
			COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))				'Matches',
			*/
			/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
			/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
			/*
			CASE WHEN ER.[MaxAbilityScore] <> 0
					THEN COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))	
					ELSE COUNT(IIF(ER.[AbilityInnerScore] = 100, 1, NULL))
				END																		'Matches',
			*/
			COUNT(
				CASE WHEN ER.[MaxAbilityScore] <> 0
						THEN IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)
						ELSE IIF(ER.[AbilityInnerScore] = 100, 1, NULL)
					END
			)																			'Matches',
			/*
			CAST(COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))*100
			/
			CONVERT(DECIMAL(4,2),SIT.Total) AS DECIMAL(7,1))							'MatchesPercentage',
			*/
			/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
			/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
			/*
			CASE WHEN ER.[MaxAbilityScore] <> 0
					THEN CAST(COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)) * 100
							/
							CONVERT(DECIMAL(4, 2), SIT.Total) AS DECIMAL(7, 1))
					ELSE CAST(COUNT(IIF(ER.[AbilityInnerScore] = 100, 1, NULL)) * 100
							/
							CONVERT(DECIMAL(4, 2), SIT.Total) AS DECIMAL(7, 1))
				END																		'MatchesPercentage',

			*/
			CAST(
				COUNT(
					CASE WHEN ER.[MaxAbilityScore] <> 0
							THEN IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)
							ELSE IIF(ER.[AbilityInnerScore] = 100, 1, NULL)
						END
				) 
				* 
				100 
				/ 
				CONVERT(DECIMAL(4, 2), SIT.Total) AS DECIMAL(7, 1)
			)																			'MatchesPercentage',
			SIT.Total																	'Total'
			
			
		INTO #RESULTS_SUMMARY
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
			ON HA.[EvaluationPlanId] = ER.[IdEvaluationPlan]
				AND HA.[ID] = ER.[IdAbility]
		INNER JOIN #SEARCHED_INTERACTIONS SI 
			ON SI.[AgentId] = ER.[IdAgent]
				AND SI.[EvaluationPlanId] =ER.[IdEvaluationPlan]
				AND SI.[InteractionId] = ER.[IdInteraction]
       INNER JOIN #SEARCHED_INTERACTIONS_TOTALBYAGENT (NOLOCK) SIT 
		ON ER.[IdAgent] =SIT.[AgentId]			
		WHERE ER.[Instance] = @VCC
			AND (
				ISNULL(LEN(@EvaluationPlanIds), 0) = 0
				OR
				ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
			)
		GROUP BY ER.[IdAgent],
					ER.[IdAbility],
					HA.[Title],
					SIT.[Total]

	 UNION ALL
	 SELECT [AgentId],[SentimentId],[SentimentId],[Matches],[MatchesPercentage],[Total]
		    FROM #SENTIMENT_RESULT
	
	  --SELECT * FROM 	#RESULTS_SUMMARY
	 -- OBTENEMOS LAS COLUMANS DINAMICAS(HABILIDADES,SENTIMIENTOS) Y ESTATICAS(TOTAL, AGENTE) PARA EL GRID 
	-- OBTENEMOS LAS COLUMANS DINAMICAS(HABILIDADES,SENTIMIENTOS) Y ESTATICAS(TOTAL, AGENTE) PARA EL GRID 
	 SELECT 'HEADER_QUARTILE' 'headerName', 'quartile' 'field', 'quartile' 'customtype'	 
	 UNION ALL
	 SELECT 'HEADER_AGENT' 'headerName','AgentId' 'field', 'agent' 'customtype'
	 UNION ALL
	 SELECT 'HEADER_TOTAL_INTERACTIONS' 'headerName', 'TotalInteractions' 'field', 'totalInteractions' 'customtype'
	 UNION ALL
	 SELECT DISTINCT AbilityTitle 'headerName',AbilityId 'field', 
     CASE WHEN HA.IsNegative = 1 AND AC.ID IS NOT NULL  THEN 'negativeAbility' 
          WHEN HA.IsNegative = 0 AND AC.ID IS NOT NULL THEN  'positiveAbility'
          ELSE 'normalAbility' END  'customtype'
	 FROM #RESULTS_SUMMARY RS
		INNER JOIN HistoricAbility HA 
		ON RS.AbilityId = HA.ID 
        LEFT JOIN AbilityScoreCard AC 
        ON HA.ID = AC.ID
        AND AC.DegradeScoreCard = 1 
        

	 WHERE AbilityId NOT IN('Positive','Negative')
	 UNION ALL
	 SELECT 'HEADER_PROM_NOTA_TOTAL' 'headerName','PromNotaTotal' 'field', 'finalnote' 'customtype'
	 UNION ALL
	 SELECT DISTINCT AbilityId 'headerName',AbilityTitle 'field','sentiment' 'customtype' FROM #RESULTS_SUMMARY
	 WHERE AbilityId IN('Positive','Negative')
	 UNION ALL
	 SELECT 'TMO' 'headerName','TMO' 'field', 'TMO' 'customtype'



	 

	-- ARMAR DRILLDOWN PARA SETEAR UN NUEVO TOTAL A LA TABLA RESULTANTE
	-- REQUERIMOS LOS DATOS DE AGENTEID, DRILLDOWNTARGET= HABILIDAD O SENTIMIENTO, DRILLDOWNID=IDABILIDAD O IDSENTIMIENTO.
	DECLARE @QUERY VARCHAR(MAX)

      
		SET @QUERY  = '
        
		SELECT P.[AgentId],
				' + @ALL_COLUMNS + ',
				P.[Total],
				INNER_AAT.[AverageLinguisticTime],
				INNER_AAT.[TotalLinguisticTime]


			INTO #RESULT_SUMMARY_PIVOT
			FROM (
				SELECT [AgentId],
						[AbilityId],
						[MatchesPercentage],
						[Total]
					FROM #RESULTS_SUMMARY
			)
			X
			PIVOT (
				MAX([MatchesPercentage]) FOR [AbilityId] IN (' + @ALL_COLUMNS + ')
			) P
			
			INNER JOIN #AGENT_AUDIOS_TIME INNER_AAT
				ON   INNER_AAT.[AgentId] = P.[AgentId]
                
			ORDER BY P.[Total] DESC ' + '

			
			
			SELECT	RSP.[AgentId],' + @HABILITY_COLUMNS_ISNULL+ ',					
					SIP.[PromNotaTotal],
					CF.[quartile] AS quartile,
					RSP.[Total] AS TotalInteractions,
					CAST (RSP.[AverageLinguisticTime] AS DECIMAL(7,1)) AS TMO
					
				
			
			FROM  #RESULT_SUMMARY_PIVOT RSP
			INNER JOIN #SEARCHED_INTERACTIONS_NOTAS_PROM SIP
                ON RSP.[AgentId] = SIP.[AgentId]
               
				
			INNER JOIN #CUARTILES_FINAL CF ON 
				CF.PromNotaTotal = SIP.PromNotaTotal

			ORDER BY SIP.[PromNotaTotal] DESC
			
	    '


	-- EJECUTAMOS EL QUERY ARMADO

	
	--PRINT (@QUERY)
	EXECUTE (@QUERY)

	

	DROP TABLE IF EXISTS #AGENT_AUDIOS_TIME
	DROP TABLE IF EXISTS #RESULTS_SUMMARY
END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveEvaluationBaseResult]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@EVALUATION_PLAN_ID VARCHAR(100) = NULL,
	@ABILITY_TYPE VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP INSERTA LOS RESULT BASE DE UN PLAN AUTOMATICO/MIXTO
	SET NOCOUNT ON

	-- SETTEAMOS EL TYPE ABILITY COMO AUTOMATIC PO DEFECTO
	IF @ABILITY_TYPE IS NULL SET @ABILITY_TYPE = 'AUTOMATIC'

	;WITH CTE_TEXT_INTERACTION_SUMMARY AS (
		SELECT IEP.[IdInteraction],
				MAX(IEP.[FormattedEndDate]) 'FormattedEndDate'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC
				AND IEP.[IdEvaluationPlan] = @EVALUATION_PLAN_ID
				AND IEP.[InteractionType] <> 'CALL'
			GROUP BY IEP.[IdInteraction]
	),
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART
	CTE AS (
		SELECT IEP.[Instance]									'vcc',
				IEP.[IdCampaign]								'IdCampaign',
				IEP.[IdInteraction]								'IdInteraction',
				IEP.[IdAgent]									'IdAgent',
				EP.[IdEvaluationFormat]							'IdEvaluationFormat',
				HEF.[MinQualificationAcceptable]				'MinQualificationAcceptable',
				HAEF.[IdGroup]									'IdGroup',
				HAEF.[IdSubGroup]								'IdSubGroup',
				HAEF.[IdAbility]								'IdAbility',
				HAEF.[Score]									'MaxAbilityScore',
				HS.[Value]										'AbilityInnerScore',
				EP.[ID]											'IdEvaluationPlan',
				HS.[Description]								'ScoreDescription',
				IEP.[IdCampaign]								'CampaignDescription',
				IEP.[IdAgent]									'AgentDescription',
				IEP.[InteractionDateStart]						'InteractionDateini',
				IEP.[InteractionDateEnd]						'InteractionDatefin',
				IEP.[ContactId]									'InteractionAddress',
				HAEF.[Order]									'AbilityOrder',
				IEP.[InteractionType]							'InteractionType',
				HAEF.[ID]										'IdAbilityEvaluationFormat',
				HAEF.[Conditional]								'Conditional',
				RN = ROW_NUMBER() OVER(PARTITION BY IEP.[IdCampaign],
													IEP.[IdInteraction],
													IEP.[IdAgent],
													EP.[IdEvaluationFormat],
													HEF.[MinQualificationAcceptable],
													HAEF.[IdGroup],
													HAEF.[IdSubGroup],
													HAEF.[IdAbility],
													HS.[Value],
													HS.[Description],
													IEP.[IdCampaign],
													IEP.[IdAgent],
													IEP.[InteractionDateStart],
													IEP.[InteractionDateEnd],
													HAEF.[Order],
													IEP.[InteractionType],
													HAEF.[ID],
													HAEF.[Conditional]
										ORDER BY IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC)
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			INNER JOIN [dbo].[HistoricEvaluationFormat] HEF (NOLOCK)
				ON HEF.[VCC] = EP.[Instance]
					AND HEF.[EvaluationPlanId] = EP.[ID]
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = EP.[Instance]
					AND IEP.[IdEvaluationPlan] = EP.[ID]
			INNER JOIN [dbo].[HistoricAbilityEvaluationFormat] HAEF (NOLOCK)
				ON HAEF.[VCC] = EP.[Instance]
					AND HAEF.[EvaluationPlanId] = EP.[ID]
			INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
				ON HA.[VCC] = EP.[Instance]
					AND HA.[EvaluationPlanId] = EP.[ID]
			LEFT JOIN [dbo].[Intent] I (NOLOCK)
				ON I.[VCC] = EP.[Instance]
					AND I.[IntentId] = HA.[QueryName]
			INNER JOIN [dbo].[HistoricScore] HS (NOLOCK)
				ON HS.[VCC] = IEP.[Instance]
					AND HS.[EvaluationPlanId] = EP.[ID]
					AND HS.[IdAbility] = HA.[ID]
					AND HS.[Value] = IIF(HA.[IsNegative] = 1, 100, 0)
			LEFT JOIN [dbo].[EvaluationResult] ER (NOLOCK)
				ON ER.[Instance] = IEP.[Instance]
					AND ER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
					AND ER.[IdAgent] = IEP.[IdAgent]
					AND ER.[IdAbilityEvaluationFormat] = HAEF.[ID]
			LEFT JOIN [dbo].[Audio] AU(NOLOCK)
 			    ON  AU.[ID] = IEP.[IdInteraction]
				AND AU.[Section] = IEP.[InteractionSection]
				AND AU.[Part] = IEP.[InteractionPart]
			-- TODO: Y EL CRUCE PARA INTERACCIONES DE TEXTO?
			LEFT JOIN CTE_TEXT_INTERACTION_SUMMARY CTE_IS 
				ON CTE_IS.[IdInteraction] = IEP.[IdInteraction]
					AND CTE_IS.[FormattedEndDate] = IEP.[FormattedEndDate]
			WHERE IEP.[IdInteraction] IS NOT NULL
				AND (
					-- (@ABILITY_TYPE = 'AUTOMATIC' AND I.[VCC] IS NOT NULL)
					(@ABILITY_TYPE = 'AUTOMATIC' AND HA.[Type] = 'MANUAL_AUTOMATIC')
					OR
					-- (@ABILITY_TYPE = 'MANUAL' AND I.[VCC] IS NULL)
					(@ABILITY_TYPE = 'MANUAL' AND HA.[Type] = 'MANUAL')
				)
				AND ER.[Instance] IS NULL
				AND EP.[ID] = @EVALUATION_PLAN_ID
				AND EP.[Instance] = @VCC
			    -- SI TIENE AUDIO DEBE ESTAR TRANSCRITO
			    AND (
					(
						AU.[ID] IS NOT NULL 
						AND 
						AU.[IsTranscribed] = 1
					)
					OR 
					IEP.[InteractionType] <> 'CALL'
				) 
				AND (
					CTE_IS.[IdInteraction] IS NOT NULL 
					OR
					IEP.[InteractionType] = 'CALL'
				)
	)

	-- INSERTAMOS SOLO LAS PRIMERAS OCURRENCIAS PARA CADA INTERACCION
	INSERT INTO [dbo].[EvaluationResult] (
		[Instance], [IdCampaign], [IdInteraction],
		[IdAgent], [IdEvaluationFormat], [MinQualificationAcceptable],
		[IdGroup], [IdSubGroup], [IdAbility],
		[Qualification], [OwnScore], [AbilityInnerScore], 
		[IdEvaluator], [EvaluationDate], [MaxAbilityScore], 
		[IdEvaluationPlan], [CreatedDate], [CreatedByUserId], 
		[LastModifiedDate], [LastModifiedByUserId], [TimeStamp], 
		[Comment], [NotApplies], [ScoreDescription], 
		[CampaignDescription], [AgentDescription], [InteractionDateini], 
		[InteractionDatefin], [InteractionAddress], [AbilityOrder], 
		[InteractionType], [IdAbilityEvaluationFormat],  [IdAuditor], 
		[Conditional]
	) 
		SELECT DISTINCT C.[vcc], C.[IdCampaign], C.[IdInteraction],
				C.[IdAgent], C.[IdEvaluationFormat], C.[MinQualificationAcceptable],
				C.[IdGroup], C.[IdSubGroup], C.[IdAbility],
				(C.[MaxAbilityScore] * C.[AbilityInnerScore] / 100), (C.[MaxAbilityScore] * C.[AbilityInnerScore] / 100), C.[AbilityInnerScore], 
				'SPEECH', GETUTCDATE(), C.[MaxAbilityScore], 
				C.[IdEvaluationPlan], GETUTCDATE(), 'SPEECH', 
				--'100', C.[IdEvaluationPlan], GETUTCDATE(),
				GETUTCDATE(), 'SPEECH', GETUTCDATE(), 
				NULL, '0', C.[ScoreDescription], 
				C.[CampaignDescription], C.[AgentDescription], C.[InteractionDateini], 
				C.[InteractionDatefin], C.[InteractionAddress], C.[AbilityOrder], 
				C.[InteractionType], C.[IdAbilityEvaluationFormat], 'SPEECH', 
				C.[Conditional]
			FROM CTE C 
			WHERE C.RN = 1

	SET NOCOUNT OFF
END
GO
PRINT N'Creando Procedimiento [dbo].[DeleteEvaluationPlanInteractionByTypeAndId]...';


GO
CREATE PROCEDURE [dbo].[DeleteEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- ELIMINAMOS EL REGISTRO DE LA TABLA [dbo].[InteractionEvaluationPlan]
		DELETE FROM [dbo].[InteractionEvaluationPlan] 
			WHERE [Instance] = @VCC
				AND [IdEvaluationPlan] = @EvaluationPlanId
				AND [InteractionType] = @InteractionType
				AND [IdInteraction] = @InteractionId

		-- ELIMINAMOS EL REGISTRO DE LA TABLA [dbo].[AuditorEvaluationPlan]
		DELETE FROM [dbo].[AuditorEvaluationPlan] 
			WHERE [Instance] = @VCC
				AND [IdEvaluationPlan] = @EvaluationPlanId
				AND [InteractionType] = @InteractionType
				AND [IdInteraction] = @InteractionId

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Creando Procedimiento [dbo].[GetI6AlreadyRegisteredCallInteractions]...';


GO
CREATE PROCEDURE [dbo].[GetI6AlreadyRegisteredCallInteractions] (@VCC VARCHAR(50) = NULL)
AS
BEGIN
	-- CRUZAMOS LA TABLA TEMPORAL CON LAS INTERACCIONES DE LA API CON LA TABLA AUDIO
	SELECT DISTINCT A.[VCC]														'vcc',
					CONCAT(A.[ID], '_', A.[Section], '_', A.[Part])				'ID',
					A.[ID]														'InteractionId',
					A.[Section]													'Secction',
					A.[Part]													'Part',
					'CALL'														'Channel',
					A.[Number]													'Number',
					A.[ContactAddress]											'ContactAdress',
					A.[Gender]													'Gender',
					A.[SilenceTime]												'SilenceTime',
					A.[DurationTime]											'DurationTime',
					A.[DurationTime]											'AttentionTime',
					1															'TotalParts',
					A.[Category1]												'Category1',
					A.[Category2]												'Category2',
					A.[Category3]												'Category3',
					A.[Description]												'Description',
					A.[DispositionCode]											'DispositionCode',
					A.[Campaign]												'Campaign',
					A.[Agent]													'Agent',
					A.[AgentName]												'agentName',
					A.[Type]													'Type',
					A.[StartDate]												'StartDate',
					A.[EndDate]													'EndDate',
					A.[Format]													'Format',
					ISNULL(A.[NeedI6Update], CAST(1 AS BIT))					'needI6Update'
		FROM [#InteractionsTemp] IT
		INNER JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IT.[VCC]
				AND  A.[ID] = IT.[InteractionId]
		WHERE IT.[VCC] = @VCC
	

END
GO
PRINT N'Creando Procedimiento [dbo].[GetI6AlreadyRegisteredTextInteractions]...';


GO
CREATE PROCEDURE [dbo].[GetI6AlreadyRegisteredTextInteractions] (@VCC VARCHAR(50) = NULL)
AS
BEGIN
	-- CRUZAMOS LA TABLA TEMPORAL CON LAS INTERACCIONES DE LA API CON LA TABLA ASYNCINTERACTION
	SELECT DISTINCT AI.[VCC]													'vcc',
					AI.[ID]														'id',
					AI.[ID]														'InteractionId',
					AI.[Folder]													'folder',
					AI.[ExportedContent]										'exportedContent',
					AI.[Channel]												'channel',
					AI.[Campaign]												'campaign',
					AI.[StartDate]												'startDate',
					AI.[EndDate]												'endDate',
					AI.[Account]												'account',
					AI.[Initiative]												'initiative',
					AI.[ContactName]											'contactName',
					AI.[ContactAddress]											'contactAdress',
					AI.[ContactId]												'contactId',
					AI.[FirstTakedAgent]										'firstTakedAgent',
					AI.[LastTakedAgent]											'lastTakedAgent',
					AI.[TotalMessages]											'totalMessages',
					AI.[DurationTime]											'durationTime',
					AI.[AttentionTime]											'attentionTime',
					AI.[DispositionCode]										'dispositionCode',
					AI.[DispositionTreePath]									'dispositionTreePath',
					AI.[RawChar]												'rawChar',
					ISNULL(AI.[NeedI6Update], CAST(1 AS BIT))					'needI6Update'
		FROM [#InteractionsTemp] IT
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[VCC] = IT.[VCC]
				AND  AI.[ID] = IT.[InteractionId]
				AND AI.[Folder] = IT.[Folder]
		WHERE IT.[VCC] = @VCC
	
END
GO
PRINT N'Creando Procedimiento [dbo].[GetI6InteractionMessages]...';


GO
CREATE PROCEDURE [dbo].[GetI6InteractionMessages] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL
) AS 
BEGIN
	-- RETORNAMOS LOS REGISTROS DE AMBAS TABLAS
	;WITH CTE_ALL_RECORDS AS (
		-- BUSCAMOS LOS REGISTROS DE LA INTERACCION
		SELECT DISTINCT [ID]									'id',
						[Campaign]								'campaign',
						[Folder]								'folder',
						[LastTakedAgent]						'agentId'
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			WHERE AI.[VCC] = @VCC
				AND AI.[ID] = @InteractionId
		UNION
		SELECT DISTINCT [IdInteraction]							'id',
						[IdCampaign]							'campaign',
						[FormattedEndDate]						'folder',
						[IdAgent]								'agentId'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
	),
	CTE_SUMMARY AS (
		SELECT *,
				RN = ROW_NUMBER() OVER(PARTITION BY CTE_AR.[id],
													CTE_AR.[folder],
													CTE_AR.[campaign],
													CTE_AR.[agentId]
											ORDER BY CTE_AR.[id] ASC, 
														CTE_AR.[folder] ASC,
														CTE_AR.[campaign] DESC,
														CTE_AR.[agentId] DESC
										) 
			 FROM CTE_ALL_RECORDS CTE_AR
	)
		SELECT CTE_S.[id], 
				CTE_S.[folder],
				CTE_S.[campaign],
				CTE_S.[agentId] 
			FROM CTE_SUMMARY CTE_S
			WHERE RN = 1

	/*
	-- DECLARAMOS VARIABLES PARA ALMACENAR LAS CANTIDADES DE REGISTROS
	DECLARE @MESSAGES_RECORDS INT = 0
	DECLARE @INTERACION_EVALUATION_PLAN_RECORDS INT = 0

	SELECT @MESSAGES_RECORDS = COUNT(*)
		FROM [dbo].[AsyncInteraction] AI (NOLOCK)
		WHERE AI.[VCC] = @VCC
			AND AI.[ID] = @InteractionId

	SELECT @INTERACION_EVALUATION_PLAN_RECORDS = COUNT(DISTINCT CONCAT(IEP.[IdInteraction], '_', IEP.[IdCampaign], '_', IEP.[FormattedEndDate]))
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE IEP.[Instance] = @VCC	
			AND IEP.[IdInteraction] = @InteractionId

	IF @MESSAGES_RECORDS >= @INTERACION_EVALUATION_PLAN_RECORDS
	BEGIN
		-- BUSCAMOS LOS REGISTROS DE LA INTERACCION
		SELECT DISTINCT [ID]									'id',
						[Campaign]								'campaign',
						[Folder]								'folder',
						[LastTakedAgent]						'agentId'
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			WHERE AI.[VCC] = @VCC
				AND AI.[ID] = @InteractionId
			ORDER BY AI.[Folder] ASC
	END 
	ELSE 
	BEGIN
		SELECT DISTINCT [IdInteraction]							'id',
						[IdCampaign]							'campaign',
						[FormattedEndDate]						'folder',
						[IdAgent]								'agentId'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
			ORDER by IEP.[FormattedEndDate] ASC
	END
	*/
END
GO
PRINT N'Creando Procedimiento [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]...';


GO
CREATE PROCEDURE [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Folder					VARCHAR(50) = NULL,
	@ExportedContent		VARCHAR(250) = NULL,
	@Channel				VARCHAR(25) = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@AgentName				VARCHAR(100) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Account				VARCHAR(50) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@DispositionTreePath	VARCHAR(50) = NULL,
	@DispositionCode		VARCHAR(50) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@TotalMessages			INT = NULL,
	@EvaluationPlanId		VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UN CURSOR PARA RECORRER PLANES
        DECLARE RECURRENT_CURSOR CURSOR 
        LOCAL STATIC READ_ONLY FORWARD_ONLY
        FOR 
        	-- SELECCIONAMOS LOS PLANES DONDE ESTA REGISTRADA LA INTERACCION
			SELECT [IdEvaluationPlan]
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN[dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = IEP.[Instance]
						AND EP.[ID] = IEP.[IdEvaluationPlan]
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdInteraction] = @InteractionId
					AND IEP.[NeedI6Update] = 1
					AND (
						IEP.[IdEvaluationPlan] = @EvaluationPlanId
						OR 
						@EvaluationPlanId IS NULL
					)
					AND EP.[Status] <= 6
		
		-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS RECORRIENDO
        DECLARE @CURRENT_EVALUATION_PLAN VARCHAR(50) = ''

		-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
        OPEN RECURRENT_CURSOR

        FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_EVALUATION_PLAN
        WHILE @@FETCH_STATUS = 0
        BEGIN 
			-- PARA EL PLAN ACTUAL BUSCAMOS SI EXISTE INTERACCION CON EL FOLDER CORRESPONDIENTE
			DECLARE @EXISTS_IEP BIT = 0
			SELECT @EXISTS_IEP = IIF(IEP.[IdInteraction] IS NOT NULL, CAST(1 AS BIT), CAST(0 AS BIT))
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK) 
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
					AND IEP.[IdInteraction] = @InteractionId
					AND IEP.[FormattedEndDate] = @Folder

			-- SI LA INTERACCION-FOLDER EXISTE, LA ACTUALIZAMOS
			IF @EXISTS_IEP = 1
			BEGIN
				-- ACTUALIZAMOS LA INTERACCION
				UPDATE [dbo].[InteractionEvaluationPlan] 
					SET [IdCampaign] = @Campaign,
						[IdAgent] = @AgentId,
						[AgentName] = @AgentName,
						[InteractionMessages] = @TotalMessages,
						[InteractionDateStart] = @StartDate,
						[InteractionDateEnd] = @EndDate,
						[InteractionOrigin] = IIF(@Origin = 'IN', 'E', 'S'),
						[ManagementResult] = NULL,
						[ExportedContent] = @ExportedContent,
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[NeedI6Update] = 0,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND [IdInteraction] = @InteractionId
						AND [FormattedEndDate] = @Folder
						AND [NeedI6Update] = 1
			END
			-- SI LA INTERACCION-FOLDER NO EXISTE, LA INSERTAMOS
			ELSE
			BEGIN
				-- INSERTAMOS LA INTERACCION  SELECT * FROM [dbo].[InteractionEvaluationPlan]
				INSERT INTO [dbo].[InteractionEvaluationPlan] (
					[Instance], [IdEvaluationPlan], [InteractionType], [FormattedEndDate], [IdCampaign],
					[IdInteraction], [IdAgent], [AgentName], [InteractionMessages], [InteractionDateStart], 
					[InteractionDateEnd], [InteractionDuration], [InteractionOrigin], [ManagementResult], [ExportedContent],
					[ContactId], [ContactName], [ContactAddress], [NeedI6Update], [CreatedByUserId], 
					[CreatedDate], [TimeStamp]
				) VALUES (
					@VCC, @CURRENT_EVALUATION_PLAN, @Channel, @Folder, @Campaign,
					@InteractionId, @AgentId, @AgentName, @TotalMessages, @StartDate, 
					@EndDate, @DurationTime, IIF(@Origin = 'IN', 'E', 'S'), @DispositionTreePath + @DispositionCode, @ExportedContent,
					@ContactId, @ContactName, @ContactAddress, CAST(0 AS BIT), 'system', 
					GETUTCDATE(), GETUTCDATE()
				)
			END

			-- DECLARAMOS UN CURSOR PARA RECORRER AUDITORES
			DECLARE RECURRENT_CURSOR_02 CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
        		-- SELECCIONAMOS LOS AUDITORES QUE TIENEN ASIGNADA LA INTERACCION
				SELECT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE AEP.[Instance] = @VCC 
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND AEP.[IdInteraction] = @InteractionId

			-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS RECORRIENDO
			DECLARE @CURRENT_AUDITOR VARCHAR(50) = ''

			-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
			OPEN RECURRENT_CURSOR_02

			FETCH NEXT FROM RECURRENT_CURSOR_02 INTO @CURRENT_AUDITOR
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- PARA EL PLAN ACTUAL BUSCAMOS SI EXISTE INTERACCION CON EL FOLDER CORRESPONDIENTE
				DECLARE @EXISTS_AEP BIT = 0
				SELECT @EXISTS_AEP = IIF(AEP.[IdInteraction] IS NOT NULL, CAST(1 AS BIT), CAST(0 AS BIT))
					FROM [dbo].[InteractionEvaluationPlan] AEP (NOLOCK) 
					WHERE AEP.[Instance] = @VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND AEP.[IdInteraction] = @InteractionId
						AND AEP.[FormattedEndDate] = @Folder

				-- SI LA INTERACCION-FOLDER EXISTE, LA ACTUALIZAMOS
				IF @EXISTS_IEP = 1
				BEGIN
					-- ACTUALIZAMOS EL REGISTRO DE AUDITOREVALUATIONPLAN
					UPDATE [dbo].[AuditorEvaluationPlan] 
						SET [IdCampaign] = @Campaign,
							[IdAgent] = @AgentId,
							[InteractionDate] = @StartDate,
							[InteractionDateEnd] = @EndDate,
							[InteractionOrigin] = @Origin,
							[ContactId] = @ContactId,
							[ContactName] = @ContactName,
							[ContactAddress] = @ContactAddress,
							[ManagementResult] = @DispositionTreePath + @DispositionCode,
							[LastModifiedByUserId] = 'system',
							[LastModifiedDate] = GETUTCDATE(),
							[TimeStamp] = GETUTCDATE()
						WHERE [Instance] = @VCC
							AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
							AND [IdInteraction] = @InteractionId
							AND [IdAuditor] = @CURRENT_AUDITOR
				END
				/* NO ES NECESARIO INSERTAR
				ELSE
				BEGIN
					-- INSERTAMOS EL REGISTRO A AUDITOREVALUATIONPLA
					INSERT INTO [dbo].[AuditorEvaluationPlan] (
						[Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [Completed], 
						[Score], [IdCampaign], [IdAgent], [InteractionDate], [InteractionType], 
						[InteractionDuration], [InteractionOrigin], [InteractionDateEnd], [ManagementResult], [ContactId], 
						[ContactName], [ContactAddress], [Status], [StatusDescription],
						[CreatedByUserId], [CreatedDate], [TimeStamp]
					) VALUES (
						@VCC, @CURRENT_EVALUATION_PLAN, @CURRENT_AUDITOR, @InteractionId, 0,
						0, @Campaign, @AgentId, @StartDate, @Channel, 
						@DurationTime, @Origin, @EndDate, @DispositionTreePath + @DispositionCode, @ContactId,
						@ContactName, @ContactAddress, 1, 'NEW',
						'system', GETUTCDATE(), GETUTCDATE()
					)
				END
				*/

				FETCH NEXT FROM RECURRENT_CURSOR_02 INTO @CURRENT_AUDITOR
			END
			CLOSE RECURRENT_CURSOR_02
			DEALLOCATE RECURRENT_CURSOR_02

		    FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_EVALUATION_PLAN
        END
        CLOSE RECURRENT_CURSOR
        DEALLOCATE RECURRENT_CURSOR

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Creando Procedimiento [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]...';


GO
CREATE PROCEDURE [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@OldSection				INT = NULL,
	@OldPart				INT = NULL,
	@NewSection				INT = NULL,
	@NewPart				INT = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@Format					VARCHAR(10) = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@AgentName				VARCHAR(100) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@Category1				VARCHAR(100) = NULL,
	@Category2				VARCHAR(100) = NULL,
	@Category3				VARCHAR(100) = NULL,
	@Description			VARCHAR(100) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@EvaluationPlanId		VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UN CURSOR PARA RECORRER PLANES
        DECLARE RECURRENT_CURSOR CURSOR 
        LOCAL STATIC READ_ONLY FORWARD_ONLY
        FOR 
        	-- SELECCIONAMOS LOS PLANES DONDE ESTA REGISTRADA LA INTERACCION
			SELECT DISTINCT [IdEvaluationPlan]
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN[dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = IEP.[Instance]
						AND EP.[ID] = IEP.[IdEvaluationPlan]
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdInteraction] = @InteractionId
					AND IEP.[NeedI6Update] = 1
					AND (
						IEP.[IdEvaluationPlan] = @EvaluationPlanId
						OR 
						@EvaluationPlanId IS NULL
					)
					AND EP.[Status] <= 6

		-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS RECORRIENDO
        DECLARE @CURRENT_EVALUATION_PLAN VARCHAR(50) = ''

		-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
        OPEN RECURRENT_CURSOR

        FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_EVALUATION_PLAN
        WHILE @@FETCH_STATUS = 0
        BEGIN 
			-- PARA EL PLAN ACTUAL BUSCAMOS SI EXISTE INTERACCION CON EL OLD-SECTION Y OLD-PART CORRESPONDIENTE
			DECLARE @EXISTS_IEP BIT = 0
			SELECT @EXISTS_IEP = IIF(IEP.[IdInteraction] IS NOT NULL, CAST(1 AS BIT), CAST(0 AS BIT))
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK) 
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
					AND IEP.[IdInteraction] = @InteractionId
					AND IEP.[InteractionSection] = @OldSection
					AND IEP.[InteractionPart] = @OldPart

			-- SI LA INTERACCION-SECTION-PART EXISTE, LA ACTUALIZAMOS
			IF @EXISTS_IEP = 1
			BEGIN
				-- ACTUALIZAMOS LA INTERACCION
				UPDATE [dbo].[InteractionEvaluationPlan] 
					SET [IdCampaign] = @Campaign,
						[InteractionSection] = @NewSection,
						[InteractionPart] = @NewPart,
						[IdAgent] = @AgentId,
						[AgentName] = @AgentName,
						[InteractionDateStart] = @StartDate,
						[InteractionDateEnd] = @EndDate,
						[InteractionOrigin] = @Origin,
						[InteractionFormat] = @Format,
						[ManagementResult] = @Category1 + @Category2 + @Category3 + @Description, 
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[NeedI6Update] = 0,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND [IdInteraction] = @InteractionId
						AND [InteractionSection] = @OldSection
						AND [InteractionPart] = @OldPart
						AND [NeedI6Update] = 1
			END
			-- SI LA INTERACCION-SECTION-PART NO EXISTE, LA INSERTAMOS
			ELSE
			BEGIN
				-- INSERTAMOS LA INTERACCION  SELECT * FROM [dbo].[InteractionEvaluationPlan]
				INSERT INTO [dbo].[InteractionEvaluationPlan] (
					[Instance], [IdEvaluationPlan], [InteractionType], [IdCampaign], [IdInteraction], 
					[InteractionSection], [InteractionPart], [IdAgent], [AgentName], [InteractionDateStart], 
					[InteractionDateEnd], [InteractionDuration], [InteractionOrigin], [InteractionFormat], [ManagementResult], 
					[ContactId], [ContactName], [ContactAddress], [NeedI6Update], [CreatedByUserId], 
					[CreatedDate], [TimeStamp]
				) VALUES (
					@VCC, @CURRENT_EVALUATION_PLAN, 'CALL', @Campaign, @InteractionId, 
					@NewSection, @NewPart, @AgentId, @AgentName, @StartDate, 
					@EndDate, @DurationTime, @Origin, @Format, @Category1 + @Category2 + @Category3 + @Description, 
					@ContactId, @ContactName, @ContactAddress, CAST(0 AS BIT), 'system', 
					GETUTCDATE(), GETUTCDATE()
				)
			END

			-- DECLARAMOS UN CURSOR PARA RECORRER AUDITORES
			DECLARE RECURRENT_CURSOR_02 CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
        		-- SELECCIONAMOS LOS AUDITORES QUE TIENEN ASIGNADA LA INTERACCION
				SELECT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE AEP.[Instance] = @VCC 
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND AEP.[IdInteraction] = @InteractionId

			-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS RECORRIENDO
			DECLARE @CURRENT_AUDITOR VARCHAR(50) = ''

			-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
			OPEN RECURRENT_CURSOR_02

			FETCH NEXT FROM RECURRENT_CURSOR_02 INTO @CURRENT_AUDITOR
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- PARA EL PLAN ACTUAL BUSCAMOS SI EXISTE INTERACCION CON EL FOLDER CORRESPONDIENTE
				DECLARE @EXISTS_AEP BIT = 0
				SELECT @EXISTS_AEP = IIF(AEP.[IdInteraction] IS NOT NULL, CAST(1 AS BIT), CAST(0 AS BIT))
					FROM [dbo].[InteractionEvaluationPlan] AEP (NOLOCK) 
					WHERE AEP.[Instance] = @VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND AEP.[IdInteraction] = @InteractionId

				-- SI LA INTERACCION-FOLDER EXISTE, LA ACTUALIZAMOS
				IF @EXISTS_AEP = 1
				BEGIN
					-- ACTUALIZAMOS EL REGISTRO DE AUDITOREVALUATIONPLAN
					UPDATE [dbo].[AuditorEvaluationPlan] 
						SET [IdCampaign] = @Campaign,
							[IdAgent] = @AgentId,
							[InteractionFormat] = @Format,
							[ManagementResult] = @Category1 + @Category2 + @Category3 + @Description,
							[ContactId] = @ContactId,
							[ContactName] = @ContactName,
							[ContactAddress] = @ContactAddress,
							[LastModifiedByUserId] = 'system',
							[LastModifiedDate] = GETUTCDATE(),
							[TimeStamp] = GETUTCDATE()
						WHERE [Instance] = @VCC
							AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
							AND [IdInteraction] = @InteractionId
							AND [IdAuditor] = @CURRENT_AUDITOR
							AND [Completed] = 0
				END
				ELSE
				BEGIN
					-- INSERTAMOS EL REGISTRO A AUDITOREVALUATIONPLA
					INSERT INTO [dbo].[AuditorEvaluationPlan] (
						[Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [Completed], 
						[Score], [IdCampaign], [IdAgent], [InteractionDate], [InteractionType], 
						[InteractionDuration], [InteractionOrigin], [InteractionDateEnd], [ManagementResult], [ContactId], 
						[ContactName], [ContactAddress], [Status], [StatusDescription],
						[CreatedByUserId], [CreatedDate], [TimeStamp]
					) VALUES (
						@VCC, @CURRENT_EVALUATION_PLAN, @CURRENT_AUDITOR, @InteractionId, 0,
						0, @Campaign, @AgentId, @StartDate, 'CALL', 
						@DurationTime, @Origin, @EndDate, @Category1 + @Category2 + @Category3 + @Description, @ContactId,
						@ContactName, @ContactAddress, 1, 'NEW',
						'system', GETUTCDATE(), GETUTCDATE()
					)
				END

				FETCH NEXT FROM RECURRENT_CURSOR_02 INTO @CURRENT_AUDITOR
			END
			CLOSE RECURRENT_CURSOR_02
			DEALLOCATE RECURRENT_CURSOR_02

			FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_EVALUATION_PLAN
        END
        CLOSE RECURRENT_CURSOR
        DEALLOCATE RECURRENT_CURSOR

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN
	
	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]

	



	------------INICIO DE ACTUALIZACION DE ESTADOS DE PROCESS I6UPDATE --------------

	-- ACTUALIZAMOS EL ESTADO GENERAL DE PROCESS SOBRE LA ACTUALIZACION DE INTERACCIONES CALL I6
	UPDATE P 
		SET [Total] = PT.[Total]
			,[progress] = PT.[Progress]
			,[error] = PT.[Error]
			,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error],0) > 0 
											THEN 'I6_UPDATE_COMPLETED_WITH_ERROR' 
										WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error],0) = 0 
											THEN 'I6_UPDATE_COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON P.[vcc] = PT.[vcc] 
				AND PT.ProcessId = P.[Name] 
		WHERE PT.[Type] = 'i6update'

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
	UPDATE A
		SET [Status] = CASE 
				WHEN B.total >= 0 
						AND B.total <= B.[updated] + B.cancel 
						AND B.cancel > B.[updated] 
					THEN 'FAILED' 
				WHEN B.total >= 0 
						AND B.total <= B.[updated] + B.cancel 
					THEN 'COMPLETE' 
				ELSE 'INPROCESS_I6_UPDATE' 
				END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] AS A
		INNER JOIN (
			SELECT SUM(UT.total)									'total',
					SUM(UT.cancel)									'cancel',
					SUM(UT.[updated])								'updated',
					UT.processId									'processId',
					UT.vcc											'vcc'
				FROM (
					SELECT COUNT(1)										'total'
							,COUNT(A.[isCancel])						'cancel'
							,COUNT(IIF(A.[NeedI6Update] = 0, 1, 0))		'updated' 
							,PT.[ProcessId]								'processId'
							,PT.[vcc]									'vcc'
						FROM [dbo].[ProcessAudio] PA (NOLOCK)
						INNER JOIN [#ProgressTemp] PT 
							ON PA.[vcc] = PT.[vcc] 
								AND PA.ProcessId = PT.ProcessId 
								AND PT.[Percentage] = 1
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON PA.[VCC] = A.VCC 
								AND PA.[AudioId] = A.ID 
						WHERE PT.[Type] = 'i6update'
						GROUP BY PT.ProcessId, PT.vcc
				) UT 
				GROUP BY UT.processId, UT.vcc
		) B ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.[ProcessId]

	------------FIN DE ACTUALIZACION DE ESTADOS DE PROCESS I6UPDATE --------------



	  
	------------INICIO DE ACTUALIZACION DE ESTADOS DE PROCESS --------------

	UPDATE A
		SET [Total] = PT.[Total]
			,[progress] = PT.[Progress]
			,[error] = PT.[Error]
			,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error], 0) > 0 
											THEN 'COMPLETED_WITH_ERROR' 
										WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error], 0) = 0 
											THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM Process AS A
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON A.[vcc] = PT.[vcc] 
				AND A.[Name] = PT.ProcessId 
		WHERE PT.[Type] IS NULL

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
	UPDATE A
	SET [Status] = CASE 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
			ELSE 'INPROCESS_TRANSCRIPTION' 
			END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		SELECT ISNULL(SUM(UT.total), 0)					'total',
				ISNULL(SUM(UT.cancel), 0)				'cancel',
				ISNULL(SUM(UT.transcription), 0)		'transcription',
				UT.processId							'processId',
				UT.vcc									'vcc'
			FROM (
			SELECT COUNT(1)					total
					,COUNT(C.isCancel)			cancel
					,COUNT(C.IsTranscribed)		transcription 
					,B.ProcessId				processId
					,B.vcc						vcc
				FROM [ProcessAudio] A (NOLOCK)
				INNER JOIN [#ProgressTemp] B 
					ON A.[vcc] = B.[vcc] 
						AND A.ProcessId = B.ProcessId 
						-- AND B.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN Audio C (NOLOCK) 
					ON A.VCC = C.VCC 
						AND A.AudioId =C.ID 
						AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
						AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
				WHERE B.[Type] IS NULL
				GROUP BY B.ProcessId, B.vcc
			UNION
			SELECT 
				COUNT(1)						total
				,COUNT(AI.IsCancel)			cancel
				,COUNT(AI.IsTranscribed)		transcription
				,PT.[ProcessId]				processId
				,PT.[vcc]						vcc
				FROM [ProcessAsyncInteraction] PAI (NOLOCK)
				INNER JOIN [#ProgressTemp] PT
					ON PAI.[VCC] = PT.[vcc]
						AND PAI.[ProcessId] = PT.[ProcessId]
						-- AND PT.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN [AsyncInteraction] AI (NOLOCK) 
					ON AI.[VCC] = PT.[vcc]
						AND AI.[Channel] = PAI.[InteractionType]
						AND AI.[Folder] = PAI.[FormattedEndDate]
						AND AI.[Campaign] = PAI.[Campaign]
						AND AI.[ID] = PAI.[InteractionId]
				WHERE PT.[Type] IS NULL
				GROUP BY PT.ProcessId, PT.vcc
		) UT GROUP BY UT.processId, UT.vcc

	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	-- ACTUALIZAMOS EL ESTADO DE OTROS PROCESOS QUE ESTAN COMO FALLIDOS, COLGADOS, ETC QUE COINCIDEN CON LAS INTERACCIONES DEL PROCESS TERMINADO
	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
			,P.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT UT.[processId]							'processId',
					ISNULL(SUM(UT.[totalAudio]), 0)			'totalAudio',
					ISNULL(SUM(UT.[totalSucced]), 0)		'totalSucced',
					ISNULL(SUM(UT.[totalFailed]), 0)		'totalFailed'
				FROM (
					SELECT P.[Name] 'processId',
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
							ON PA.[VCC] = P.[VCC]
								AND PA.[ProcessId] = P.[Name]
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON A.[VCC] = PA.[VCC]
								AND A.[ID] = PA.[AudioId]
								AND A.[Section] = PA.[Section]
								AND A.[Part] = PA.[Part]
						WHERE 
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR 
							(P.[Total] = 0 AND P.[Percentage] = 0)
							-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
							--AND P.[StatusDescription] = 'IN_PROGRESS'
						GROUP BY P.[Name]
			
					UNION

					SELECT P.[Name],
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
							ON PAI.[VCC] = P.[vcc]
								AND PAI.[ProcessId] = P.[Name]
						INNER JOIN [AsyncInteraction] AI (NOLOCK) 
							ON AI.[VCC] = P.[vcc]
								AND AI.[Channel] = PAI.[InteractionType]
								AND AI.[Folder] = PAI.[FormattedEndDate]
								AND AI.[Campaign] = PAI.[Campaign]
								AND AI.[ID] = PAI.[InteractionId]
						WHERE 
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR 
							(P.[Total] = 0 AND P.[Percentage] = 0)
						GROUP BY P.[Name]
					) UT GROUP BY UT.[processId]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL -- EL NULL INDICA QUE ES PROCESS DE TRANSCRIPCION Y NO DE PLAN DE EVALUACION

	-- REGISTRAMOS LA(S) AGENDA(S) DE PLANTILLA PARA LOS PROCESS TERMINADO
	INSERT INTO [dbo].[BatchScheduleExecution] ([VCC], [Id], [BatchScheduleId], [ProcessId], [ExecutionDate], [Status], [CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT PTMP.[vcc],
				NEWID(),
				BS.[Id],
				PTMP.[ProcessId],
				GETUTCDATE(),
				'PENDING',
				'system',
				GETUTCDATE(),
				GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			LEFT JOIN [dbo].[BatchSchedule] BS (NOLOCK)
				ON BS.[VCC] = PTMP.[vcc]
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL -- EL NULL INDICA QUE ES PROCESS DE TRANSCRIPCION Y NO DE PLAN DE EVALUACION
				AND BS.[BatchType] = 'TEMPLATE'
				AND GETUTCDATE() >= BS.[StartDate]
				AND (
					BS.[EndDate] IS NULL 
					OR
					GETUTCDATE() < BS.[EndDate]
				)

	------------FIN DE ACTUALIZACION DE ESTADOS DE PROCESS --------------





	------------INICIO DE ACTUALIZACION DE ESTADOS DE ESTUDIOS --------------
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] IN ('study', 'template')
				
	--Eliminar StudyResultSummary
	         DELETE SRS FROM [dbo].[StudyResultSummary] SRS 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SRS.[VCC] 
	                       AND S.[Name] = SRS.[StudyId] 
	                       AND S.[TemplateId] = SRS.[TemplateId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRS.[TemplateThemeId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.ProcessId 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type]  IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SRS.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	                  
	           	        
	 -- Eliminar StudyResultSummaryDetail
	           	  DELETE SRSD FROM [dbo].[StudyResultSummaryDetail] SRSD 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SRSD.[VCC] 
	                       AND S.[Name] = SRSD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRSD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI 
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SRSD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.ProcessId 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type]  IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SRSD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	
   	 -- Eliminar StudyResultSummaryDetail
	           	  DELETE SD FROM [dbo].[StudyDetail] SD 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SD.[VCC] 
	                       AND S.[Name] = SD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI 
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.[ProcessId] 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type] IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], UPPER(PTMP.[Type]), PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] IN ('study', 'template')
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IN ('study', 'template')

	-- ACTUALIZAMOS LA EJECUCION RELACIONADA AL BATCH TEMPLATE TERMINADO
	UPDATE BSE 
		SET BSE.[Status] = 'FINISHED',
			BSE.[LastModifiedByUserId] = 'system',
			BSE.[LastModifiedDate] = GETUTCDATE()
		FROM [#ProgressTemp] PTMP
		INNER JOIN [dbo].[BatchScheduleExecution] BSE 
			ON BSE.[vcc] = PTMP.[vcc] 
				AND BSE.[BatchId] = PTMP.[TypeId] 
		WHERE PTMP.[Percentage] = 1 
			AND PTMP.[Type] = 'template'

	------------FIN DE ACTUALIZACION DE ESTADOS DE ESTUDIOS --------------





	------------INICIO DE ACTUALIZACION DE ESTADOS DE PLAN DE EVALUACION --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	UPDATE EP
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE 'IN_PROGRESS' END
			,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
				AND B.[Type] IS NULL 
				AND EP.[FilterByContentQueryName] IS NOT NULL 
				AND EP.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'evaluationPlan'
			
	-- UPDATE PARA INICIAR LA PARTE DE ANALISIS SEMANTICO/COGNITIVO CUANDO EL PROCESS TERMINOS
	UPDATE EP
		SET EP.[Total] = B.[Total]
			,EP.[progress] = B.[Progress]
			,EP.[error] = B.[Error]
			,EP.[percentage] = B.[Percentage]
			,EP.[StatusDescription] = CASE WHEN B.[Percentage] = 1 
												AND P.[Status] NOT LIKE '%I6_UPDATE%'
											--THEN CASE WHEN P.[StatusDescription] = 'FAILED' THEN 'CANCELLED_BY_FAILED_PROCESS'
											--		ELSE P.[StatusDescription]
											--		END
											THEN IIF (P.[StatusDescription] = 'FAILED', 'CANCELLED_BY_FAILED_PROCESS', P.[StatusDescription])
											ELSE 'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN B.[Percentage] = 1 
							--THEN CASE WHEN P.[StatusDescription] = 'FAILED' THEN 10 
							--		ELSE 5 END
							THEN IIF (P.[StatusDescription] = 'FAILED', 10, 5)
							ELSE 2 END
			,EP.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[Process] P (NOLOCK)
			ON P.[VCC] = EP.[Instance]
				AND P.[Name] = EP.[ProcessId] 
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
		WHERE EP.[FilterByContentQueryName] IS NULL 
				AND EP.[FilterByContentQuery] IS NULL 
				AND EP.[Evaluation_Mode] IN ('A', 'X')
				AND B.[Type] IS NULL 

	/*
	--OBTENGO ESTADOS DE PROCESO DE AUDIOS
	;WITH AudioStatus AS (
		SELECT D.[VCC]										'instance',
				D.[ProcessId]								'processId',
				COUNT(*) 									'total',
				SUM(IIF(A.[IsTranscribed] = 1, 1, 0))		'transcribed',
				SUM(IIF(A.[IsCancel] = 1, 1, 0))			'cancelled'
			FROM [dbo].[Audio] A (NOLOCK)
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON A.[ID] = IEP.[IdInteraction]
					AND A.[Section] = IEP.[InteractionSection]
					AND A.[Part] = IEP.[InteractionPart]
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = IEP.[Instance]
					AND EP.[ID] = IEP.[IdEvaluationPlan]
			INNER JOIN [dbo].[#ProgressTemp] D (NOLOCK)
				ON D.[vcc] = EP.[Instance]
					AND D.[ProcessId] = EP.ProcessId
					AND  D.[TypeId] = EP.Id
					AND D.[Type] = 'ability'
			GROUP BY D.[VCC], D.[ProcessId]
	)
	*/

	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES(FASE DE EVALUACION AUTOMATICA) DE LA TABLA TEMPORAL CUANDO EL PLAN ESTA EN STATUS 5 (ANALIZADO) O 6 (EVALUANDO)
	UPDATE EP
		SET EP.[Total] = B.[Total]
			,EP.[progress] = B.[Progress]
			,EP.[error] = B.[Error]
			,EP.[percentage] = B.[Percentage]
			,EP.[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error], 0) > 0 THEN 'EVALUATION_COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error], 0) = 0 THEN 'EVALUATION_COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN B.[Percentage] = 1 THEN 11 ELSE 6 END
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
				AND EP.Id = B.[TypeId] 
				AND B.[Type] = 'ability'
		WHERE EP.[Status] IN (5, 6)

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 11 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	UPDATE AEP 
		SET AEP.[Completed] = 1
			,[StatusDescription] = 'COMPLETED'
			,[LastModifiedByUserId] = 'system'
			,[LastModifiedDate] = GETUTCDATE()
			,[TimeStamp] = GETUTCDATE()
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
	WHERE EP.[Status] = 11
		AND AEP.[IdAuditor] = 'SPEECH' 
		AND (EP.[Evaluation_Mode] = 'A' OR EP.[Evaluation_Mode] = 'X') 
		AND B.[Type] = 'ability'



	/*************************************INICIO DE ACTUALIZACION DE TIPIFICACIONES***********************************************/
	
	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES(FASE DE TIPIFICACIONES) DE LA TABLA TEMPORAL
	UPDATE EP
		SET EP.[percentage] = TMP_P.[Percentage]
			,EP.[StatusDescription] = CASE WHEN TMP_P.[Percentage] = 1 AND  ISNULL(TMP_P.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN TMP_P.[Percentage] = 1 AND  ISNULL(TMP_P.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN TMP_P.[Percentage] = 1 THEN 7 ELSE 12 END
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] EP
		INNER JOIN [dbo].[#ProgressTemp] TMP_P 
			ON EP.[Instance] = TMP_P.[vcc] 
				AND EP.[ProcessId] = TMP_P.ProcessId 
				AND EP.Id = TMP_P.[TypeId] 
		WHERE EP.[Status] IN (11, 12)
			AND TMP_P.[Type] = 'tipification'

	/*************************************FIN DE ACTUALIZACION DE TIPIFICACIONES***********************************************/

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (
						PTMP.[Type] = 'ability' 
						OR 
						PTMP.[Type] = 'evaluationPlan'
					)
			WHERE EP.[Status] = 7
				AND PTMP.[Percentage] = 1 
				AND (
					PTMP.[Type] = 'ability' 
					OR 
					PTMP.[Type] = 'evaluationPlan'
				)



	-- REGISTRAMOS LA(S) AGENDA(S) DE PLANTILLA PARA LOS PROCESS TERMINADO
	INSERT INTO [dbo].[BatchScheduleExecution] ([VCC], [Id], [BatchScheduleId], [ProcessId], [ExecutionDate], [Status], [CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT PTMP.[vcc],
				NEWID(),
				BS.[Id],
				PTMP.[ProcessId],
				GETUTCDATE(),
				'PENDING',
				'system',
				GETUTCDATE(),
				GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			LEFT JOIN [dbo].[BatchSchedule] BS (NOLOCK)
				ON BS.[VCC] = PTMP.[vcc]
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan') -- EL NULL INDICA QUE ES PROCESS DE PLAN DE EVALUACION
				AND BS.[BatchType] = 'TEMPLATE'
				AND GETUTCDATE() >= BS.[StartDate]
				AND (
					BS.[EndDate] IS NULL 
					OR
					GETUTCDATE() < BS.[EndDate]
				)

	-- INICIO MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT PTMP.[vcc] 'VCC', 
				PTMP.[TypeId] 'EVALUATION_PLAN_ID'
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
			WHERE PTMP.[Percentage] = 1 
				AND (
					PTMP.[Type] = 'ability' 
					OR 
					PTMP.[Type] = 'evaluationPlan'
				)
			
	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION NUMERIC(5, 2) = 0

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- BUSCAMOS SI EXISTE RESULTS PARA EL PLAN ACTUAL
		IF NOT EXISTS (
			SELECT 1 
				FROM [dbo].[EvaluationResult] ER (NOLOCK) 
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		)
		BEGIN
			-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
			EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

			-- ACTUALIZAMOS A COMPLETED LOS REGISTROS AUDITOR_EVALUATION_PLAN DEL PLAN ACTUAL
			UPDATE AEP
				SET AEP.[Completed] = '1'
					,AEP.[StatusDescription] = 'COMPLETED'
					,AEP.[LastModifiedByUserId] = 'system'
					,AEP.[LastModifiedDate] = GETUTCDATE()
					,AEP.[TimeStamp] = GETUTCDATE()
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		END

		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS





	-- INICIO DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS(TERMINADA LA FASE AUTOMATICA(ESTADO 7), PASA A LA MANUAL(ESTADO 8) Y ACABADA LA MANUAL REGRESA AL ESTADO 7)

	DECLARE @CURRENT_AUDITOR_ID VARCHAR(50) = ''

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR_2 CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				PT.[vcc]								'VCC', 
				PT.[TypeId]								'EVALUATION_PLAN_ID',
				EF.[MinAutomaticQualification]			'MIN_AUTOMATIC_QUALIFICATION'
			FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
			INNER JOIN [dbo].[#ProgressTemp] PT 
				ON EP.[Instance] = PT.[vcc] 
					AND EP.[ProcessId] = PT.[ProcessId] 
					AND EP.[Id] = PT.[TypeId] 
					AND PT.[Type] = 'ability'
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			WHERE EP.[Status] = 7
				AND EP.[Evaluation_Mode] = 'X'

	-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
	OPEN MY_CURSOR_2
	FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EVALUAMOS SI EL AUDITOR SPEECH CALIFICO CON NOTA MAYOR O IGUAL AL ACEPTABLE MINIMO PARA LA PARTE AUTOMATICA
		IF EXISTS (
			SELECT 1
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND AEP.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
		)
		BEGIN
			-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
			UPDATE EP 
				SET EP.[percentage] = 0
					,EP.[StatusDescription] = 'IN_PROGRESS'
					,EP.[Status] = 8
					,EP.[LastModifiedDate] = GETUTCDATE() 
				FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
				WHERE EP.[Instance] = @CURRENT_VCC
					AND EP.[ID] = @CURRENT_EVALUATION_PLAN_ID

			-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS ID DE AUDITORES CORRESPONDIENTES AL PLAN
			DECLARE MY_AUDITOR_CURSOR CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
				FOR 
				-- CONSULTAMOS LOS ID DE AUDITORES
				SELECT DISTINCT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE  AEP.[Instance] = @CURRENT_VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND AEP.[IdAuditor] <> 'SPEECH'

			-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
			OPEN MY_AUDITOR_CURSOR
			FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- INSERTARMOS LOS REGISTROS DE ER QUE TENIA EL AUDITOR SPEECH
				INSERT INTO [dbo].[EvaluationResult] (
					[Instance], [IdCampaign], [IdInteraction], [IdAgent], [IdEvaluationFormat],
					[MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification],
					[OwnScore], [IdEvaluator], [EvaluationDate], [MaxAbilityScore], [IdEvaluationPlan], 
					[CreatedDate], [CreatedByUserId], [TimeStamp], [NotApplies], [ScoreDescription], 
					[CampaignDescription], [AgentDescription], [InteractionDateini], [InteractionDatefin], [InteractionAddress], 
					[AbilityOrder], [InteractionType], [IdAbilityEvaluationFormat], [IdAuditor], [Conditional]
				) 
					-- SELECCIONAMOS LOS RESULTADOS REGISTRADOS POR SPEECH
					SELECT ER.[Instance], ER.[IdCampaign], ER.[IdInteraction], ER.[IdAgent], ER.[IdEvaluationFormat],
							ER.[MinQualificationAcceptable], ER.[IdGroup], ER.[IdSubGroup], ER.[IdAbility], ER.[Qualification],
							ER.[OwnScore], ER.[IdEvaluator], ER.[EvaluationDate], ER.[MaxAbilityScore], ER.[IdEvaluationPlan], 
							ER.[CreatedDate], ER.[CreatedByUserId], GETUTCDATE(), ER.[NotApplies], ER.[ScoreDescription], 
							ER.[CampaignDescription], ER.[AgentDescription], ER.[InteractionDateini], ER.[InteractionDatefin], ER.[InteractionAddress], 
							ER.[AbilityOrder], ER.[InteractionType], ER.[IdAbilityEvaluationFormat], @CURRENT_AUDITOR_ID, ER.[Conditional]
						FROM [dbo].[EvaluationResult] ER (NOLOCK)
						INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
							ON AEP.[Instance] = ER.[Instance]
								AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
								AND AEP.[IdAuditor] = ER.[IdAuditor]
								AND AEP.[IdInteraction] = ER.[IdInteraction]
								AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
						WHERE ER.[Instance] = @CURRENT_VCC
							AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
							AND ER.[IdAuditor] = 'SPEECH'

				-- REABRIMOS LAS EVALUACIONES DE LAS INTERACCIONES CON SCORE MAYOR O IGUAL AL UMBRAL
				UPDATE [dbo].[AuditorEvaluationPlan]
					SET [Completed] = 0,
						[AutomaticScore] = [Score],
						[ManualScore] = 0,
						[StatusDescription] = 'NEW',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = @CURRENT_AUDITOR_ID

				FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			END
			CLOSE MY_AUDITOR_CURSOR
			DEALLOCATE MY_AUDITOR_CURSOR

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

			-- REMOVEMOS LOS REGISTROS DE SPEECH (AEP Y ER) QUE FUERON ASIGNADOS A LOS AUDITORES
			DELETE ER
				FROM [dbo].[EvaluationResult] ER
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND ER.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE SPEECH EN AEP QUE PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] = 'SPEECH'
					AND [Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE LOS OTROS AUDITORES QUE NO PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'
					AND [IdInteraction] IN (
						SELECT [IdInteraction] 
							FROM [dbo].[AuditorEvaluationPlan] 
							WHERE [Instance] = @CURRENT_VCC
								AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
								AND [IdAuditor] = 'SPEECH'
								AND [Score] < @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
					)

			-- ACTUALIZAMOS LOS CAMPOS SCORE DE LAS EVALUACIONES DE SPEECH
			UPDATE [dbo].[AuditorEvaluationPlan]
					SET [AutomaticScore] = [Score],
						[ManualScore] = 0,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = 'SPEECH'

		END
		ELSE
		BEGIN
			-- ELIMINAMOS LOS REGISTROS DE LOS OTROS AUDITORES (AEP)
			DELETE FROM [dbo].[AuditorEvaluationPlan] 
				WHERE  [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

		END

		FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	END
	CLOSE MY_CURSOR_2
	DEALLOCATE MY_CURSOR_2

	-- INVALIDAR LAS AUDITORIAS CUYO AUDIO PRESENTAN ALGUN ERROR
	UPDATE AEP
		SET AEP.[StatusDescription] = 'INVALID'
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK)
		    ON AEP.[Instance] = A.[VCC] 
		        AND AEP.[IdInteraction] = A.[ID]
		INNER JOIN [#ProgressTemp] PTMP (NOLOCK)
			ON AEP.[Instance] = PTMP.[vcc]
			    AND AEP.[IdEvaluationPlan] = PTMP.[TypeId]
		WHERE (
				A.[IsTranscribed] IS NULL 
				OR 
				A.[IsTranscribed]  <> 1
			)
		    AND (
				PTMP.[Type] = 'ability' 
				OR 
				PTMP.[Type] = 'evaluationPlan'
			)
		    -- AND A.[ErrorMessage] IN ('GET_AUDIO_REQUEST_FAILED','JSON_IDATHA_IS_NOT_FOUND','JSON_TRANSCRIPTION_CONTENT_IS_EMPTY')

	-- RECUPERAMOS LAS EVALUACIONES DE SPEECH DE LA TABLA AUDITOR EVALUATION PARA REPLICARLA

	/*
	-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
	UPDATE EP 
		SET EP.[percentage] = 0
			,EP.[StatusDescription] = 'IN_PROGRESS'
			,EP.[Status] = 8
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON EP.[Instance] = PT.[vcc] 
				AND EP.[ProcessId] = PT.[ProcessId] 
				AND EP.[Id] = PT.[TypeId] 
				AND PT.[Type] = 'ability'
		WHERE EP.[Status] = 7
			AND EP.[Evaluation_Mode] = 'X'
	*/
	

	-- FIN DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS





	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveI6InteractionAudio]...';


GO
ALTER PROCEDURE [dbo].[SaveI6InteractionAudio] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@OldSection				INT = NULL,
	@OldPart				INT = NULL,
	@NewSection				INT = NULL,
	@NewPart				INT = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@Format					VARCHAR(10) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@Category1				VARCHAR(100) = NULL,
	@Category2				VARCHAR(100) = NULL,
	@Category3				VARCHAR(100) = NULL,
	@Description			VARCHAR(100) = NULL,
	@Filename				VARCHAR(200) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@ProcessId				VARCHAR(50) = NULL
) AS 
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UNA VARIABLE PARA AYUDAR A LA ACTUALIZACION
		DECLARE @BD_A_ID VARCHAR(250) = NULL
		DECLARE @NEED_I6_UPDATE BIT = 1
		DECLARE @AGENT_NAME VARCHAR(100) = NULL -- NOMBRE DEL AGENTE
		DECLARE @EVALUATION_PLAN_ID VARCHAR(50) = NULL -- ID DEL PLAN EN CASO EXISTA

		-- ASIGNAMOS EL VALOR ACTUALIZADO DEL FLAG
		SELECT @BD_A_ID = A.[ID],
				@NEED_I6_UPDATE = A.[NeedI6Update]
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
				AND A.[Section] = @OldSection
				AND A.[Part] = @OldPart

		-- BUSCAMOS EL ID DEL PLAN EN CASO EXISTA
		SELECT @EVALUATION_PLAN_ID = EP.[ID]
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			WHERE EP.[Instance] = @VCC 
				AND EP.[ProcessId] = @ProcessId
				AND EP.[Status] = 1

		-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL AGENTE
		SELECT @AGENT_NAME = A.[Name]
			FROM [dbo].[Agent] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[AgentId] = @AgentId

		-- EN CASO REQUIERAN ACTUALIZACION POR UNICA VEZ
		IF @NEED_I6_UPDATE = 1 AND @ProcessId IS NOT NULL
		BEGIN
			-- VERIFICAMOS IS EXISTE
			IF @BD_A_ID IS NOT NULL
			BEGIN
				-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA AUDIO
				UPDATE [dbo].[Audio] 
					SET [Section] = @NewSection,
						[Part] = @NewPart,
						[Agent] = @AgentId,
						[AgentName] = @AGENT_NAME,
						[Format] = @Format,
						[Campaign]= @Campaign,
						[Type] = @Origin,
						[Category1] = @Category1,
						[Category2] = @Category2,
						[Category3] = @Category3,
						[Description] = @Description,
						[FileName] = @Filename,
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[NeedI6Update] = 0,
						[IsProcess] = NULL,
						[IsCancel] = NULL,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC
						AND [ID] = @InteractionId
						AND [Section] = @OldSection
						AND [Part] = @OldPart
						AND [NeedI6Update] = 1
						AND (
							[IsTranscribed] IS NULL 
							OR
							[IsTranscribed] <> 1
						)

				IF @@ROWCOUNT > 0
				BEGIN
					-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA PROCESSAUDIO
					UPDATE [dbo].[ProcessAudio]
						SET [Section] = @NewSection,
							[Part] = @NewPart
						WHERE [VCC] = @VCC
							AND [AudioId] = @InteractionId
							AND [Section] = @OldSection
							AND [Part] = @OldPart 
				END
			END
			ELSE
			BEGIN
				-- INSERTAMOS EL NUEVO AUDIO CUANDO NO RECIBIMOS SECTION Y PART
				INSERT INTO [dbo].[Audio] (
					[VCC], [Id], [Section], [Part], [Channel],
					[Number], [Format], [DurationTime], [Category1], [Category2],
					[Category3], [Description], [Filename], [Campaign], [Agent], 
					[AgentName], [Type], [StartDate], [EndDate], [ContactId], 
					[ContactName], [ContactAddress], [NeedI6Update], [CreatedByUserId], [CreatedDate], 
					[TimeStamp]
				)
				VALUES (
					@VCC, @InteractionId, @NewSection, @NewPart, 'CALL',
					@ContactAddress, @Format, @DurationTime, @Category1, @Category2,
					@Category3, @Description, @Filename, @Campaign, @AgentId, 
					@AGENT_NAME, @Origin, @StartDate, @EndDate, @ContactId, 
					@ContactName, @ContactAddress, 0, 'system', GETUTCDATE(), 
					GETUTCDATE()
				)

				INSERT INTO [dbo].[ProcessAudio] (
					[VCC], [ProcessId], [AudioId], [Section], [Part],
					[CreatedDate], [CreatedByUserId], [TimeStamp]
				)
				VALUES (
					@VCC, @ProcessId, @InteractionId, @NewSection, @NewPart,
					GETUTCDATE(), 'system', GETUTCDATE()
				)
			END 
		END

		-- ACTUALIZAMOS LOS REGISTROS DE PLAN
		EXEC [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan] 
			@VCC, @InteractionId, @OldSection, @OldPart, @NewSection,
			@NewPart, @StartDate, @EndDate, @DurationTime, @Format,
			@AgentId, @AGENT_NAME, @Campaign, @Origin, @Category1,
			@Category2, @Category3, @Description, @ContactId, @ContactName,
			@ContactAddress, @EVALUATION_PLAN_ID
			
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Creando Procedimiento [dbo].[SaveI6InteractionAsyncInteraction]...';


GO
CREATE PROCEDURE [dbo].[SaveI6InteractionAsyncInteraction] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Folder					VARCHAR(50) = NULL,
	@ExportedContent		VARCHAR(250) = NULL,
	@Channel				VARCHAR(25) = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Account				VARCHAR(50) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@DispositionTreePath	VARCHAR(50) = NULL,
	@DispositionCode		VARCHAR(50) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@TotalMessages			INT = NULL,
	@ProcessId				VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
	--select * from AsyncInteraction (nolock)
	--select * from InteractionEvaluationPlan (nolock)
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UNA VARIABLE PARA AYUDAR A LA ACTUALIZACION
		DECLARE @BD_AI_ID VARCHAR(250) = NULL
		DECLARE @NEED_I6_UPDATE BIT = 1
		DECLARE @AGENT_NAME VARCHAR(100) = NULL -- NOMBRE DEL AGENTE
		DECLARE @EVALUATION_PLAN_ID VARCHAR(50) = NULL -- ID DEL PLAN EN CASO EXISTA

		-- ASIGNAMOS EL VALOR ACTUALIZADO DEL FLAG
		SELECT @BD_AI_ID = AI.[Id],
				@NEED_I6_UPDATE = AI.[NeedI6Update]
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			WHERE AI.[VCC] = @VCC
				AND AI.[ID] = @InteractionId
				AND AI.[Folder] = @Folder

		-- BUSCAMOS EL ID DEL PLAN EN CASO EXISTA
		SELECT @EVALUATION_PLAN_ID = EP.[ID]
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			WHERE EP.[Instance] = @VCC 
				AND EP.[ProcessId] = @ProcessId
				AND EP.[Status] < 5
		
		-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL AGENTE
		SELECT @AGENT_NAME = A.[Name]
			FROM [dbo].[Agent] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[AgentId] = @AgentId
		
		-- EN CASO REQUIERAN ACTUALIZACION POR UNICA VEZ
		IF @NEED_I6_UPDATE = 1 AND @ProcessId IS NOT NULL
		BEGIN
			print @BD_AI_ID
			-- VERIFICAMOS IS EXISTE
			IF @BD_AI_ID IS NOT NULL
			BEGIN
				PRINT 'UPDATE'
				-- ACTUALIZAMOS LA TABLA DE LA INTERACCION EN LA TABLA ASYNC_INTERACTION
				UPDATE [dbo].[AsyncInteraction]
					SET [ExportedContent] = @ExportedContent,
						[Campaign]= @Campaign,
						[StartDate] = @StartDate,
						[EndDate] = @EndDate,
						[Account] = @Account,
						[Initiative] = @Origin,
						[LastTakedAgent] = @AgentId,
						[LastTakedAgentName] = @AGENT_NAME,
						[DurationTime] = @DurationTime,
						[DispositionTreePath] = @DispositionTreePath,
						[DispositionCode] = @DispositionCode,
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[TotalMessages] = @TotalMessages,
						[NeedI6Update] = 0,
						[IsProcess] = NULL,
						[IsCancel] = NULL,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC
						AND [ID] = @InteractionId
						AND [Folder] = @Folder
						AND [NeedI6Update] = 1
						AND (
							[IsTranscribed] IS NULL 
							OR
							[IsTranscribed] <> 1
						)

				-- ACTUALIZAMOS EL CAMPAIGN Y ENDDATE EN LA INTERACCION EN LA TABLA PROCESSAUDIO
				UPDATE [dbo].[ProcessAsyncInteraction]
					SET [Campaign] = @Campaign,
						[EndDate] = @EndDate,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC
						AND [InteractionId] = @InteractionId
						AND [FormattedEndDate] = @Folder 
						AND [ProcessId] = @ProcessId
			END
			ELSE
			BEGIN
				-- SELECT * FROM AsyncInteraction (NOLOCK)
				-- SELECT * FROM ProcessAsyncInteraction (NOLOCK)
				-- INSERTAMOS EL REGISTRO EN ASYNC_INTERACTION
				INSERT INTO [dbo].[AsyncInteraction] (
					[VCC], [ID], [Folder], [ExportedContent], [Channel], 
					[Campaign], [StartDate], [EndDate], [Account], [Initiative], 
					[ContactId], [ContactName], [ContactAddress], [LastTakedAgent], [LastTakedAgentName], 
					[TotalMessages], [DurationTime], [AttentionTime], [DispositionCode], [DispositionTreePath], 
					[NeedI6Update], [LastModifiedByUserId], [LastModifiedDate], [TimeStamp]
				) VALUES (
					@VCC, @InteractionId, @Folder, @ExportedContent, @Channel, 
					@Campaign, @StartDate, @EndDate, @Account, @Origin, 
					@ContactId, @ContactName, @ContactAddress, @AgentId, @AGENT_NAME, 
					@TotalMessages, @DurationTime, @DurationTime, @DispositionCode, @DispositionTreePath, 
					0, 'system', GETUTCDATE(), GETUTCDATE()
				)

				-- INSERTAMOS EL REGISTRO EN PROCESS_ASYNC_INTERACTION
				INSERT INTO [dbo].[ProcessAsyncInteraction] (
					[VCC], [ProcessId], [InteractionType], [Campaign], [InteractionId],
					[EndDate], [FormattedEndDate], [CreatedDate], [CreatedByUserId], [TimeStamp]
				) VALUES (
					@VCC, @ProcessId, @Channel, @Campaign, @InteractionId, 
					@EndDate, @Folder, GETUTCDATE(), 'system', GETUTCDATE()
				)
			END
		END

		-- ACTUALIZAMOS LOS REGISTROS DE PLAN
		EXEC [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan] 
			@VCC, @InteractionId, @Folder, @ExportedContent, @Channel,  
			@StartDate, @EndDate, @DurationTime, @AgentId, @AGENT_NAME, 
			@Campaign, @Account, @Origin, @DispositionTreePath, @DispositionCode, 
			@ContactId, @ContactName, @ContactAddress, @TotalMessages, @EVALUATION_PLAN_ID

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Actualizando Procedimiento [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Actualización completada.';


GO
