PRINT N'Altering Function [dbo].[GetGlobalSearchInteractions]...';
GO
ALTER PROCEDURE [dbo].[GetGlobalSearchInteractions] (
	@VCC Varchar(50) = NULL,
	@Agents Varchar(MAX) = NULL,
   	@Campaigns VARCHAR(MAX) = NULL,
 	@InteractionDateFrom VARCHAR(50) = '1980-01-01T00:00:00',
    @InteractionDateTo VARCHAR(50) = '2050-01-01T23:59:59',	
    @InteractionOrigins Varchar(50) = NULL,	
	@InteractionTypes Varchar(50) = NULL,
	@InteractionIds     VARCHAR(MAX) = NULL,
	@ContactAddress Varchar(300) = NULL,
	@DispositionCodes VARCHAR(MAX)
	
	
)
AS
BEGIN
	SET NOCOUNT ON	
	
	--LISTAMOS INTERACCIONES ENCONTRADAS CON LOS  FILTROS BASICOS
	
	--INTERACCIONES DE PLANES MANUALES
	--SELECT * FROM InteractionEvaluationPlan
	CREATE TABLE #AllInteractionEvaluationPlan
	(
		[interactionId]				VARCHAR(250),
		[interactionSection]		INT,
		[interactionPart]			INT,	
		[interactionType]			VARCHAR(50),
		[interactionDateStart]		DATETIME,
		[interactionDateEnd]		DATETIME,
		[agentId]					VARCHAR(50),
		[campaignId]				VARCHAR(50),
		[interactionOrigin]			VARCHAR(50),
		[contactAddress]			VARCHAR(50),
		[interactionDuration]		INT,
		[evaluationPlanId]			VARCHAR(50),
		[processId]						VARCHAR(50),
		[evaluation_Mode]			VARCHAR(50),
		RN							INT
		
	)
	IF (@InteractionIds IS NULL OR  @InteractionIds = '')
	BEGIN
		INSERT INTO #AllInteractionEvaluationPlan
			SELECT DISTINCT
			IEP.[IdInteraction]				'interactionId',
			IEP.[InteractionSection]		'interactionSection',
			IEP.[InteractionPart]			'interactionPart',	
			IEP.[InteractionType]			'interactionType',
			IEP.[InteractionDateStart]		'interactionDateStart',
			IEP.[InteractionDateEnd]		'interactionDateEnd',
			IEP.[IdAgent]					'agentId',
			IEP.[IdCampaign]				'campaignId',
			IEP.[InteractionOrigin]			'originId',
			IEP.[ContactAddress]			'contactAddress',
			IEP.[InteractionDuration]		'duration',
			IEP.[IdEvaluationPlan]			'evaluationPlanId',
			NULL							'processId',
			EP.[Evaluation_Mode]			'evaluation_mode',
			
			RN = ROW_NUMBER() OVER(PARTITION BY IEP.[Instance],IEP.[IdInteraction] ORDER BY IEP.[CreatedDate] DESC)

		
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN dbo.[EvaluationPlan] EP (NOLOCK)
				 ON IEP.[Instance] = EP.[Instance]
					AND IEP.[IdEvaluationPlan] = EP.[ID]

			WHERE IEP.[Instance] = @VCC			
				AND	(
						ISNULL(LEN(@Agents), 0) = 0
						OR
						[IdAgent]  IN (SELECT Value FROM [dbo].[split](@Agents, ','))
					)
	
				AND (
						ISNULL(LEN(@Campaigns), 0) = 0
						OR
						[IdCampaign]  IN (SELECT Value FROM [dbo].[split](@Campaigns, ','))
					)
	
				AND (
						ISNULL(LEN(@InteractionOrigins), 0) = 0
						OR
						[InteractionOrigin]  IN (SELECT Value FROM [dbo].[split](@InteractionOrigins, ','))
					)

				AND	(
						ISNULL(LEN(@InteractionTypes), 0) = 0
						OR
						[InteractionType]  IN (SELECT Value FROM [dbo].[split](@InteractionTypes, ','))
					)	

	

				AND (
						ISNULL(LEN(@ContactAddress), 0) = 0
						OR
						[ContactAddress] LIKE '%' + @ContactAddress + '%'
					)
    
				AND (
						ISNULL(LEN(@DispositionCodes), 0) = 0
						OR
						[ManagementResult] IN (SELECT Value FROM [dbo].[split](@DispositionCodes, ','))
					)
				AND (
						IEP.InteractionDateEnd BETWEEN @InteractionDateFrom AND @InteractionDateTo
					)

					
	END
	ELSE 
	BEGIN
		INSERT INTO #AllInteractionEvaluationPlan
			SELECT DISTINCT
			IEP.[IdInteraction]				'interactionId',
			IEP.[InteractionSection]		'interactionSection',
			IEP.[InteractionPart]			'interactionPart',	
			IEP.[InteractionType]			'interactionType',
			IEP.[InteractionDateStart]		'interactionDateStart',
			IEP.[InteractionDateEnd]		'interactionDateEnd',
			IEP.[IdAgent]					'agentId',
			IEP.[IdCampaign]				'campaignId',
			IEP.[InteractionOrigin]			'originId',
			IEP.[ContactAddress]			'contactAddress',
			IEP.[InteractionDuration]		'duration',
			IEP.[IdEvaluationPlan]			'evaluationPlanId',
			NULL							'processId',
			EP.[Evaluation_Mode]			'evaluation_mode',
			
			RN = ROW_NUMBER() OVER(PARTITION BY IEP.[Instance],IEP.[IdInteraction] ORDER BY IEP.[CreatedDate] DESC)

		
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN dbo.[EvaluationPlan] EP (NOLOCK)
				 ON IEP.[Instance] = EP.[Instance]
					AND IEP.[IdEvaluationPlan] = EP.[ID]

			WHERE IEP.[Instance] = @VCC			
					AND [IdInteraction]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))				
		
	END

		DROP TABLE IF EXISTS #DistinctInteractionEvaluationPlan
	    SELECT [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode]
			INTO  #DistinctInteractionEvaluationPlan
			FROM #AllInteractionEvaluationPlan 
			WHERE RN = 1

	
	--INTERACCIONES DE CALL DE PLANES AUTOMATICOS QUE AUN NO EXISTAN EN EL PRIMER LISTADO

	CREATE TABLE #AllInteractionProcess
	(
		[interactionId]				VARCHAR(250),
		[interactionSection]		INT,
		[interactionPart]			INT,	
		[interactionType]			VARCHAR(50),
		[interactionDateStart]		DATETIME,
		[interactionDateEnd]		DATETIME,
		[agentId]					VARCHAR(50),
		[campaignId]				VARCHAR(50),
		[interactionOrigin]			VARCHAR(50),
		[contactAddress]			VARCHAR(50),
		[interactionDuration]		INT,
		[evaluationPlanId]			VARCHAR(50),
		[processId]						VARCHAR(50),
		[evaluation_Mode]			VARCHAR(50),
		RN							INT
		
	)

	IF (@InteractionIds IS NULL OR  @InteractionIds = '')
	BEGIN
		INSERT INTO #AllInteractionProcess
			SELECT DISTINCT
			A.[ID]					'interactionId',
			A.[Section]				'interactionSection',
			A.[Part]				'interactionPart',	
			A.[Channel]				'interactionType',
			A.[StartDate]			'interactionDateStart',
			A.[EndDate]				'interactionDateEnd',
			A.[Agent]				'agentId',
			A.[Campaign]			'campaignId',
			A.[Type]				'originId',
			A.[ContactAddress]		'contactAddress',
			A.[DurationTime]		'duration',
			NULL					'evaluationPlanId',
			PA.[ProcessId]			'processId',
			'A'						'evaluation_mode',
			RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC],A.[ID] ORDER BY A.[CreatedDate] DESC)
	

			FROM dbo.[Audio] A (NOLOCK)
			INNER JOIN dbo.[ProcessAudio] PA (NOLOCK)
				ON  A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId] 
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]

			WHERE A.[VCC] = @VCC 
				AND  A.[IsTranscribed] = 1
				AND	(
						ISNULL(LEN(@Agents), 0) = 0
						OR
						[Agent]  IN (SELECT Value FROM [dbo].[split](@Agents, ','))
					)
	
				AND (
						ISNULL(LEN(@Campaigns), 0) = 0
						OR
						[Campaign]  IN (SELECT Value FROM [dbo].[split](@Campaigns, ','))
					)
		
				AND (
						ISNULL(LEN(@InteractionOrigins), 0) = 0
						OR
						[Type]  IN (SELECT Value FROM [dbo].[split](@InteractionOrigins, ','))
					)

				AND	(
						ISNULL(LEN(@InteractionTypes), 0) = 0
						OR
						[channel]  IN (SELECT Value FROM [dbo].[split](@InteractionTypes, ','))
					)	

				--AND (
				--		ISNULL(LEN(@InteractionIds), 0) = 0
				--		OR
				--		[Id]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))
				--	)

				AND (
						ISNULL(LEN(@ContactAddress), 0) = 0
						OR
						[ContactAddress] LIKE '%' + @ContactAddress + '%'
					)
		
				AND (
						ISNULL(LEN(@DispositionCodes), 0) = 0
						OR
						[Description] IN (SELECT Value FROM [dbo].[split](@DispositionCodes, ','))
					)

				AND (
						A.EndDate BETWEEN @InteractionDateFrom AND @InteractionDateTo
					)

				AND  [Id] NOT IN (SELECT interactionId FROM #DistinctInteractionEvaluationPlan)
					
				
				
	END		
	ELSE
	BEGIN
		INSERT INTO #AllInteractionProcess
			SELECT DISTINCT
			A.[ID]					'interactionId',
			A.[Section]				'interactionSection',
			A.[Part]				'interactionPart',	
			A.[Channel]				'interactionType',
			A.[StartDate]			'interactionDateStart',
			A.[EndDate]				'interactionDateEnd',
			A.[Agent]				'agentId',
			A.[Campaign]			'campaignId',
			A.[Type]				'originId',
			A.[ContactAddress]		'contactAddress',
			A.[DurationTime]		'duration',
			NULL					'evaluationPlanId',
			PA.[ProcessId]			'processId',
			'A'						'evaluation_mode',
			RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC],A.[ID] ORDER BY A.[CreatedDate] DESC)
	

			FROM dbo.[Audio] A (NOLOCK)
			INNER JOIN dbo.[ProcessAudio] PA (NOLOCK)
				ON  A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId] 
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]

			WHERE A.[VCC] = @VCC
					AND A.[IsTranscribed] = 1
					AND A.[ID]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))	
					AND A.[ID] NOT IN (SELECT interactionId FROM #DistinctInteractionEvaluationPlan)
					
					
				
				
	END

	DROP TABLE IF EXISTS #DistinctInteractionProcess
	    SELECT [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode]
			INTO  #DistinctInteractionProcess
			FROM #AllInteractionProcess WHERE RN = 1	

	--LISTAMOS INTERACCIONES DE TEXTO DE PLANES AUTOMATICOS QUE AUN NO EXISTAN EN UN PLAN DE EVALUACION 
	CREATE TABLE #AllTextInteractionProcess
	(
		[interactionId]				VARCHAR(250),
		[interactionSection]		INT,
		[interactionPart]			INT,	
		[interactionType]			VARCHAR(50),
		[interactionDateStart]		DATETIME,
		[interactionDateEnd]		DATETIME,
		[agentId]					VARCHAR(50),
		[campaignId]				VARCHAR(50),
		[interactionOrigin]			VARCHAR(50),
		[contactAddress]			VARCHAR(50),
		[interactionDuration]		INT,
		[evaluationPlanId]			VARCHAR(50),
		[processId]						VARCHAR(50),
		[evaluation_Mode]			VARCHAR(50),
		RN							INT
		
	)
	IF (@InteractionIds IS NULL OR  @InteractionIds = '')
	BEGIN
		INSERT INTO #AllTextInteractionProcess
			SELECT DISTINCT
			ASY.[ID]				'interactionId',
			0						'interactionSection',
			0						'interactionPart',
			ASY.[Channel]			'interactionType',
			ASY.[StartDate]			'interactionDateStart',
			ASY.[EndDate]			'interactionDateEnd',
			ASY.[FirstTakedAgent]	'agentId',
			ASY.[Campaign]			'campaignId',
			ASY.[Initiative]		'originId',
			ASY.[ContactAddress]	'contactAddress',
			ASY.[DurationTime]		'duration',
			NULL					'evaluationPlanId',
			PASY.[ProcessId]		'processId',
			'A'						'evaluation_mode',
			RN = ROW_NUMBER() OVER(PARTITION BY ASY.[VCC],ASY.[ID] ORDER BY ASY.[CreatedDate] ASC)


			FROM dbo.[AsyncInteraction] ASY (NOLOCK)
			INNER JOIN dbo.[ProcessAsyncInteraction] PASY  (NOLOCK)
				ON ASY.[VCC] = PASY.[VCC]
					AND ASY.[ID] = PASY.[InteractionId]
					AND ASY.[EndDate] = PASY.[EndDate]


			WHERE ASY.[VCC] = @VCC	
				AND ASY.[IsTranscribed] = 1
				AND	(
						ISNULL(LEN(@Agents), 0) = 0
						OR
						[FirstTakedAgent]  IN (SELECT Value FROM [dbo].[split](@Agents, ','))
					)
	
				AND	(
						ISNULL(LEN(@Campaigns), 0) = 0
						OR
						ASY.[Campaign]  IN (SELECT Value FROM [dbo].[split](@Campaigns, ','))
					)
		
				AND (
						ISNULL(LEN(@InteractionOrigins), 0) = 0
						OR
						[Initiative]  IN (SELECT Value FROM [dbo].[split](@InteractionOrigins, ','))
					)

				AND	(
						ISNULL(LEN(@InteractionTypes), 0) = 0
						OR
						[channel]  IN (SELECT Value FROM [dbo].[split](@InteractionTypes, ','))
					)	

				--AND (
				--		ISNULL(LEN(@InteractionIds), 0) = 0
				--		OR
				--		[Id]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))
				--	)

				AND (
						ISNULL(LEN(@ContactAddress), 0) = 0
						OR
						[ContactAddress] LIKE '%' + @ContactAddress + '%'
					)
		
				AND (
						ISNULL(LEN(@DispositionCodes), 0) = 0
						OR
						[DispositionTreePath] IN (SELECT Value FROM [dbo].[split](@DispositionCodes, ','))
					)

				AND ASY.EndDate BETWEEN @InteractionDateFrom AND @InteractionDateTo
					
				AND ASY.[ID] NOT IN (SELECT interactionId FROM #DistinctInteractionEvaluationPlan)

				
	END
	ELSE
	BEGIN
		INSERT INTO #AllTextInteractionProcess
			SELECT DISTINCT
			ASY.[ID]				'interactionId',
			0						'interactionSection',
			0						'interactionPart',
			ASY.[Channel]			'interactionType',
			ASY.[StartDate]			'interactionDateStart',
			ASY.[EndDate]			'interactionDateEnd',
			ASY.[FirstTakedAgent]	'agentId',
			ASY.[Campaign]			'campaignId',
			ASY.[Initiative]		'originId',
			ASY.[ContactAddress]	'contactAddress',
			ASY.[DurationTime]		'duration',
			NULL					'evaluationPlanId',
			PASY.[ProcessId]		'processId',
			'A'						'evaluation_mode',
			RN = ROW_NUMBER() OVER(PARTITION BY ASY.[VCC],ASY.[ID] ORDER BY ASY.[CreatedDate] ASC)


			FROM dbo.[AsyncInteraction] ASY
			INNER JOIN dbo.[ProcessAsyncInteraction] PASY 
				ON ASY.[VCC] = PASY.[VCC]
					AND ASY.[ID] = PASY.[InteractionId]
					AND ASY.[EndDate] = PASY.[EndDate]


			WHERE ASY.[VCC] = @VCC	
					AND ASY.[IsTranscribed] = 1
					AND ASY.[ID]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))	
					AND ASY.[ID] NOT IN (SELECT interactionId FROM #DistinctInteractionEvaluationPlan)
		

	END

	
	
	DROP TABLE IF EXISTS #DistinctTextInteractionProcess
	    SELECT [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode]
			INTO   #DistinctTextInteractionProcess
			FROM #AllTextInteractionProcess WHERE RN = 1	
	
	--LISTADO CONSOLIDADO 
	
	SELECT  [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode] 
	FROM #DistinctInteractionEvaluationPlan
	UNION
	SELECT  [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode] 
	FROM #DistinctInteractionProcess
	UNION
	SELECT  [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode] 
	FROM #DistinctTextInteractionProcess
		
	SET NOCOUNT OFF
	
END

PRINT N'Altering Function [dbo].[GetBillingInteractions]...';
GO
ALTER PROCEDURE [dbo].[GetBillingInteractions] (
	@VCC					VARCHAR(50) = NULL,
	@SecondsPerRequest		DECIMAL(18, 5) = 0,
	@CharsPerPhrase			DECIMAL(18, 5) = 0,
	@Channel				VARCHAR(25) = NULL,
	@Retranscription		BIT = 0
	
)
AS
BEGIN
	
	-- SEGUN EL TIPO DE CANAL DEFINIMOS LA FUNCION
	IF @Channel = 'CALL'
	BEGIN
		-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
		DECLARE @VCC_TYPE VARCHAR(50) = ''
		
		-- RECUPERAMOS EL TIPO DE VCC
		SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC

		-- CREAMOS UNA TEMPORAL PARA AUDIO CON SU DEFINICION
		CREATE TABLE #INNER_AUDIO (
			[VCC] VARCHAR(50),
			[ID] VARCHAR(100),
			[Section] NUMERIC(5,0),
			[Part] NUMERIC(5,0), 
			[DurationTime] NUMERIC(12,0), 
			[TotalPhrases] INT,
			[IsProcess] BIT,
			[IsTranscribed] BIT,
			[IsCancel] BIT
		)
		
		-- SEGUN EL TIPO DE VCC COMPLETAMOS EL FROM
		IF @VCC_TYPE <> 'I6' -- I6
		BEGIN
			--OBTENEMOS TODOS AUDIOS RELACIONADOS A LA BUSQUEDA
			INSERT INTO #INNER_AUDIO
				SELECT DISTINCT A.[VCC],
								A.[ID],
								A.[Section],
								A.[Part],
								A.[DurationTime],
								A.[TotalPhrases],
								A.[IsProcess],
								A.[IsTranscribed],
								A.[IsCancel]
					FROM [dbo].[Audio] A (NOLOCK)
					WHERE A.[VCC] = @VCC
		END
		ELSE
	    BEGIN
			-- GENERAMOS EL 1ER RESUMEN DE AUDIOS
			;WITH CTE_AUDIO AS (
				SELECT DISTINCT A.[VCC],
								A.[ID],
								A.[Section],
								A.[Part],
								A.[DurationTime],
								A.[TotalPhrases],
								A.[IsProcess],
								A.[IsTranscribed],
								A.[IsCancel],
								RN = ROW_NUMBER() OVER(PARTITION BY A.[ID] ORDER BY A.[EndDate] DESC)
					FROM [dbo].[Audio] A (NOLOCK)
					WHERE A.[VCC] = @VCC
			)

			--OBTENEMOS TODOS AUDIOS RELACIONADOS A LA BUSQUEDA
			INSERT INTO #INNER_AUDIO
				SELECT CTE.[VCC],
						CTE.[ID],
						CTE.[Section],
						CTE.[Part],
						CTE.[DurationTime],
						CTE.[TotalPhrases],
						CTE.[IsProcess],
						CTE.[IsTranscribed],
						CTE.[IsCancel] 
					FROM CTE_AUDIO CTE
					WHERE CTE.[RN] = 1
				
		END
		
		-- HACEMOS LA BUSQUEDA
		SELECT SUM(CASE WHEN A.[IsTranscribed] = 1 
								AND @Retranscription = 0 
							THEN 1 ELSE 0 END)															'alreadyTranscribedAudio',
				SUM(CASE WHEN A.[IsTranscribed] = 1 
								AND @Retranscription = 0 
							THEN A.[DurationTime] ELSE 0 END)											'alreadyTranscribedDurationTime',
				SUM(CASE WHEN (A.[IsProcess] = 1 
								AND A.[IsTranscribed] IS NULL 
								AND A.[IsCancel] IS NULL) 
							THEN 1 ELSE 0 END)															'inProcessAudio',
				SUM(CASE WHEN (A.[IsProcess] = 1 
								AND A.[IsTranscribed] IS NULL 
								AND A.[IsCancel] IS NULL) 
							THEN A.[DurationTime] ELSE 0 END)											'inProcessDurationTime',
				'CALL'																				'interactionType',
				SUM(CASE WHEN (
					A.[IsProcess] IS NULL 
					OR
					@Retranscription = 1
					OR 
					(
						A.[IsProcess] = 1 
						AND 
						A.[IsCancel] = 1
					)
				) THEN 1 ELSE 0 END)																	'notTranscribedAudio',
				SUM(CASE WHEN (
					A.[IsProcess] IS NULL 
					OR
					@Retranscription = 1
					OR (
						A.[IsProcess] = 1 
						AND 
						A.[IsCancel] = 1
					)
				--) THEN A.[DurationTime] ELSE 0 END)														'notTranscribedDurationTime',
				) THEN IT.[AttentionTime] ELSE 0 END)														'notTranscribedDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1  
								AND A.[TotalPhrases] IS NOT NULL
							THEN A.[TotalPhrases] ELSE 0 END)											'totalPhrases',
				SUM(CASE WHEN (A.[IsProcess] IS NULL 
								OR (A.[IsProcess] = 1 
									AND A.[IsCancel] = 1)
								OR (A.[TotalPhrases] IS NULL)) 
							THEN (IT.[AttentionTime] / @SecondsPerRequest) ELSE 0 END)					'totalRawPhrases',
				SUM(IT.[AttentionTime] / @SecondsPerRequest)											'averageModelRequest' 
			FROM [#InteractionsTemp] IT
			INNER JOIN [dbo].[VCC] V (NOLOCK)
				ON V.[VCC] = IT.[VCC]
			LEFT JOIN [#INNER_AUDIO] A 
				ON A.[VCC] = IT.[VCC]
					AND  A.[ID] = IT.[InteractionId]
					AND (
						(
							V.[Type] <> 'I6'
							AND 
							A.[Section] = IT.[Section]
							AND 
							A.[Part] = IT.[Part]
						)
						OR 
						(
							V.[Type] = 'I6'
						)
					)
			WHERE IT.[VCC] = @VCC

		-- ELIMINAMOS LA TABLA TEMPORAL
		DROP TABLE IF EXISTS #INNER_AUDIO
	END
	ELSE
	BEGIN
		-- DECLARAMOS UNA VARIABLE PARA PARA EL TOTALDE RESULTADOS
		DECLARE @TOTAL_INTERACTIONS INT = 0

		-- SETTEAMOS EL NUMERO DE REGISTROS A LA VARIABLE DE TOTAL
		SELECT @TOTAL_INTERACTIONS = COUNT(*) FROM [#InteractionsTemp]

		IF @TOTAL_INTERACTIONS = 0 
		BEGIN
			-- SI NO EXISTEN RESULTADOS EN HD LLENAMOSUN RESULTADOS CON 0
			SELECT @Channel																					'interactionType',
					0																						'totalInteractionDetails',
					0																						'alreadyTranscribedInteraction',
					0																						'inProcessInteraction',
					0																						'notTranscribedInteraction',
					0																						'totalPhrases',
					0																						'totalRawChars',
					0																						'totalRawPhrases'
		END 
		ELSE
		BEGIN
			-- CRUZAMOS LA TABLA TEMPORAL DE INTERACCIONES ASINCRONAS CON LA TABLA LOCAL INTERACTION PARA LAS INTERACCIONES ASINCRONAS YA REGISTRADAS
			SELECT ISNULL(IT.[Channel], @Channel)															'interactionType',
					COUNT(*)																				'totalInteractionDetails',
					SUM(CASE WHEN (AI.[VCC] IS NOT NULL 
						AND AI.[IsTranscribed] = 1) THEN 1 ELSE 0 END)										'alreadyTranscribedInteraction',
					0																						'inProcessInteraction',
					SUM(CASE WHEN (AI.[VCC] IS NULL 
						OR AI.[IsTranscribed] <> 1) THEN 1 ELSE 0 END)										'notTranscribedInteraction',
					SUM(ISNULL(AI.[TotalPhrases], 0))														'totalPhrases',
					-- CUANDO TENEMOS VALIDPHRASES, YA NO CONTAMOS LAS RAWCHAR 
					SUM(
						CASE WHEN (AI.[TotalPhrases] IS NULL 
								OR AI.[TotalPhrases] = 0)
						THEN (
							ISNULL(AI.[RawChar], ISNULL(IT.[rawChar], 0))
						)
						ELSE 0 END
					)																						'totalRawChars',
					SUM(
						CASE WHEN (AI.[TotalPhrases] IS NULL 
								OR AI.[TotalPhrases] = 0)
						THEN (
							-- SI RAWCHAR ES NULL, SE DEBE VALUAR COMO MINIMO 1 FRASE(@CharsPerPhrase)
							-- CEILING(ISNULL(AI.[RawChar], ISNULL(HDI.[rawChar], @CharsPerPhrase)) * 1.00 / @CharsPerPhrase)
							CEILING(ISNULL(AI.[RawChar], ISNULL(IT.[RawChar], 0)) * 1.00 / @CharsPerPhrase)
						)
						ELSE 0 END
					)																						'totalRawPhrases' 
				FROM [#InteractionsTemp] IT
				LEFT JOIN [dbo].[AsyncInteraction] AI 
					ON IT.[VCC] = AI.[VCC]
						AND IT.[Channel] = AI.[Channel]
						--AND IT.[Campaign] = AI.[Campaign]
						AND IT.[InteractionId] = AI.[ID]
						AND IT.[EndDate] = AI.[EndDate]
					--WHERE AI.[VCC] = @VCC
				GROUP BY IT.[VCC],
							IT.[Channel]

		END
	END

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [#InteractionsTemp] 
END