GO
PRINT N'Creando Índice [dbo].[EvaluationResult].[ReportByDetailAgent_01]...';


GO
CREATE NONCLUSTERED INDEX [ReportByDetailAgent_01]
    ON [dbo].[EvaluationResult]([Instance] ASC, [AgentDescription] ASC, [IdAuditor] ASC, [CampaignDescription] ASC);


GO
PRINT N'Modificando Procedimiento [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationPlanCognitiveInteractionTask] (
    @VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL -- EVALUATION PLAN ID
)
AS
BEGIN
SET NOCOUNT ON
	-- ESTE SP TIENE POR FINALIDAD RETORNAR LA LISTA DE INTERACCIONES CRUZADA CON LOS MODELOS NLU QUE SE VAN A EVALUAR

	-- BUSCAMOS LOS MODELOS ASOCIADOS AL PLAN Y LAS HABILIDADES QUE LO APLICAN
	SELECT DISTINCT HAQ.VCC										'vcc'
					-- ,N.[Name] + '|' + I.[Name]					'cognitiveId'
					,N.[Name]									'nluId'
					,N.[AppId]									'appId'
					,I.[IntentId]								'intentId'
					,'ABILITY'								'mainTarget'
					,STUFF(
						(
							SELECT DISTINCT ',' + INNER_HAQ.[AbilityId]
								FROM [dbo].[HistoricAbilityQuery] INNER_HAQ (NOLOCK)
								WHERE INNER_HAQ.[VCC] = HAQ.[VCC]
									AND INNER_HAQ.[EvaluationPlanId] = HAQ.[EvaluationPlanId]
									-- AND INNER_HAQ.[QueryContent] = N.[Name] + '|' + I.[Name]
							FOR XML PATH(''), TYPE
						).value('.', 'NVARCHAR(MAX)'), 
						1, 
						1, 
						''
					)											'abilities'
					,CONVERT(BIT, 1) 							'needRequest'
		INTO #EVALUATION_PLAN_MODELS 
		FROM [HistoricAbilityQuery] HAQ (NOLOCK) 
		INNER JOIN [HistoricAbility] HA (NOLOCK)
			ON HA.[VCC] = HAQ.[VCC]
				AND HA.[EvaluationPlanId] = HAQ.[EvaluationPlanId]
				AND HA.[ID] = HAQ.[AbilityId]
		INNER JOIN [dbo].[Intent] I (NOLOCK)
			ON I.[VCC] = HAQ.[VCC]
				AND I.[IntentId] = HAQ.[QueryId]
		INNER JOIN [dbo].[NLU] N (NOLOCK)
			ON N.[VCC] = HAQ.[VCC]
				AND N.[AppId] = I.[AppId]
		WHERE HAQ.[VCC] = @VCC
			AND HAQ.[EvaluationPlanId] = @ID
			AND HA.[AnalysisType] = 'COGNITIVE'

	-- DROP TABLE #EVALUATION_PLAN_MODELS 
	-- SELECT * FROM #EVALUATION_PLAN_MODELS 

	-- ESTE SCRIPT RECUPERA LAS INTERACCIONES TIPO CALL QUE ENTRARAN A LA EVALUACION COGNITIVA
	SELECT DISTINCT
			EP.Instance									'vcc'
			,EP.ProcessId								'processId'
			,'EVALUATION_PLAN'							'batchTypeName'
			,AU.Campaign								'campaign'
			,IEP.[InteractionType]						'interactionType'
			,EP.[Id]									'evaluationPlanId'
			,IEP.IdInteraction							'id'
			,AU.Section									'section'
			,AU.Part									'part'
			,NULL										'folder'
			,EPM.nluId									'nluId'
			,EPM.appId									'appId'
			,EPM.[mainTarget]							'mainTarget'
			,AU.[FileName]								'fileName'
			--,EPM.[cognitiveId]						-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]						'cognitiveEngine'
			,EPM.[abilities]							'abilities'
			,EPM.[needRequest]							'needRequest'
	FROM [EvaluationPlan] EP (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] IEP (NOLOCK) 
		ON IEP.Instance = EP.Instance 
			AND IEP.IdEvaluationPlan = EP.Id
	INNER JOIN [dbo].[Audio] AU (NOLOCK) 
		ON AU.VCC = EP.Instance
			AND AU.ID = IEP.IdInteraction 
	INNER JOIN #EVALUATION_PLAN_MODELS EPM 
		ON EPM.[vcc] = EP.[Instance]
			--AND EPM.[cognitiveId] = HAQ.[QueryContent] 
			--AND EPM.[intentId] = HAQ.[QueryId] 
	LEFT JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = EP.[Instance]
	WHERE EP.[Instance] = @VCC
		AND EP.[ID] = @ID
		AND AU.[IsTranscribed] = 1
	
	-- ESTE SCRIPT RECUPERA LAS INTERACCIONES TIPO TEXT QUE ENTRARAN A LA EVALUACION COGNITIVA
	SELECT DISTINCT
			EP.Instance									'vcc'
			,EP.ProcessId								'processId'
			,'EVALUATION_PLAN'							'batchTypeName'
			,AI.[Campaign]								'campaign'
			,IEP.[InteractionType]						'interactionType'
			,EP.[Id]									'evaluationPlanId'
			,IEP.IdInteraction							'id'
			,NULL										'section'
			,NULL										'part'
			,AI.[EndDate]								'endDate'
			,AI.[Folder]								'folder'
			,AI.[DispositionCode]						'dispositionCode'
			,EPM.nluId									'nluId'
			,EPM.appId									'appId'
			,EPM.[mainTarget]							'mainTarget'
			,AI.[FileName]								'fileName'
			--,F.[cognitiveId]							-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]						'cognitiveEngine'
			,EPM.[abilities]							'abilities'
			,EPM.[needRequest]							'needRequest'
	FROM [EvaluationPlan] EP (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] IEP (NOLOCK) 
		ON EP.Instance = IEP.Instance 
			AND EP.Id = IEP.IdEvaluationPlan
	INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK) 
		ON EP.Instance = AI.VCC 
			AND IEP.IdInteraction = AI.ID
			AND IEP.FormattedEndDate = AI.Folder
	INNER JOIN #EVALUATION_PLAN_MODELS EPM 
		ON EPM.[vcc] = EP.[Instance]
			--AND EPM.[cognitiveId] = HAQ.[QueryContent] 
			--AND EPM.[intentId] = HAQ.[QueryId] 
	LEFT JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = EP.[Instance]
	WHERE EP.[Instance] = @VCC
		AND EP.[ID] = @ID
		AND AI.[IsTranscribed] = 1

SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveI6InteractionAsyncInteraction]...';


GO
ALTER PROCEDURE [dbo].[SaveI6InteractionAsyncInteraction] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Folder					VARCHAR(50) = NULL,
	@ExportedContent		VARCHAR(250) = NULL,
	@Channel				VARCHAR(25) = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Account				VARCHAR(50) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@DispositionTreePath	VARCHAR(50) = NULL,
	@DispositionCode		VARCHAR(50) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@TotalMessages			INT = NULL,
	@ProcessId				VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
	--select * from AsyncInteraction (nolock)
	--select * from InteractionEvaluationPlan (nolock)
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UNA VARIABLE PARA AYUDAR A LA ACTUALIZACION
		DECLARE @BD_AI_ID VARCHAR(250) = NULL
		DECLARE @NEED_I6_UPDATE BIT = 1
		DECLARE @AGENT_NAME VARCHAR(100) = NULL -- NOMBRE DEL AGENTE
		DECLARE @EVALUATION_PLAN_ID VARCHAR(50) = NULL -- ID DEL PLAN EN CASO EXISTA

		-- ASIGNAMOS EL VALOR ACTUALIZADO DEL FLAG
		SELECT @BD_AI_ID = AI.[Id],
				@NEED_I6_UPDATE = AI.[NeedI6Update]
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			WHERE AI.[VCC] = @VCC
				AND AI.[ID] = @InteractionId
				AND AI.[Folder] = @Folder

		-- BUSCAMOS EL ID DEL PLAN EN CASO EXISTA
		SELECT @EVALUATION_PLAN_ID = EP.[ID]
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			WHERE EP.[Instance] = @VCC 
				AND EP.[ProcessId] = @ProcessId
				AND EP.[Status] < 5
		
		-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL AGENTE
		SELECT @AGENT_NAME = A.[Name]
			FROM [dbo].[Agent] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[AgentId] = @AgentId

		-- ASIGNAMOS EL NAME EN CASO SEA NULL
		SET @AGENT_NAME = IIF((@AgentId IS NOT NULL AND @AgentId <> ''), @AgentId, NULL)
		
		-- EN CASO REQUIERAN ACTUALIZACION POR UNICA VEZ
		IF @NEED_I6_UPDATE = 1 AND @ProcessId IS NOT NULL
		BEGIN
			print @BD_AI_ID
			-- VERIFICAMOS IS EXISTE
			IF @BD_AI_ID IS NOT NULL
			BEGIN
				PRINT 'UPDATE'
				-- ACTUALIZAMOS LA TABLA DE LA INTERACCION EN LA TABLA ASYNC_INTERACTION
				UPDATE [dbo].[AsyncInteraction]
					SET [ExportedContent] = @ExportedContent,
						[Campaign]= @Campaign,
						[StartDate] = @StartDate,
						[EndDate] = @EndDate,
						[Account] = @Account,
						[Initiative] = @Origin,
						[LastTakedAgent] = @AgentId,
						[LastTakedAgentName] = @AGENT_NAME,
						[DurationTime] = @DurationTime,
						[DispositionTreePath] = @DispositionTreePath,
						[DispositionCode] = @DispositionCode,
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[TotalMessages] = @TotalMessages,
						[NeedI6Update] = 0,
						[IsProcess] = NULL,
						[IsCancel] = NULL,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC
						AND [ID] = @InteractionId
						AND [Folder] = @Folder
						AND [NeedI6Update] = 1
						AND (
							[IsTranscribed] IS NULL 
							OR
							[IsTranscribed] <> 1
						)

				-- ACTUALIZAMOS EL CAMPAIGN Y ENDDATE EN LA INTERACCION EN LA TABLA PROCESSAUDIO
				UPDATE [dbo].[ProcessAsyncInteraction]
					SET [Campaign] = @Campaign,
						[EndDate] = @EndDate,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC
						AND [InteractionId] = @InteractionId
						AND [FormattedEndDate] = @Folder 
						AND [ProcessId] = @ProcessId
			END
			ELSE
			BEGIN
				-- SELECT * FROM AsyncInteraction (NOLOCK)
				-- SELECT * FROM ProcessAsyncInteraction (NOLOCK)
				-- INSERTAMOS EL REGISTRO EN ASYNC_INTERACTION
				INSERT INTO [dbo].[AsyncInteraction] (
					[VCC], [ID], [Folder], [ExportedContent], [Channel], 
					[Campaign], [StartDate], [EndDate], [Account], [Initiative], 
					[ContactId], [ContactName], [ContactAddress], [LastTakedAgent], [LastTakedAgentName], 
					[TotalMessages], [DurationTime], [AttentionTime], [DispositionCode], [DispositionTreePath], 
					[NeedI6Update], [LastModifiedByUserId], [LastModifiedDate], [TimeStamp]
				) VALUES (
					@VCC, @InteractionId, @Folder, @ExportedContent, @Channel, 
					@Campaign, @StartDate, @EndDate, @Account, @Origin, 
					@ContactId, @ContactName, @ContactAddress, @AgentId, @AGENT_NAME, 
					@TotalMessages, @DurationTime, @DurationTime, @DispositionCode, @DispositionTreePath, 
					0, 'system', GETUTCDATE(), GETUTCDATE()
				)

				-- INSERTAMOS EL REGISTRO EN PROCESS_ASYNC_INTERACTION
				INSERT INTO [dbo].[ProcessAsyncInteraction] (
					[VCC], [ProcessId], [InteractionType], [Campaign], [InteractionId],
					[EndDate], [FormattedEndDate], [CreatedDate], [CreatedByUserId], [TimeStamp]
				) VALUES (
					@VCC, @ProcessId, @Channel, @Campaign, @InteractionId, 
					@EndDate, @Folder, GETUTCDATE(), 'system', GETUTCDATE()
				)
			END
		END

		-- ACTUALIZAMOS LOS REGISTROS DE PLAN
		EXEC [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan] 
			@VCC, @InteractionId, @Folder, @ExportedContent, @Channel,  
			@StartDate, @EndDate, @DurationTime, @AgentId, @AGENT_NAME, 
			@Campaign, @Account, @Origin, @DispositionTreePath, @DispositionCode, 
			@ContactId, @ContactName, @ContactAddress, @TotalMessages, @EVALUATION_PLAN_ID

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[ReportByDetailAgent]...';


GO
ALTER PROCEDURE [dbo].[ReportByDetailAgent] (
	@VCC varchar(50) = NULL, 
	@HistoricCampaign varchar(MAX) = NULL , 
	@Plan varchar(MAX) = NULL,
	@Format varchar(MAX), 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(MAX) = NULL ,
	@IdAgente varchar(MAX) = NULL
) AS
BEGIN
	-- ReportByDetailAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191001','20191201','isidoro','icagente3'
	SET NOCOUNT ON
	
	DECLARE @cols varchar(max) 
	DECLARE @query varchar(max)
  
	-- SETTEAMOS EL STARTDATE Y ENDDATE EN CASO SEAN NULL
	IF @StartDate IS NULL SET @StartDate = '2021-01-01 00:00:00'
	IF @EndDate IS NULL SET @EndDate = '2050-01-01 23:59:59' 
	ELSE 
	BEGIN
		SET @EndDate = DateAdd(hh,- (DatePart(hh, @EndDate)) + 23, @EndDate) 
		SET @EndDate = DateAdd(mi,- (DatePart(mi, @EndDate)) + 59, @EndDate) 
		SET @EndDate = DateAdd(ss,- (DatePart(ss, @EndDate)) + 59, @EndDate) 
	END

	print @StartDate
	print @EndDate
	
	SELECT * 
		INTO #TempEvaluationResult
		FROM (
			SELECT EP.[Instance]														'VCC',
					EP.[Description]													'DescriptionPlan',
					EF.[Description]													'DescriptionFormat',
					(
						GP.[Description]
						+ '-' 
						+ SGP.[Description]
						+ '-' 
						+ A.[Title]
					)																	'Ability', --Collate SQL_Latin1_General_CP1253_CI_AI
					ER.[AgentDescription],
					ER.[CampaignDescription],
					ER.[IdInteraction],
					ISNULL(ER.[Qualification], 0)										'Qualification',
					AEP.[Score]															'Score',
					AEP.[AutomaticScore],
					AEP.[ManualScore],
					--Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss')					AS 'EvaluationDate',
					--CAST(Format(AEP.[TimeStamp], 'yyyy-MM-dd hh:mm:ss') AS DATETIME)					AS 'EvaluationDate',
					AEP.[TimeStamp] AS 'EvaluationDate',
					ER.[IdAuditor],
					EP.[Evaluation_Mode]
				FROM dbo.[EvaluationResult] (NOLOCK) ER
				INNER JOIN dbo.[HistoricEvaluationFormat] EF
					ON EF.[VCC] = ER.[Instance]
						AND EF.[EvaluationPlanId] = ER.[IdEvaluationPlan] 
						AND EF.ID = ER.[IdEvaluationFormat] 
				INNER JOIN dbo.[HistoricAbility] (NOLOCK) A
					ON A.[VCC] = ER.[Instance]
						AND A.[EvaluationPlanId] = ER.[IdEvaluationPlan]  
						AND A.[ID] = ER.[IdAbility] 
				INNER JOIN dbo.[EvaluationPlan] (NOLOCK) EP
					ON EP.[Instance] = ER.[Instance]
						AND EP.[ID] = ER.[IdEvaluationPlan]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] =  ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[IdAuditor] =  ER.[IdAuditor]
				INNER JOIN [HistoricGroup] (NOLOCK) GP
					ON GP.[VCC] = ER.[Instance]
						AND GP.[EvaluationPlanId] = EP.ID
						AND GP.[ID] = ER.[IdGroup] 
				INNER JOIN dbo.[HistoricSubGroup] (NOLOCK) SGP
					ON SGP.[VCC] = ER.[Instance]
						AND SGP.[EvaluationPlanId] = EP.[ID]
						AND SGP.[ID] = ER.[IdSubGroup] 
				WHERE AEP.[TimeStamp] BETWEEN @StartDate AND  @EndDate
					AND AEP.[Completed] = 1
					AND AEP.[StatusDescription] NOT IN('INVALID')
					AND ER.[Instance] LIKE CASE WHEN @VCC IS NOT NULL THEN @VCC ELSE ER.[Instance] END
					AND ER.[AgentDescription] IN (SELECT [Value] FROM [dbo].[Split](IIF(@IdAgente IS NULL, ER.[AgentDescription], @IdAgente), ','))
					AND ER.[IdAuditor] IN (SELECT [Value] FROM [dbo].[Split](IIF(@IdAuditor IS NULL, ER.[IdAuditor], @IdAuditor), ','))
					AND ER.[CampaignDescription] IN (SELECT [Value] FROM [dbo].[Split](IIF(@HistoricCampaign IS NULL, ER.[CampaignDescription], @HistoricCampaign), ','))
					AND EP.[Description] IN (SELECT [Value] FROM [dbo].[Split](IIF(@Plan IS NULL, EP.[Description], @Plan), ','))
					AND EF.[Description] IN (SELECT [Value] FROM [dbo].[Split](IIF(@Format IS NULL, EF.[Description], @Format), ','))
					--AND EP.[Status] = 7
		) A

	print 'Despues del select'

	--select * from #TempEvaluationResult ORDER BY IdInteraction


  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability) 
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')

  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
    --SELECT @type
	If @type = 'M'
	BEGIN
    SET @query = ' 
				SELECT p.[VCC]							[VCC],
						p.[DescriptionPlan]				[EVALUATION_PLAN],
						p.[DescriptionFormat]			[EVALUATION_FORMAT],
						p.[AgentDescription]			[AGENT],
  						p.[CampaignDescription]			[CAMPAIGN],
						p.[IdInteraction]				[INTERACTION],
						p.[EvaluationDate]				[EVALUATION_DATE],
						p.[IdAuditor]					[AUDITOR],
						[InteractionDuration]			[DURATION_TIME], 
						NULL							[PHONE],
						[InteractionDateStart]			[START_DATE],
						NULL							[CATEGORY],
						-- (' + @Total + ')				[COLUMN_TOTAL_SCORE], 
						p.[Score]						[COLUMN_TOTAL_SCORE], 
						p.[AutomaticScore]				[COLUMN_AUTOMATIC_SCORE],
						p.[ManualScore]					[COLUMN_MANUAL_SCORE],
						' + @cols + ' 
					FROM 
				( select VCC,
							DescriptionPlan,
							DescriptionFormat,
							Ability,
							AgentDescription,
							CampaignDescription,
							IdInteraction,
							EvaluationDate,
							Qualification,
							Score,
							AutomaticScore,
							ManualScore,
							IdAuditor			
						from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock) 
				) as A On
				A.IdInteraction = p.IdInteraction '
    END
	ELSE 
	BEGIN
    SET @query = ' 
				Select p.[VCC]							[VCC],
						p.[DescriptionPlan]				[EVALUATION_PLAN],
						p.[DescriptionFormat]			[EVALUATION_FORMAT],
						p.[AgentDescription]			[AGENT],
  						p.[CampaignDescription]			[CAMPAIGN] ,
						p.[IdInteraction]				[INTERACTION] ,
						p.[EvaluationDate]				[EVALUATION_DATE],
						p.[IdAuditor]					[AUDITOR],
						A.[DurationTime]				[DURATION_TIME],
						A.[Number]						[PHONE] ,
						A.[StartDate]					[START_DATE] ,
						A.[Category1]					[CATEGORY] ,
						-- (' + @Total + ')				[COLUMN_TOTAL_SCORE], 
						p.[Score]						[COLUMN_TOTAL_SCORE], 
						p.[AutomaticScore]				[COLUMN_AUTOMATIC_SCORE],
						p.[ManualScore]					[COLUMN_MANUAL_SCORE],
						' + @cols + ' 
					from ( 
						select VCC,
								DescriptionPlan,
								DescriptionFormat,
								Ability,
								AgentDescription,
								CampaignDescription,
								IdInteraction,
								EvaluationDate,
								Qualification,
								Score,
								AutomaticScore,
								ManualScore,
								IdAuditor			
							from #TempEvaluationResult
					) x pivot 
					( 
						 max(Qualification)
						for Ability in (' + @cols + ')
					) p 
					LEFT Join Audio as A 
						On A.[VCC] = p.[VCC]
							AND A.ID = p.IdInteraction'
	END
	--Print(@query)
    EXECUTE (@query)
    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    SELECT
						''				As [EVALUATION_PLAN],
						''				As [EVALUATION_FORMAT],
						''				As [AGENT],
  						''			    As [CAMPAIGN] ,
						''			 	As [INTERACTION] ,
						''				As [EVALUATION_DATE],
						''				As [AUDITOR]
  END
  
  SET NOCOUNT OFF

END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveInteractionEvaluationPlanResult]...';


GO
ALTER PROCEDURE [dbo].[SaveInteractionEvaluationPlanResult] (
	@VCC VARCHAR(50),
	@IdEvaluationPlan VARCHAR(50),
	@IdAuditor VARCHAR(50),
	@IdInteraction VARCHAR(250),
	@InteractionType VARCHAR(50),
	@Score NUMERIC(5,2),
	@AutomaticScore NUMERIC(5,2),
	@ManualScore NUMERIC(5,2),
	@IsDraft BIT
) AS
BEGIN
	SET NOCOUNT ON

	-- EN CASO LLEGUE NULL ASIGNAMOS UN VALOR
	IF @IsDraft IS NULL
		SET @IsDraft = 0

 	UPDATE [dbo].[AuditorEvaluationPlan] 
		SET [Completed] = IIF (@IsDraft = 1, 0, 1), 
			[Score] = @Score, 
			[AutomaticScore] = @AutomaticScore,
			[ManualScore] = @ManualScore,
			[StatusDescription] = IIF (@IsDraft = 1, 'DRAFT', 'COMPLETED'),
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [Instance] = @VCC
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND [IdInteraction] = @IdInteraction
			AND [InteractionType] = @InteractionType
			AND [IdAuditor] = @IdAuditor

	-- ACTUALIZAMOS LAS NOTAS FINALES TENIENDO EN CUENTA LAS PENALIZACIONES
	IF @IsDraft = 0
	BEGIN
		;WITH CTEFP AS (
			SELECT DISTINCT 
					ER.[Instance],
					ER.[IdInteraction],
					ER.[IdEvaluationPlan],
					ER.[IdEvaluationFormat],
					ER.[IdAbility],
					CASE WHEN ER.[AbilityInnerScore] = 0 AND HAEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
					HAEF.[Penalizes],
					CASE HAEF.[Penalizes]
						WHEN 'INT' THEN ER.[IdInteraction] 
						WHEN 'GRP' THEN ER.[IdGroup] 
						WHEN 'SGR' THEN ER.[IdSubGroup] 
					END 'PenalizedOn',
					RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
						ORDER BY CASE HAEF.[Penalizes]
						WHEN 'INT' THEN 1 
						WHEN 'GRP' THEN 2 
						WHEN 'SGR' THEN 3 
					END)
				FROM [EvaluationResult] ER (NOLOCK) 
				LEFT JOIN [HistoricAbilityEvaluationFormat] HAEF (NOLOCK) 
					ON HAEF.[VCC] = ER.[Instance]
						AND HAEF.[EvaluationPlanId] = ER.[IdEvaluationPlan]
						AND HAEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
						AND HAEF.[IdAbility] = ER.[IdAbility]
				WHERE ER.[IdEvaluationPlan] IN (@IdEvaluationPlan) 
					AND ER.[IdInteraction] = @IdInteraction
					AND ER.[IdAuditor] = @IdAuditor
					AND ER.[AbilityInnerScore] = 0
					AND HAEF.[Penalizes] <> 'NO'
				-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
		),
		CTEFS AS (
			SELECT ER.[Instance],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction],
					ER.[IdAuditor],
					SUM(ER.[Qualification])															'TOTAL_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC', ER.[Qualification], 0))					'TOTAL_AUTOMATIC_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL', ER.[Qualification], 0))							'TOTAL_MANUAL_SCORE',
					--SUM(ER.[Qualification] * CASE WHEN FP2.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE',
					SUM(ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1) THEN 0 ELSE 1 END
					))																				'PENALIZED_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC',
						ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1
						) THEN 0 ELSE 1 END),
						0) 
					)																				'PENALIZED_AUTOMATIC_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL',
						ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1
						) THEN 0 ELSE 1 END),
						0) 
					)																				'PENALIZED_MANUAL_SCORE'
				FROM EvaluationResult ER (NOLOCK) 
				LEFT JOIN (
					-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
					--  POR LA MAS PRIORITARIA (FP.[RN])
					SELECT DISTINCT FP.[Instance],
									FP.[IdEvaluationPlan], 
									FP.[IdInteraction], 
									FP.[Penalized],
									FP.[Penalizes], 
									FP.[PenalizedOn]
						FROM CTEFP FP (NOLOCK)
						WHERE FP.[Penalizes] <> 'NO'
							AND FP.[RN] = 1
				) FP2
					ON FP2.[Instance] = ER.[Instance]
						AND ER.[IdEvaluationPlan] = FP2.[IdEvaluationPlan]
						AND ER.[IdInteraction] = FP2.[IdInteraction]
						/*
						AND CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1
						*/
				INNER JOIN dbo.[HistoricAbility] HA (NOLOCK)
					ON HA.[VCC] = ER.[Instance]
						AND HA.[EvaluationPlanId] = ER.[IdEvaluationPlan]
						AND HA.[ID] = ER.[IdAbility]
				--WHERE ER.[Instance] = 'multisalud'
				WHERE -- ER.[Instance] = FP2.[Instance] -- ESTA LINEA CAUSA QUE NO SE ACTUALICEN LOS SCORES LAS EVALUACIONES QUE NO PENALIZAN
					-- AND 
					ER.[IdEvaluationPlan] IN (@IdEvaluationPlan) 
					AND ER.[IdInteraction] = @IdInteraction
					AND ER.[IdAuditor] = @IdAuditor
					--AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility)
				GROUP BY ER.[Instance],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction],
					ER.[IdAuditor]
		)
		--SELECT * FROM CTEFS

		-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
		UPDATE AEP 
			SET AEP.[Score] = FS.[PENALIZED_SCORE],
				AEP.[AutomaticScore] = FS.[PENALIZED_AUTOMATIC_SCORE],
				AEP.[ManualScore] = FS.[PENALIZED_MANUAL_SCORE],
				AEP.[LastModifiedDate] = GETUTCDATE(),
				AEP.[TimeStamp] = GETUTCDATE()
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN CTEFS FS (NOLOCK) 
				ON FS.[Instance] = AEP.[Instance] 
					AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
					AND FS.[IdInteraction] = AEP.[IdInteraction]
					AND FS.[IdAuditor] = AEP.[IdAuditor]
			WHERE FS.[Instance] IS NOT NULL
	END

    SELECT 1 AS 'result'

 	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando Procedimiento [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkInteractionQueryStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionQueryStudy]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkProcessI6Update]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProcessI6Update]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkProcessInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProcessInteraction]';


GO
PRINT N'Actualizando Procedimiento [dbo].[CloseI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CloseI6InteractionAudio]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteI6InteractionAudio]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteInteraction]';


GO
PRINT N'Actualizando Procedimiento [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAudioNavigatorInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudioNavigatorInteractions]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudios]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetBillingInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetBillingInteractions]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetCleanerData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCleanerData]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetCognitiveAnalysisProcessValidDurationTime]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCognitiveAnalysisProcessValidDurationTime]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationPlanTipificationInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanTipificationInteractionTask]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetGlobalSearchFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGlobalSearchFilters]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetGlobalSearchInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGlobalSearchInteractions]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetI6AlreadyRegisteredCallInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6AlreadyRegisteredCallInteractions]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetI6InteractionAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6InteractionAudios]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetInteractionAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionAgents]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetInteractionCampaigns]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionCampaigns]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetInteractionsCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsCognitive]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetPendingAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPendingAudios]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetProcessFiltersData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessFiltersData]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetProcessI6InteractionsToUpdate]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessI6InteractionsToUpdate]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetProcessInteractionsByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsByProcessId]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetProcessInteractionsHistory]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsHistory]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetProcessSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessSummary]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetProcessValidDurationTime]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessValidDurationTime]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetStudiesInProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudiesInProcess]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetTeamPerformanceFromEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTeamPerformanceFromEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudio]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveAudioLinguisticProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudioLinguisticProcess]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveEvaluationBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationBaseResult]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveProcess]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveStudyBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveStudyBaseResult]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkInteractionCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionCognitive]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkEvaluationPlanQuery]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanQuery]';


GO
PRINT N'Actualizando Procedimiento [dbo].[CleanFailedBatchData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CleanFailedBatchData]';


GO
PRINT N'Actualizando Procedimiento [dbo].[CleanFailedEvaluationPlanData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CleanFailedEvaluationPlanData]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAuditorEvaluationPlanEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorEvaluationPlanEvaluation]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetCognitiveInteractionIntents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCognitiveInteractionIntents]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetI6InteractionMessages]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6InteractionMessages]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveEvaluationEfectivitySample]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationEfectivitySample]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveInteractionEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveInteractionEvaluationPlanSample]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlanSample]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAudio]';


GO
PRINT N'Actualización completada.';


GO
