PRINT N'Altering Procedure [dbo].[GetAPIUsers]...';

GO
ALTER PROCEDURE [dbo].[GetAPIUsers](
@VCC Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]							'vcc',
		[User] 							'user',
		[IsLocked]						'isLocked',
		[CreatedDate] 					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [UserAPI] (NOLOCK)
	WHERE [VCC] = @VCC
		AND ISNULL([User], '') LIKE CASE WHEN @SearchCriteria = 'user' THEN '%' + @SearchExpression + '%' ELSE '%' END
	SET NOCOUNT OFF
END



GO
PRINT N'Altering Procedure [dbo].[GetNotEvaluatedInteractionsAuditor]...';

GO
ALTER PROCEDURE [dbo].[GetNotEvaluatedInteractionsAuditor] (
	@Instance Varchar(50) = NULL, 
	@UserId Varchar(50) = NULL,
	@IdCampaigns VARCHAR(MAX) = NULL,
	@IdAgents Varchar(MAX) = NULL,
	@EvaluationPlans Varchar(MAX) = NULL,
	@InteractionTypes Varchar(100) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
 	@EvaluationDateTo   VARCHAR(MAX) = '2050-01-01T23:59:59',
	@EvaluationStatus BIT = 1,
 	@InteractionIds     VARCHAR(MAX) = NULL,
	@ContactAddress VARCHAR(300) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @USER_ROLE VARCHAR(50) = ''
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_FIXED_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = ''

	-- IDENTIFICAMOS EL ROL DEL USUARIO
	SELECT @USER_ROLE = U.[Role]
		FROM [dbo].[User] U (NOLOCK)
		WHERE U.[VCC] = @Instance
			AND U.[ID] = @UserId

	-- EMULAMOS UNA NUEVA TABLA EN BASE A AuditorEvaluationPlan DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	SET @SQL_SELECT_1 += '
		WITH CTE AS (
			SELECT AEP.[Instance], 
					AEP.[IdEvaluationPlan], 
					AEP.[IdInteraction], 
					AEP.[IdAuditor], 
					AEP.[Score], 
					IEP.[AgentName],
					AEP.[LastModifiedDate],
					RN = ROW_NUMBER() OVER(PARTITION BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction] ORDER BY AEP.[LastModifiedDate] DESC)
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance] 
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction]
					AND IEP.[IdAgent] = AEP.[IdAgent]
			WHERE AEP.[Instance] = ''' + @Instance + ''' 
				AND AEP.[Completed] = 0 
				AND AEP.[IdAuditor] <> ''SPEECH''
				AND AEP.[StatusDescription] NOT IN(''INVALID'') '

	IF @USER_ROLE = 'quality_auditor' 
	BEGIN
		SET @SQL_SELECT_1 += '
				AND	AEP.[IdAuditor] = ''' + @UserId + ''' '
	END

	IF (@IdCampaigns IS NOT NULL AND @IdCampaigns != '') SET @SQL_SELECT_1 += 'AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaigns + ''','','')) ';
	IF (@IdAgents IS NOT NULL AND @IdAgents != '') SET @SQL_SELECT_1 += 'AND AEP.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgents + ''','','')) ';
	IF (@EvaluationPlans IS NOT NULL AND @EvaluationPlans != '') SET @SQL_SELECT_1 += 'AND AEP.[IdEvaluationPlan] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationPlans + ''','','')) '
	IF (@InteractionTypes IS NOT NULL AND @InteractionTypes != '') SET @SQL_SELECT_1 += 'AND AEP.[InteractionType] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTypes + ''','','')) ';
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') 
		SET @SQL_SELECT_1 += 'AND (
								(CONCAT(AEP.[IdCampaign], ISNULL(REPLACE(AEP.[ManagementResult], ''/'', ''_''), ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(CONCAT(AEP.[IdCampaign], ''_'', ISNULL(AEP.[ManagementResult], ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
							)'

	SET @SQL_SELECT_1 += '
		),
		CLEANED_CTE AS (
			SELECT C.[Instance], 
					C.[IdEvaluationPlan], 
					C.[IdInteraction], 
					C.[IdAuditor], 
					C.[Score], 
					C.[AgentName],
					C.[LastModifiedDate]
			FROM [CTE] C
			WHERE C.[RN] = 1
		) '
	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	
	-- ARMAMOS EL SELECT PRINCIPAL PARA LA BUSQUEDA DE EVALUACIONES PENDIENTES DEL AUDITOR
	SET @SQL_SELECT_1 += '
		SELECT DISTINCT '
	SET @SQL_SELECT_1 += '
				AEP.[IdInteraction]															''id'', 
				AEP.[IdCampaign]															''descriptionCampaign'',
				AEP.[IdAgent]																''idAgent'',
				AEP.[IdAgent]																''descriptionAgent'',
				AEP.[InteractionDate]														''dateIni'',
				AEP.[InteractionDateEnd]													''dateFin'',
				AEP.[InteractionDuration]													''interactionTime'',
				AEP.[Completed]																''evaluated'',
				AEP.[InteractionType]														''interactionType'',
				AEP.[ManagementResult]														''dispositionCode'',
				AEP.[ContactAddress]																''address'',
				AEP.[InteractionOrigin]														''origin'',
				AEP.[IdEvaluationPlan]														''idEvaluationPlan'',
				EP.[ProcessId]																''processId'',
				EP.[Description]															''descriptionEvaluationPlan'',
				EP.[DateFin]																''dateFinEvaluationPlan'', 
				EP.[Modality]																''evaluationPlanModality'',
				EP.[Evaluation_Mode]														''evaluationPlanEvaluationMode'',
				A.[ID]																		''idAuditor'', 
				A.[Description]																''descriptionAuditor'',
				ISNULL(U.[FirstName] + '' '', '''') + ISNULL(U.[LastName], '''')			''auditorName'',						-- NOMBRE DEL AUDITOR
				C.[AgentName]																''agentName'',							-- NOMBRE DEL AGENTE
				C.[IdAuditor]																''lastEvaluationEvaluator'', 
				C.[Score]																	''lastEvaluationScore'',
				AEP.[Status]																''status'',
				CASE
					WHEN EP.[DateFin] < CAST(GETDATE()  AS DATE)
					THEN 1
					ELSE 0
				END																			''isExpired'',
				AEP.[StatusDescription]														''statusDescription'''

	SET @SQL_FROM += '
			FROM [AuditorEvaluationPlan] AEP (NOLOCK) 
			INNER JOIN [EvaluationPlan] EP (NOLOCK) 
				ON (EP.[Instance] = EP.Instance
					AND EP.[ID] = AEP.IdEvaluationPlan) 
			INNER JOIN CLEANED_CTE C (NOLOCK) 
				ON C.[Instance] = AEP.[Instance] 
					AND C.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
					AND C.[IdInteraction] = AEP.[IdInteraction]
			LEFT JOIN [dbo].[User] U (NOLOCK)
				ON U.[VCC] = AEP.[Instance]
					AND U.[ID] = AEP.[IdAuditor]
			LEFT JOIN [Auditor] A (NOLOCK) 
				ON (A.[ID] = AEP.[IdAuditor]) '

	SET @FILTERS_FIXED_PART = '
			WHERE AEP.[Instance] = ''' + @Instance + ''' 
				AND AEP.[Completed] = 0
				AND AEP.[StatusDescription] NOT IN(''INVALID'')
				AND EP.[Enabled] = 1 
				AND (
					(EP.[Evaluation_Mode] = ''X'' AND EP.[Status] = 8)
					OR
					(EP.[Evaluation_Mode] = ''M'')
				) '

	-- AGREGAMOS EL FILTRO DE ESTADO
	IF @EvaluationStatus = 0
	BEGIN
		SET @FILTERS_FIXED_PART += '
				AND AEP.[Status] = 0 '
	END
	ELSE IF @EvaluationStatus = 1
	BEGIN
		SET @FILTERS_FIXED_PART += '
				AND AEP.[Status] = 1 '
	END

	-- HACEMOS EL FILTRADO SEGUN EL ROL DEL USUARIO
	IF @USER_ROLE = 'quality_auditor'
	BEGIN
		SET @FILTERS_FIXED_PART += '
				AND	AEP.[IdAuditor] = ''' + @UserId + ''' '
	END
	ELSE IF @USER_ROLE = 'administrator' OR @USER_ROLE = 'quality_admin'
	BEGIN
		SET @FILTERS_FIXED_PART += ''
	END
	ELSE 
	BEGIN
		SET @FILTERS_FIXED_PART += '
				AND	AEP.[IdAuditor] = ''' + @UserId + ''' '
	END

	/*
	IF (@IdCampaigns IS NOT NULL AND @IdCampaigns != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaigns + ''','','')) ';
	IF (@IdAgents IS NOT NULL AND @IdAgents != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgents + ''','','')) ';
	--IF (@EvaluationPlans IS NOT NULL AND @EvaluationPlans != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdEvaluationPlan] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationPlans + ''','','')) '
	IF (@InteractionTypes IS NOT NULL AND @InteractionTypes != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[InteractionType] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTypes + ''','','')) ';
	-- IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') SET @FILTERS_EXCLUDING_PART += 'AND CONCAT(AEP.[IdCampaign], ''_'', AEP.[ManagementResult]) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')) ';
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND (
								(CONCAT(AEP.[IdCampaign], ISNULL(REPLACE(AEP.[ManagementResult], ''/'', ''_''), ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(CONCAT(AEP.[IdCampaign], ''_'', ISNULL(AEP.[ManagementResult], ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
							)'
	*/
	IF (@EvaluationDateTo IS NOT NULL AND @EvaluationDateTo != '') SET @FILTERS_OPTIONAL_PART += 'AND EP.[DateFin] <= ''' + @EvaluationDateTo + '''  ';
	IF(@ContactAddress IS NOT NULL AND @ContactAddress <>'')
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND AEP.ContactAddress LIKE ''%' + @ContactAddress + '%''
			'
	END	
	
	IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
       BEGIN 
            SET @FILTERS_OPTIONAL_PART = '';
	        SET @FILTERS_EXCLUDING_PART=' AND AEP.[IdInteraction] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
       END

	SET @SQL_SELECT_1 += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART;

	-- print @SQL_SELECT_1
	EXEC (@SQL_SELECT_1)

 	SET NOCOUNT OFF
END


GO
PRINT N'Altering Procedure [dbo].[GetEvaluationPlansExpired]...';

GO
CREATE   PROCEDURE [dbo].[GetEvaluationPlansExpired] (
    @CurrentDate            DATETIME = NULL
)
AS
BEGIN
	SET NOCOUNT ON	 
    
	SELECT
			EP.[ID]									'id',
			AEP.[IdInteraction]					    'idInteraction',
			AEP.[IdAuditor]					        'idAuditor',
			AEP.[instance]							'vcc',
			AEP.[LastModifiedByUserId]				'lastModifiedByUserId'
		FROM [AuditorEvaluationPlan] AEP (NOLOCK) 
		INNER JOIN [EvaluationPlan] EP (NOLOCK) 
				ON (EP.[Instance] = EP.Instance
					AND EP.[ID] = AEP.IdEvaluationPlan) 
		WHERE 
		EP.[DateFin] < CAST(@CurrentDate AS DATE)
			AND AEP.[Completed] = 0
			AND AEP.[StatusDescription] NOT IN('INVALID')
			AND EP.[Enabled] = 1
		    AND AEP.[Status] = 1
		    AND AEP.[IdAuditor] <> 'SPEECH'
			AND EP.[Evaluation_Mode] <> 'A'

	SET NOCOUNT OFF
END

GO
PRINT N'Altering Table [dbo].[SaveEvaluationFormat]...';

GO

ALTER PROCEDURE [dbo].[SaveEvaluationFormat] (
	@Instance Varchar(50) = NULL, 						
	@ID Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@Type Varchar(50) = NULL,
	@EnvironmentType VARCHAR(50) = NULL,
	@CreatedDate Datetime = NULL,						
	@CreatedByUserId Varchar(50) = NULL,		
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,			
	@MinQualificationAcceptable numeric(5,2),	
	@MinAutomaticQualification NUMERIC(5, 2),
	@ManagementFormURL varchar(1000) = NULL,
	@Enabled bit = NULL, 
	@templateId Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- Danny Jhonston:
	-- Inicio:
	-- Validar si el formato tiene al menos un plan asignado.
	-- Validar si el formato tiene un plan de evaluacion que tiene evaluaciones pendientes.

	-- DECLARE @ID VARCHAR(50)
	-- SET @ID = '183fedb7-9dbf-4b1c-8efd-b1164f33c8ba'

	-- Tabla temporal para almacenar resultado de consulta.
	/*DECLARE @EvaluationsData TABLE (
		[ID]						VARCHAR(50),
		[totalEvaluations]			INT,
		[completedEvaluations]		INT
	)
	INSERT INTO @EvaluationsData
	SELECT
		EP.[ID]									'id',
		COUNT(AEP.[IdInteraction])				'totalEvaluations',
		SUM(CAST(AEP.[Completed] AS INT))		'completedEvaluations'
	FROM
		[dbo].[EvaluationPlan] EP
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP ON EP.[ID] = AEP.[IdEvaluationPlan]
	WHERE
		EP.[Instance] = @Instance
		AND EP.[IdEvaluationFormat] = @ID
	GROUP BY EP.[ID]

	-- Contiene las evaluaciones de un formato.
	DECLARE @TotalEvaluations INT
	SET @TotalEvaluations = (SELECT COUNT([ID]) FROM @EvaluationsData WHERE (CAST([completedEvaluations] AS NUMERIC(18, 2)) / CAST([totalEvaluations] AS NUMERIC(18, 2))) * 100 > 0)
	-- SET @TotalEvaluations = (SELECT COUNT([ID]) FROM @EvaluationsData WHERE [totalEvaluations] > [completedEvaluations])

	--PRINT @TotalEvaluations
	IF(@TotalEvaluations > 0)
	BEGIN
		BEGIN
			-- Tiene evaluaciones asociadas que en al menos se esta evaluando un plan de evaluacion.
			SELECT CAST(-1 AS INT) 'idEvaluationFormat'
			PRINT @@ROWCOUNT
		END
	END
	ELSE
	*/
	-- Danny Jhonston:
	-- Fin:
	BEGIN
		-- No tiene evaluaciones asociadas.
		-- Debe continuar con el guardado.

		UPDATE [EvaluationFormat] SET
			[Description] = @Description,
			[Type] = @Type,
			[EnvironmentType] = @EnvironmentType,
			[MinQualificationAcceptable] = @MinQualificationAcceptable,
			[MinAutomaticQualification] = @MinAutomaticQualification,
			[ManagementFormURL] = @ManagementFormURL,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[Enabled] = CASE WHEN @Enabled IS NULL THEN 1 ELSE @Enabled END,
			[TimeStamp] = GETUTCDATE(),
			[templateId] = @templateId
		WHERE [Instance] = @Instance
		AND [ID] = @ID

		

		IF @@ROWCOUNT = 0
			INSERT INTO [EvaluationFormat] (
				[Instance],[ID], [Description], [Type], 
				[EnvironmentType], [MinQualificationAcceptable], [MinAutomaticQualification], [ManagementFormURL],
				[CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId],
				[Enabled], [TimeStamp], [templateId]
				)
			VALUES (
				@Instance, @ID, @Description, @Type, 
				@EnvironmentType, @MinQualificationAcceptable, @MinAutomaticQualification, @ManagementFormURL,
				@CreatedDate, @CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId,
				@Enabled, GETUTCDATE(), @templateId
			)

		SELECT CAST(Scope_Identity() AS INT) as 'idEvaluationFormat';
	END

	

    SET NOCOUNT OFF
END


GO
PRINT N'Altering Procedure [dbo].[GetTeamPerformanceFromEvaluationPlan]...';

GO
ALTER PROCEDURE [dbo].[GetTeamPerformanceFromEvaluationPlan] (
	@VCC					VARCHAR(50) = NULL,
	@EvaluationFormatId		VARCHAR(50) = NULL,
	@EvaluationPlanIds		VARCHAR(MAX) = NULL,
	@AgentIds				VARCHAR(MAX) = NULL,
	@AbilityIds				VARCHAR(MAX) = NULL,
	@StartDate				DATETIME,
	@EndDate				DATETIME,
	@drilldownTarget		VARCHAR(50) = NULL,
	@drilldownId			VARCHAR(50) = NULL
)
AS
BEGIN

	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS
	CREATE TABLE #SEARCHED_INTERACTIONS
	(
		AgentId				VARCHAR(100),
		EvaluationPlanId	VARCHAR(50),
		InteractionId		VARCHAR(250)
	)
	
	IF(@drilldownTarget ='ABILITY')
	BEGIN
		SET @AbilityIds = @drilldownId
	
		INSERT INTO #SEARCHED_INTERACTIONS
			SELECT DISTINCT ER.[IdAgent]															'AgentId',
							ER.[IdEvaluationPlan]													'EvaluationPlanId',
							ER.[IdInteraction]														'InteractionId' 
		
				FROM [dbo].[EvaluationResult] ER (NOLOCK)				
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON ER.[Instance] = EP.[Instance]
						AND ER.[IdEvaluationPlan] = EP.[ID]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON EP.[Instance] = AEP.[Instance]
						AND EP.[ID] = AEP.[IdEvaluationPlan]
						AND (
							(
								EP.[Status] = 7 
								AND 
								EP.Evaluation_Mode = 'A'
							)
							OR
							(	
								AEP.[Completed] = 1 
								AND 
								EP.Evaluation_Mode IN ('X','M')
							)
						)
						AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
						AND ER.[IdInteraction] = AEP.[IdInteraction]
						AND ER.[IdAgent] = AEP.[IdAgent]
						AND ER.[IdAuditor] = AEP.[IdAuditor]
						AND AEP.[Completed] = 1 
						AND AEP.[StatusDescription] NOT IN('INVALID') 
				WHERE ER.[Instance] = @VCC
					AND ER.[InteractionDatefin] BETWEEN @StartDate AND @EndDate
					AND ER.[IdEvaluationFormat] = @EvaluationFormatId
					AND (
						ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						OR					
						ER.[IdEvaluationPlan]  IN (SELECT Value FROM [dbo].[split](@EvaluationPlanIds, ','))
					)	
					AND (
						ISNULL(LEN(@AgentIds), 0) = 0
						OR
						ER.[IdAgent]  IN (SELECT Value FROM [dbo].[split](@AgentIds, ','))
					)
					AND (
						ISNULL(LEN(@AbilityIds), 0) = 0
						OR 					
						(
							ER.[IdAbility] IN (SELECT Value FROM [dbo].[split](@AbilityIds, ','))
							AND
							(
								/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
								/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
								(
									ER.[MaxAbilityScore] <> 0
									AND
									ER.[Qualification] = ER.[MaxAbilityScore]
								)
								OR
								(
									ER.[MaxAbilityScore] = 0
									AND
									ER.[AbilityInnerScore] = 100
								)
							)
						)
					)

	END
	ELSE
	BEGIN
		INSERT INTO #SEARCHED_INTERACTIONS
			SELECT DISTINCT ER.[IdAgent]															'AgentId',
							ER.[IdEvaluationPlan]													'EvaluationPlanId',
							ER.[IdInteraction]														'InteractionId' 
				FROM [dbo].[EvaluationResult] ER (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON ER.[Instance] = EP.[Instance]
						AND ER.[IdEvaluationPlan] = EP.[ID]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON EP.[Instance] = AEP.[Instance]
						AND EP.[ID] = AEP.[IdEvaluationPlan]
						AND (
							(
								EP.[Status] = 7 
								AND 
								EP.Evaluation_Mode = 'A'
							)
							OR
							(
								AEP.[Completed] = 1 
								AND 
								EP.Evaluation_Mode IN ('X','M')
							)
						)
						AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
						AND ER.[IdInteraction] = AEP.[IdInteraction]
						AND ER.[IdAgent] = AEP.[IdAgent]
						AND ER.[IdAuditor] = AEP.[IdAuditor]
						AND AEP.[Completed] = 1 
						AND AEP.[StatusDescription] NOT IN('INVALID') 

				WHERE ER.[Instance] = @VCC
					AND ER.[InteractionDatefin] BETWEEN @StartDate AND @EndDate
					AND ER.[IdEvaluationFormat] = @EvaluationFormatId
					AND (
						ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						OR					
						ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
						)
					
					AND (
						ISNULL(LEN(@AgentIds), 0) = 0
						OR
						ER.[IdAgent]  IN(SELECT Value FROM [dbo].[split](@AgentIds,','))
						)
			
					AND (
						ISNULL(LEN(@AbilityIds), 0) = 0
						OR 
						(
						ER.[IdAbility] IN (SELECT Value FROM [dbo].[split](@AbilityIds, ','))
					
						)
					)

	END


   
	-- GENERAMOS EL LISTADO DE INTERACCIONES A BUSCAR
	
	
	--SELECT * FROM #SEARCHED_INTERACTIONS
	-- OBTENEMOS TOTAL DE INTERACCIONES POR AGENTE	
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_TOTALBYAGENT
	SELECT [AgentId],COUNT([InteractionId]) 'Total' 
		INTO #SEARCHED_INTERACTIONS_TOTALBYAGENT
		FROM #SEARCHED_INTERACTIONS 
		GROUP BY [AgentId]
	
	--SELECT * FROM #SEARCHED_INTERACTIONS_TOTALBYAGENT
	
	--OBTENENEMOS SUMATORIA DE NOTAS POR AGENTE
	--PARA EL CASO DE MIXTAS LOS RESULTADOS SE MULTIPLICAN SEGUN EL NUMERO DE AUDITORES ES POR ELL QUE SE DEBE TOMAR 
	
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_NOTAS
	SELECT ER.[IdAgent]					'AgentId',
			ER.[IdEvaluationPlan]		'EvaluationPlanId',	
			ER.[IdInteraction]			'InteractionId', 
			SUM(Qualification)			'NotaTotal'
		INTO  #SEARCHED_INTERACTIONS_NOTAS
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			ON ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
				AND ER.[IdInteraction] = AEP.[IdInteraction]
				AND ER.[IdAgent] = AEP.[IdAgent]
				AND ER.[IdAuditor] = AEP.[IdAuditor]
				AND AEP.[Completed] = 1 
				AND AEP.[StatusDescription] NOT IN('INVALID')
		INNER JOIN #SEARCHED_INTERACTIONS SI
			ON ER.[IdAgent] =SI.[AgentId]
				AND ER.[IdEvaluationPlan] = SI.[EvaluationPlanId]
				AND  ER.[IdInteraction] = SI.[InteractionId]
		WHERE ER.[Instance] = @VCC
			AND ER.[IdEvaluationFormat] = @EvaluationFormatId
			AND (
				ISNULL(LEN(@EvaluationPlanIds), 0) = 0
				OR					
			    ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
			)
		GROUP BY ER.[IdAgent],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction]
					
				
	--SELECT * FROM #SEARCHED_INTERACTIONS_NOTAS
	-- OBTENEMOS EL PROMEDIO DE NOTAS POR AGENTE PARA OBTENER CUARILTES
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_NOTAS_PROM
    SELECT [AgentId], CAST(AVG([NotaTotal]) AS DECIMAL(7,1)) 'PromNotaTotal'
	INTO #SEARCHED_INTERACTIONS_NOTAS_PROM
	FROM #SEARCHED_INTERACTIONS_NOTAS
	GROUP BY [AgentId]			

	--SELECT * FROM #SEARCHED_INTERACTIONS_NOTAS_PROM

	--OBTENEMOS CUARTILES
	--OBTENEMOS CUARTILES DE ACUERDO A LOS PROMEDIOS DE NOTAS POR AGENTE
	DROP TABLE IF EXISTS #CUARTILES
	SELECT DISTINCT CAST([PromNotaTotal] AS DECIMAL(7,1)) 'PromNotaTotal'
	INTO #CUARTILES
	FROM #SEARCHED_INTERACTIONS_NOTAS_PROM

	DROP TABLE IF EXISTS #CUARTILES_ENUM
	SELECT ROW_NUMBER() OVER(ORDER BY [PromNotaTotal] DESC) 'lux',[PromNotaTotal] 
	INTO #CUARTILES_ENUM
	FROM #CUARTILES
    
	DECLARE @CUARTIL_EL INT
	SELECT @CUARTIL_EL = COUNT(*) FROM #CUARTILES_ENUM
	
	DROP TABLE IF EXISTS #CUARTILES_FINAL
	SELECT
    CAST(CE.[PromNotaTotal] AS DECIMAL(7,1)) 'PromNotaTotal',
    IIF (A.PromNotaTotal IS NOT NULL AND @CUARTIL_EL>=4 , 1,
        IIF (B.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 2, 
        IIF (C.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 3, 
        IIF (D.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 4, 1)))
    ) as quartile
	INTO #CUARTILES_FINAL
	FROM
    #CUARTILES_ENUM CE
    LEFT OUTER JOIN #CUARTILES_ENUM A on CE.PromNotaTotal = A.PromNotaTotal and A.lux > (SELECT COUNT(*)*0.00 FROM #CUARTILES_ENUM) and a.lux <= (SELECT COUNT(*)*0.25 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM B on CE.PromNotaTotal = B.PromNotaTotal and B.lux > (SELECT COUNT(*)*0.25 FROM #CUARTILES_ENUM) and b.lux <= (SELECT COUNT(*)*0.50 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM C on CE.PromNotaTotal = C.PromNotaTotal and C.lux > (SELECT COUNT(*)*0.50 FROM #CUARTILES_ENUM) and c.lux <= (SELECT COUNT(*)*0.75 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM D on CE.PromNotaTotal = D.PromNotaTotal and D.lux > (SELECT COUNT(*)*0.75 FROM #CUARTILES_ENUM)


	-- OBTENEMOS LOS TIEMPOS DE CADA AGENTE
	DROP TABLE IF EXISTS #AGENT_AUDIOS_TIME
	SELECT A.[Agent]								'AgentId',
			A.[AgentName]							'AgentName',
			AVG(A.[DurationLinguisticTime])			'AverageLinguisticTime',
			SUM(A.[DurationLinguisticTime])			'TotalLinguisticTime'
		INTO #AGENT_AUDIOS_TIME
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		INNER JOIN #SEARCHED_INTERACTIONS SI
			ON SI.[InteractionId] = IEP.[IdInteraction]
			AND SI.[EvaluationPlanId] = IEP.[IdEvaluationPlan]
		INNER JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IEP.[Instance]
				AND A.[ID] = IEP.[IdInteraction]
				AND A.[Section] = IEP.[InteractionSection]
				AND A.[Part] = IEP.[InteractionPart]
		WHERE IEP.[Instance] = @VCC
			AND (
			 ISNULL(LEN(@EvaluationPlanIds), 0) = 0
			 OR
			 IEP.[IdEvaluationPlan]  IN (SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

			)
			
		GROUP BY A.[Agent], 
					A.[AgentName]
	
	--SELECT * FROM  #AGENT_AUDIOS_TIME	
	
	-- OBTENEMOS LAS INTEARACCIONES QUE TUVIERON SENTIMIENTO POSITVO O NEGATIVO
	-- OBTENEMOS LAS INTEARACCIONES QUE TUVIERON SENTIMIENTO POSITVO O NEGATIVO
	SELECT DISTINCT SI.[AgentId],IEP.[IdEvaluationPlan],SR.[InteractionId] ,SR.[SentimentId]
		INTO #SEARCHED_INTERACTIONS_SENTIMENTS
		FROM [dbo].[SentimentAnalysisResult] SR (NOLOCK)
				INNER JOIN [dbo].[InteractionEvaluationPlan] IEP
					ON SR.[InteractionId] = IEP.[IdInteraction]
					AND SR.[InteractionSection] = IEP.[InteractionSection] 
					AND SR.[InteractionPart] = IEP.[InteractionPart]
					AND ISNULL(SR.[EndDate],'') = ISNULL(IEP.[InteractionDateEnd],'')
					AND IEP.[Instance] = @VCC					
					AND (
						 ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						 OR					
						 IEP.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
						 )
					 AND SR.[AnalysisType] = 'Client'
					 AND SR.[Score] > 0
					 AND SR.[MaxScore] = 1
					 AND SR.[SentimentId] IN ('Positive','Negative') 
				
					INNER JOIN 
					#SEARCHED_INTERACTIONS SI 
					ON 	SR.[InteractionId] = SI.[InteractionId]
						AND IEP.[IdEvaluationPlan] = SI.[EvaluationPlanId]
						AND IEP.[IdAgent] = SI.[AgentId]
			 WHERE SR.VCC = @VCC
				AND SR.[AnalysisType] = 'Client'
				AND SR.[Score] > 0
				AND SR.[SentimentId] IN ('Positive','Negative')

		--SELECT * FROM #SEARCHED_INTERACTIONS_SENTIMENTS
			





	-- OBTENEMOS TOTAL DE INTERACCIONES POR AGENTE 
	DROP TABLE IF EXISTS #TOTALINTERACTION_SR_BY_AGENT
	SELECT [AgentId], COUNT([InteractionId]) 'TotalSentiments'
	INTO #TOTALINTERACTION_SR_BY_AGENT
	FROM  #SEARCHED_INTERACTIONS_SENTIMENTS
	GROUP BY [AgentId]


	

	DROP TABLE IF EXISTS #SENTIMENT_RESULT
	SELECT SIR.[AgentId]												'AgentId', 
		SIR.[SentimentId]												'SentimentId',
		COUNT(SIR.[InteractionId])										'Matches' ,
		CAST ((COUNT(SIR.[InteractionId])*100
		/
		CONVERT(DECIMAL(10,2),SRA.TotalSentiments)) AS DECIMAL(7,1))		'MatchesPercentage',
		SRA.[TotalSentiments]											'TotalSentiments',
	    SRAT.[Total]													'Total'
		
		INTO #SENTIMENT_RESULT
		FROM #SEARCHED_INTERACTIONS_SENTIMENTS SIR 
		INNER JOIN  #TOTALINTERACTION_SR_BY_AGENT SRA
		ON SIR.[AgentId] = SRA.[AgentId]
		INNER JOIN #SEARCHED_INTERACTIONS_TOTALBYAGENT SRAT
		ON SRAT.[AgentId] = SIR.[AgentId]
			
		GROUP BY SIR.[AgentId], SIR.[SentimentId], SRA.[TotalSentiments],[Total]	
		
    

	-- OBTENEMOS LAS HABILIDADES PARA NOMBRAR LAS COLUMNAS
		DECLARE @HABILITY_COLUMNS VARCHAR(MAX)
		SET @HABILITY_COLUMNS = STUFF(
				(
					/*
					SELECT DISTINCT ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
						FROM #TempEvaluationResult
					*/
					SELECT DISTINCT ',' + QUOTENAME(HA.[Id])
						FROM [dbo].[HistoricAbility] HA (NOLOCK) 
						WHERE HA.[VCC] = @VCC
							AND
                            (
                                ISNULL(LEN(@EvaluationPlanIds), 0) = 0
                                OR
                                HA.[EvaluationPlanId]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

                            ) 
                            
						FOR xml PATH (''), TYPE
				).value('.', 'VARCHAR(MAX)'), 
				1, 
				1, 
				''
		)

		DECLARE @HABILITY_COLUMNS_ISNULL VARCHAR(MAX)
		SET @HABILITY_COLUMNS_ISNULL = STUFF(
				(
					/*
					SELECT DISTINCT ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
						FROM #TempEvaluationResult
					*/
					SELECT DISTINCT ',' +'ISNULL('+ QUOTENAME(HA.[Id]) +',0) AS' + QUOTENAME(HA.[Id]) + ' '
						FROM [dbo].[HistoricAbility] HA (NOLOCK) 
						WHERE HA.[VCC] = @VCC
							AND
                            (
                                ISNULL(LEN(@EvaluationPlanIds), 0) = 0
                                OR
                                HA.[EvaluationPlanId]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

                            ) 
                            
						FOR xml PATH (''), TYPE
				).value('.', 'VARCHAR(MAX)'), 
				1, 
				1, 
				''
		)
		DECLARE @SENTIMENT_COLUMNS VARCHAR(100)
		DECLARE @ALL_COLUMNS VARCHAR(MAX)
		DECLARE @ALL_COLUMNS_ISNULL VARCHAR(MAX)
		SET @SENTIMENT_COLUMNS =',[Positive],[Negative]'
		SET @ALL_COLUMNS =  @HABILITY_COLUMNS + @SENTIMENT_COLUMNS
		SET @HABILITY_COLUMNS_ISNULL = @HABILITY_COLUMNS_ISNULL  +',ISNULL([Positive],0) AS [Positive],ISNULL([Negative],0) AS [Negative]'

		

		



	-- GENERAMOS EL RESUMEN DE RESULTADOS POR HABILIDAD Y MATCH POSITIVO
	DROP TABLE IF EXISTS #RESULTS_SUMMARY
	SELECT ER.[IdAgent]																	'AgentId',
			ER.[IdAbility]																'AbilityId',
			HA.[Title]																	'AbilityTitle',
			/*
			COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))				'Matches',
			*/
			/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
			/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
			/*
			CASE WHEN ER.[MaxAbilityScore] <> 0
					THEN COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))	
					ELSE COUNT(IIF(ER.[AbilityInnerScore] = 100, 1, NULL))
				END																		'Matches',
			*/
			COUNT(
				CASE WHEN ER.[MaxAbilityScore] <> 0
						THEN IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)
						ELSE IIF(ER.[AbilityInnerScore] = 100, 1, NULL)
					END
			)																			'Matches',
			/*
			CAST(COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))*100
			/
			CONVERT(DECIMAL(4,2),SIT.Total) AS DECIMAL(7,1))							'MatchesPercentage',
			*/
			/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
			/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
			/*
			CASE WHEN ER.[MaxAbilityScore] <> 0
					THEN CAST(COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)) * 100
							/
							CONVERT(DECIMAL(4, 2), SIT.Total) AS DECIMAL(7, 1))
					ELSE CAST(COUNT(IIF(ER.[AbilityInnerScore] = 100, 1, NULL)) * 100
							/
							CONVERT(DECIMAL(4, 2), SIT.Total) AS DECIMAL(7, 1))
				END																		'MatchesPercentage',

			*/
			CAST(
				COUNT(
					CASE WHEN ER.[MaxAbilityScore] <> 0
							THEN IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)
							ELSE IIF(ER.[AbilityInnerScore] = 100, 1, NULL)
						END
				) 
				* 
				100 
				/ 
				CONVERT(DECIMAL(10, 2), SIT.Total) AS DECIMAL(7, 1)
			)																			'MatchesPercentage',
			SIT.Total																	'Total'
			
			
		INTO #RESULTS_SUMMARY
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			ON ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
				AND ER.[IdInteraction] = AEP.[IdInteraction]
				AND ER.[IdAgent] = AEP.[IdAgent]
				AND ER.[IdAuditor] = AEP.[IdAuditor]
				AND AEP.[Completed] = 1 
				AND AEP.[StatusDescription] NOT IN('INVALID')

		INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
			ON HA.[EvaluationPlanId] = ER.[IdEvaluationPlan]
				AND HA.[ID] = ER.[IdAbility]
		INNER JOIN #SEARCHED_INTERACTIONS SI 
			ON SI.[AgentId] = ER.[IdAgent]
				AND SI.[EvaluationPlanId] =ER.[IdEvaluationPlan]
				AND SI.[InteractionId] = ER.[IdInteraction]
       INNER JOIN #SEARCHED_INTERACTIONS_TOTALBYAGENT (NOLOCK) SIT 
		ON ER.[IdAgent] =SIT.[AgentId]			
		WHERE ER.[Instance] = @VCC
			AND (
				ISNULL(LEN(@EvaluationPlanIds), 0) = 0
				OR
				ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
			)
		GROUP BY ER.[IdAgent],
					ER.[IdAbility],
					HA.[Title],
					SIT.[Total]

	 UNION ALL
	 SELECT [AgentId],[SentimentId],[SentimentId],[Matches],[MatchesPercentage],[Total]
		    FROM #SENTIMENT_RESULT
	
	  --SELECT * FROM 	#RESULTS_SUMMARY
	 -- OBTENEMOS LAS COLUMANS DINAMICAS(HABILIDADES,SENTIMIENTOS) Y ESTATICAS(TOTAL, AGENTE) PARA EL GRID 
	-- OBTENEMOS LAS COLUMANS DINAMICAS(HABILIDADES,SENTIMIENTOS) Y ESTATICAS(TOTAL, AGENTE) PARA EL GRID 
	 SELECT 'HEADER_QUARTILE' 'headerName', 'quartile' 'field', 'quartile' 'customtype'	 
	 UNION ALL
	 SELECT 'HEADER_AGENT' 'headerName','AgentId' 'field', 'agent' 'customtype'
	 UNION ALL
	 SELECT 'HEADER_TOTAL_INTERACTIONS' 'headerName', 'TotalInteractions' 'field', 'totalInteractions' 'customtype'
	 UNION ALL
	 SELECT DISTINCT AbilityTitle 'headerName',AbilityId 'field', 
     CASE WHEN HA.IsNegative = 1 AND AC.ID IS NOT NULL  THEN 'negativeAbility' 
          WHEN HA.IsNegative = 0 AND AC.ID IS NOT NULL THEN  'positiveAbility'
          ELSE 'normalAbility' END  'customtype'
	 FROM #RESULTS_SUMMARY RS
		INNER JOIN HistoricAbility HA 
		ON RS.AbilityId = HA.ID 
        LEFT JOIN AbilityScoreCard AC 
        ON HA.ID = AC.ID
        AND AC.DegradeScoreCard = 1 
        

	 WHERE AbilityId NOT IN('Positive','Negative')
	 UNION ALL
	 SELECT 'HEADER_PROM_NOTA_TOTAL' 'headerName','PromNotaTotal' 'field', 'finalnote' 'customtype'
	 UNION ALL
	 SELECT DISTINCT AbilityId 'headerName',AbilityTitle 'field','sentiment' 'customtype' FROM #RESULTS_SUMMARY
	 WHERE AbilityId IN('Positive','Negative')
	 UNION ALL
	 SELECT 'TMO' 'headerName','TMO' 'field', 'TMO' 'customtype'



	 

	-- ARMAR DRILLDOWN PARA SETEAR UN NUEVO TOTAL A LA TABLA RESULTANTE
	-- REQUERIMOS LOS DATOS DE AGENTEID, DRILLDOWNTARGET= HABILIDAD O SENTIMIENTO, DRILLDOWNID=IDABILIDAD O IDSENTIMIENTO.
	DECLARE @QUERY VARCHAR(MAX)

      
		SET @QUERY  = '
        
		SELECT P.[AgentId],
				' + @ALL_COLUMNS + ',
				P.[Total],
				INNER_AAT.[AverageLinguisticTime],
				INNER_AAT.[TotalLinguisticTime]


			INTO #RESULT_SUMMARY_PIVOT
			FROM (
				SELECT [AgentId],
						[AbilityId],
						[MatchesPercentage],
						[Total]
					FROM #RESULTS_SUMMARY
			)
			X
			PIVOT (
				MAX([MatchesPercentage]) FOR [AbilityId] IN (' + @ALL_COLUMNS + ')
			) P
			
			LEFT JOIN #AGENT_AUDIOS_TIME INNER_AAT
				ON   INNER_AAT.[AgentId] = P.[AgentId]
                
			ORDER BY P.[Total] DESC ' + '

			
			
			SELECT	RSP.[AgentId],' + @HABILITY_COLUMNS_ISNULL+ ',					
					SIP.[PromNotaTotal],
					CF.[quartile] AS quartile,
					RSP.[Total] AS TotalInteractions,
					CAST (RSP.[AverageLinguisticTime] AS DECIMAL(7,1)) AS TMO
					
				
			
			FROM  #RESULT_SUMMARY_PIVOT RSP
			INNER JOIN #SEARCHED_INTERACTIONS_NOTAS_PROM SIP
                ON RSP.[AgentId] = SIP.[AgentId]
               
				
			INNER JOIN #CUARTILES_FINAL CF ON 
				CF.PromNotaTotal = SIP.PromNotaTotal

			ORDER BY SIP.[PromNotaTotal] DESC
			
	    '


	-- EJECUTAMOS EL QUERY ARMADO

	
	-- PRINT (@QUERY)
	EXECUTE (@QUERY)

	

	DROP TABLE IF EXISTS #AGENT_AUDIOS_TIME
	DROP TABLE IF EXISTS #RESULTS_SUMMARY
END



GO
PRINT N'Altering Procedure [dbo].[GetTeamPerformanceFilters]...';

GO
ALTER PROCEDURE [dbo].[GetTeamPerformanceFilters] (
	@VCC VARCHAR(50) = NULL,
	@BatchType VARCHAR(50) NULL,
	@EvaluationFormatId VARCHAR(50) NULL,
	@TemplateId VARCHAR(50) NULL

)
AS
BEGIN
	SET NOCOUNT ON
	-- OBTENEMOS LOS FORMATOS DE EVALUACION PARA EL VCC 	
	IF @BatchType = 'EVALUATION_PLAN'
	BEGIN
		SELECT '' 'id','' 'description'
		UNION ALL
		SELECT DISTINCT [ID]  'id', 
						[Description] 'description' 
			FROM [dbo].[HistoricEvaluationFormat]
			WHERE [VCC] =  @VCC 

		-- OBTENEMOS LOS PLANES COMPLETADOS
		SELECT DISTINCT EP.[ID]							'id',
						EP.[Description]				'description'
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				ON  EP.[Instance] = AEP.[Instance]
					AND	EP.[ID] = AEP.IdEvaluationPlan
			
			WHERE EP.[Instance] = @VCC
				/*
				AND (
						EP.[Status] = 7 AND EP.Evaluation_Mode = 'A'
						OR
						AEP.[Completed] = 1 AND EP.Evaluation_Mode IN ('X','M')
					)
				*/
				AND AEP.[Completed] = 1
				AND EP.[IdEvaluationFormat] = @EvaluationFormatId
				
		  		

	
		-- OBTENEMOS LOS AGENTES 
		SELECT DISTINCT ER.[IdAgent]							'id',
						ER.[AgentDescription]					'description'
			FROM [dbo].[EvaluationResult] ER (NOLOCK)
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
			INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				ON EP.[Instance] = AEP.[Instance]
					AND EP.[ID] = AEP.[IdEvaluationPlan]
			WHERE ER.[Instance] = @VCC
				AND (
						EP.[Status] = 7 AND EP.Evaluation_Mode = 'A'
						OR
						AEP.[Completed] = 1 AND EP.Evaluation_Mode IN ('X','M')
					)
				AND ER.[IdEvaluationFormat] = @EvaluationFormatId
		END
		ELSE
		BEGIN

		-- LISTAR TEMPLATES
			
		-- OBTENEMOS LOS ESTUDIOS COMPLETADOS
		SELECT DISTINCT S.[Name]						'id',
						S.[Name]						'name'
			FROM [dbo].[StudyResultSummaryDetail] SRSD (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK)
				ON S.[VCC] = SRSD.[VCC]
					AND S.[Name] = SRSD.[StudyId]
			WHERE S.[VCC] = @VCC
				AND S.[Type] = 'SPEECH'
				AND S.[Percentage] = 1
				AND S.[TemplateId] = @TemplateId

		END
	
	SET NOCOUNT OFF
END


GO
PRINT N'Altering Procedure [dbo].[GetStudyResultSummary]...';

GO
CREATE PROCEDURE [dbo].[GetStudyResultSummary]
(
	@VCC					VARCHAR(50),
	@StudyId				VARCHAR(200),
	@NewStructure			VARCHAR(1)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		SELECT
			B.[Name]						'processName',
			A.[Name]						'studyName',
			A.[Description]					'studyDescription',
			A.[TemplateId]					'templateId'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN Process B ON A.ProcessId = B.[Name]
		WHERE A.[VCC] = @VCC 
			AND A.[Name] = @StudyId
	END
	
	BEGIN
		SELECT SRS.[VCC]							'vcc',
				SRS.[StudyId]						'studyId',
				SRS.[TemplateId]					'templateId',
				SRS.[TemplateThemeId]				'templateThemeId',
				SRS.[ID]							'id',
				SRS.[Description]					'description',
				SRS.[Category1]						'category1',
				SRS.[Category2]						'category2',
				SRS.[Total]							'total',
				SRS.[Duration]						'duration',
				SRS.[Silence]						'silence',
				SRS.[Confidence]					'confidence',
				SRS.[CreatedDate]					'createdDate',
				SRS.[CreatedByUserId]				'createdByUserId',
				SRS.[LastModifiedDate]				'lastModifiedDate',
				SRS.[LastModifiedByUserId]			'lastModifiedByUserId'
			FROM [dbo].[StudyResultSummary] SRS (NOLOCK)
			WHERE SRS.[VCC] = @VCC 
				AND SRS.[StudyId] = @StudyId
	END

	IF(@NewStructure IS NULL)
	BEGIN

		-- CREAMOS UNA TEMPORAL PARA AUDIOS Y ASYNCINTERACTIONS
		CREATE TABLE #INNER_INTERACTION (
			[VCC] VARCHAR(50),
			[Channel] VARCHAR(50),
			[ID] VARCHAR(100),
			[Section] NUMERIC(5,0),
			[Part] NUMERIC(5,0), 
			[Campaign] VARCHAR(100),
			[Agent] VARCHAR(50),
			[IsTranscribed] BIT,
			[IsCancel] BIT,
			[Folder] VARCHAR(100),
			[TranscriptionId] VARCHAR(250),
			
		)

		-- INSERTAMOS LOS Audios 
		INSERT INTO #INNER_INTERACTION
				SELECT AU.[VCC],
					AU.[Channel], 
					AU.[ID], 
					AU.[Section], 
					AU.[Part], 
					AU.[Campaign], 
					AU.[agent], 
					AU.[IsTranscribed], 
					AU.[IsCancel],
					null as 'Folder',
					CONCAT(AU.[ID], '_', AU.[Section], '_', AU.[Part]) AS 'TranscriptionId'
				
				FROM [dbo].[Audio] AU (NOLOCK)
				INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK)
					ON AU.[VCC] = PA.[VCC]
					AND AU.[ID] = PA.[AudioId]
				INNER JOIN [dbo].[Study] ST (NOLOCK)
					ON PA.[ProcessId] = ST.[processId]
				WHERE 
				AU.[VCC] IN ('system', @VCC) AND
				ST.[Name] = @StudyId

		-- INSERTAMOS LOS AsyncInteraction 
		INSERT INTO #INNER_INTERACTION
				SELECT 
				AI.[VCC], 
				AI.[Channel], 
				AI.[ID], 
				null as 'Section',
				null as 'Part',
				AI.[Campaign], 
				AI.[FirstTakedAgent] AS 'Agent', 
				AI.[IsTranscribed], 
				AI.[IsCancel],
				AI.[Folder],
				CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_')) AS 'TranscriptionId'
			
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			INNER JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
				AND AI.[ID] = PAI.[InteractionId]
			INNER JOIN [dbo].[Study] ST (NOLOCK)
				ON ST.[processId] = PAI.[ProcessId]
			WHERE 
			AI.[VCC] IN ('system', @VCC) AND
			ST.[Name] = @StudyId		

		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			--ISNULL(D.[Query], A.[TemplateThemeItemId])			'query', -- Si es NULL se mostrara valor de TemplateThemeItem campo ID.
			ISNULL(ISNULL(D.[Query], E.[EntityName]),'')			'query', -- Si es NULL se mostrara valor de TemplateThemeItem campo ID.
			C.[Channel]											'interactionType',
			S.[ProcessId]										'processId',
			C.[ID]								                'transcriptionId',
			C.[Section]											'section',
			C.[Part]											'part',
			C.[Folder]											'folder',
			C.[Campaign]										'campaign',
			C.[Agent]		                                    'agent',
			C.[IsTranscribed]		                            'isTranscribed',
			C.[IsCancel]				                        'isCancel'
		FROM [dbo].[StudyResultSummaryDetail] A (NOLOCK)
		INNER JOIN [dbo].[Study] S (NOLOCK) 
			ON S.[VCC] = A.[VCC] 
				AND S.[Name] = A.[StudyId]
		INNER JOIN [dbo].[HistoricTemplateThemeItem] B (NOLOCK) 
			ON S.[TemplateId] = B.[TemplateId] 
				AND A.[TemplateThemeId] = B.[TemplateThemeId] 
				AND A.[TemplateThemeItemId] = B.[ID]
				AND B.[StudyId] = S.[Name]
			
		INNER JOIN [dbo].[#INNER_INTERACTION] C (NOLOCK)  -- (!)SE CAMBIO EL INNER POR LEFT PARA CONSIDER LAS TRANSCRIPCIONES DE CANALES ASINCRINOS
			ON A.[VCC] = C.[VCC]
				AND A.[TranscriptionId] = C.[TranscriptionId]
		LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON S.[VCC] = PA.[VCC] 
				AND S.[ProcessId] = PA.[ProcessId] 
				AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])

		--LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			-- ON A.[TranscriptionId] = CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_'))
		LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			ON PAI.[VCC] = S.[VCC]
				AND PAI.[ProcessId] = S.[ProcessId]
				AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = A.[TranscriptionId]

		LEFT JOIN [dbo].[GenericQuery] D (NOLOCK) 
			ON B.[VCC] = D.[VCC] 
				AND  B.[ID] = D.[Name] -- Se agrega LEFT JOIN para poder mostrar.

		LEFT JOIN [dbo].[TemplateThemeItemEntity] E 
			ON A.TemplateThemeId = E.TemplateThemeId
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId

		DROP TABLE #INNER_INTERACTION		
	END
	ELSE
	BEGIN
		-- ESTE BLOQUE NUNCA SE USA, EL UNICO LLAMADO DE LA FUNCION INSERTA DIRECTAMENTE NULL PARA LA VARIABLE @NewStructure
		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			D.[Query]											'query',
			ISNULL(C.[Channel], AI.[Channel])					'interactionType',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN A.[TranscriptionId] 
				ELSE AI.[ID] END								'transcriptionId',
			C.[Section]											'section',
			C.[Part]											'part',
			AI.[Folder]											'folder',
			AI.[Campaign]										'campaign',
			--ISNULL(C.[Agent], '')								'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[Agent], '') 
				ELSE ISNULL(AI.[FirstTakedAgent], '') END		'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsTranscribed], '') 
				ELSE ISNULL(AI.[IsTranscribed], '') END			'isTranscribed',
			CASE WHEN C.[Channel] IS NOT NULL
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsCancel], '') 
				ELSE ISNULL(AI.[IsCancel], '') END				'isCancel'
			
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[HistoricTemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
					AND B.[StudyId] = S.[Name]
			
			LEFT JOIN [dbo].[Audio] C (NOLOCK) 
				ON A.[VCC] = C.[VCC]
					AND A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
			
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON A.[TranscriptionId] = CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_'))
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = S.[VCC]
					AND PAI.[ProcessId] = S.[ProcessId]
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = A.[TranscriptionId]

			INNER JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name]
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	
	SET NOCOUNT OFF
END

